# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/BasicLaneConfiguration.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class BasicLaneConfiguration(genpy.Message):
  _md5sum = "363ecbd66c16487f3a22a191c6284deb"
  _type = "etsi_its_cam_ts_msgs/BasicLaneConfiguration"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# BasicLaneConfiguration::= SEQUENCE(SIZE(1..16,...)) OF BasicLaneInformation 
# ------------------------------------------------------------------------------
# * 
# * This DF provides information about the configuration of a road section in terms of lanes using a list of @ref LanePositionAndType .
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

BasicLaneInformation[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cam_ts_msgs/BasicLaneInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# BasicLaneInformation::= SEQUENCE{
#   laneNumber	         LanePosition,
#   direction		         Direction,
#   laneWidth		         LaneWidth OPTIONAL,
#   connectingLane         LanePosition OPTIONAL,
#   connectingRoadSection  RoadSectionId OPTIONAL,
#   ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF provides basic information about a single lane of a road segment.
# * It includes the following components: 
# * 
# * @field laneNumber: the number associated to the lane that provides a transversal identification. 
# * 
# * @field direction: the direction of traffic flow allowed on the lane. 
# * 
# * @field laneWidth: the optional width of the lane.
# *
# * @field connectingLane: the number of the connecting lane in the next road section, i.e. the number of the lane which the vehicle will use when travelling from one section to the next,
# * if it does not actively change lanes. If this component is absent, the lane name number remains the same in the next section.
# *
# * @field connectingRoadSection: the identifier of the next road section in direction of traffic, that is connecting to the current road section. 
# * If this component is absent, the connecting road section is the one following the instance where this DF is placed in the @ref RoadConfigurationSectionList.
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

LanePosition lane_number

Direction direction

LaneWidth lane_width
bool lane_width_is_present

LanePosition connecting_lane
bool connecting_lane_is_present

RoadSectionId connecting_road_section
bool connecting_road_section_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/LanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePosition ::= INTEGER {
#     offTheRoad           (-1), 
#     innerHardShoulder    (0), 
#     outerHardShoulder    (14) 
# } (-1..14)
# ------------------------------------------------------------------------------
# *
# * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
# *
# * For right-hand traffic roads, the value shall be set to:
# * - `-1` if the position is off, i.e. besides the road,
# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
# *
# * For left-hand traffic roads, the value shall be set to:
# * - `-1` if the position is off, i.e. besides the road,
# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
# *
# *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
# *
# * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
# * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
# * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
# *
# * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:
# * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the 
# *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.
# * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. 
# *   The remaining middle lane is assigned to both traffic directions as innermost lane.
# *
# * @category: Road topology information
# * @revision: Description of the legal separation of carriageways added in V2.2.1
#

int8 value
int8 MIN = -1
int8 MAX = 14
int8 OFF_THE_ROAD = -1
int8 INNER_HARD_SHOULDER = 0
int8 OUTER_HARD_SHOULDER = 14

================================================================================
MSG: etsi_its_cam_ts_msgs/Direction
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Direction::= INTEGER{
#     sameDirection     (0),
#     oppositeDirection (1),
#     bothDirections    (2),
#     unavailable       (3)
#  } (0..3)
# ------------------------------------------------------------------------------
# *
# * This DE indicates a direction with respect to a defined reference direction.
# * Example: a reference direction may be implicitly defined by the definition of a geographical zone.
# *
# * The value shall be set to:
# * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,
# * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,
# * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,
# * - 3 - `unavailable`       - to indicate that the information is unavailable.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 3
uint8 SAME_DIRECTION = 0
uint8 OPPOSITE_DIRECTION = 1
uint8 BOTH_DIRECTIONS = 2
uint8 UNAVAILABLE = 3

================================================================================
MSG: etsi_its_cam_ts_msgs/LaneWidth
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LaneWidth::= INTEGER (0..1023)
# ------------------------------------------------------------------------------
# *
# * This DE represents the width of a lane measured at a defined position.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 1022`) if the lane width information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `1022` if the lane width is out of range, i.e. greater than 10,21 m,
# * - `1023` if the lane width information is not available.
# *
# * The value 0 shall not be used.
# *
# * @unit: 0,01 metre
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 1023


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadSectionId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSectionId::= INTEGER (0..8, ...)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates an ordinal number that represents the position of a component in the list @ref RoadConfigurationSectionList. 
# *
# * The value shall be set to:
# * - `0`     - if no road section is identified
# * - `1..8`  - for instances 1..8 of @ref RoadConfigurationSectionList 
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

int64 value
int64 MIN = 0
int64 MAX = 8

"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 16

  __slots__ = ['array']
  _slot_types = ['etsi_its_cam_ts_msgs/BasicLaneInformation[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BasicLaneConfiguration, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.lane_number
        _x = _v1.value
        buff.write(_get_struct_b().pack(_x))
        _v2 = val1.direction
        _x = _v2.value
        buff.write(_get_struct_B().pack(_x))
        _v3 = val1.lane_width
        _x = _v3.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.lane_width_is_present
        buff.write(_get_struct_B().pack(_x))
        _v4 = val1.connecting_lane
        _x = _v4.value
        buff.write(_get_struct_b().pack(_x))
        _x = val1.connecting_lane_is_present
        buff.write(_get_struct_B().pack(_x))
        _v5 = val1.connecting_road_section
        _x = _v5.value
        buff.write(_get_struct_q().pack(_x))
        _x = val1.connecting_road_section_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.BasicLaneInformation()
        _v6 = val1.lane_number
        start = end
        end += 1
        (_v6.value,) = _get_struct_b().unpack(str[start:end])
        _v7 = val1.direction
        start = end
        end += 1
        (_v7.value,) = _get_struct_B().unpack(str[start:end])
        _v8 = val1.lane_width
        start = end
        end += 2
        (_v8.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.lane_width_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lane_width_is_present = bool(val1.lane_width_is_present)
        _v9 = val1.connecting_lane
        start = end
        end += 1
        (_v9.value,) = _get_struct_b().unpack(str[start:end])
        start = end
        end += 1
        (val1.connecting_lane_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.connecting_lane_is_present = bool(val1.connecting_lane_is_present)
        _v10 = val1.connecting_road_section
        start = end
        end += 8
        (_v10.value,) = _get_struct_q().unpack(str[start:end])
        start = end
        end += 1
        (val1.connecting_road_section_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.connecting_road_section_is_present = bool(val1.connecting_road_section_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v11 = val1.lane_number
        _x = _v11.value
        buff.write(_get_struct_b().pack(_x))
        _v12 = val1.direction
        _x = _v12.value
        buff.write(_get_struct_B().pack(_x))
        _v13 = val1.lane_width
        _x = _v13.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.lane_width_is_present
        buff.write(_get_struct_B().pack(_x))
        _v14 = val1.connecting_lane
        _x = _v14.value
        buff.write(_get_struct_b().pack(_x))
        _x = val1.connecting_lane_is_present
        buff.write(_get_struct_B().pack(_x))
        _v15 = val1.connecting_road_section
        _x = _v15.value
        buff.write(_get_struct_q().pack(_x))
        _x = val1.connecting_road_section_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.BasicLaneInformation()
        _v16 = val1.lane_number
        start = end
        end += 1
        (_v16.value,) = _get_struct_b().unpack(str[start:end])
        _v17 = val1.direction
        start = end
        end += 1
        (_v17.value,) = _get_struct_B().unpack(str[start:end])
        _v18 = val1.lane_width
        start = end
        end += 2
        (_v18.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.lane_width_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lane_width_is_present = bool(val1.lane_width_is_present)
        _v19 = val1.connecting_lane
        start = end
        end += 1
        (_v19.value,) = _get_struct_b().unpack(str[start:end])
        start = end
        end += 1
        (val1.connecting_lane_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.connecting_lane_is_present = bool(val1.connecting_lane_is_present)
        _v20 = val1.connecting_road_section
        start = end
        end += 8
        (_v20.value,) = _get_struct_q().unpack(str[start:end])
        start = end
        end += 1
        (val1.connecting_road_section_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.connecting_road_section_is_present = bool(val1.connecting_road_section_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
_struct_q = None
def _get_struct_q():
    global _struct_q
    if _struct_q is None:
        _struct_q = struct.Struct("<q")
    return _struct_q
