# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/BasicLaneInformation.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class BasicLaneInformation(genpy.Message):
  _md5sum = "a3c824f9cf830ebf337c01977a6535eb"
  _type = "etsi_its_cam_ts_msgs/BasicLaneInformation"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# BasicLaneInformation::= SEQUENCE{
#   laneNumber	         LanePosition,
#   direction		         Direction,
#   laneWidth		         LaneWidth OPTIONAL,
#   connectingLane         LanePosition OPTIONAL,
#   connectingRoadSection  RoadSectionId OPTIONAL,
#   ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF provides basic information about a single lane of a road segment.
# * It includes the following components: 
# * 
# * @field laneNumber: the number associated to the lane that provides a transversal identification. 
# * 
# * @field direction: the direction of traffic flow allowed on the lane. 
# * 
# * @field laneWidth: the optional width of the lane.
# *
# * @field connectingLane: the number of the connecting lane in the next road section, i.e. the number of the lane which the vehicle will use when travelling from one section to the next,
# * if it does not actively change lanes. If this component is absent, the lane name number remains the same in the next section.
# *
# * @field connectingRoadSection: the identifier of the next road section in direction of traffic, that is connecting to the current road section. 
# * If this component is absent, the connecting road section is the one following the instance where this DF is placed in the @ref RoadConfigurationSectionList.
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

LanePosition lane_number

Direction direction

LaneWidth lane_width
bool lane_width_is_present

LanePosition connecting_lane
bool connecting_lane_is_present

RoadSectionId connecting_road_section
bool connecting_road_section_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/LanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePosition ::= INTEGER {
#     offTheRoad           (-1), 
#     innerHardShoulder    (0), 
#     outerHardShoulder    (14) 
# } (-1..14)
# ------------------------------------------------------------------------------
# *
# * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
# *
# * For right-hand traffic roads, the value shall be set to:
# * - `-1` if the position is off, i.e. besides the road,
# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
# *
# * For left-hand traffic roads, the value shall be set to:
# * - `-1` if the position is off, i.e. besides the road,
# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
# *
# *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
# *
# * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
# * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
# * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
# *
# * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:
# * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the 
# *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.
# * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. 
# *   The remaining middle lane is assigned to both traffic directions as innermost lane.
# *
# * @category: Road topology information
# * @revision: Description of the legal separation of carriageways added in V2.2.1
#

int8 value
int8 MIN = -1
int8 MAX = 14
int8 OFF_THE_ROAD = -1
int8 INNER_HARD_SHOULDER = 0
int8 OUTER_HARD_SHOULDER = 14

================================================================================
MSG: etsi_its_cam_ts_msgs/Direction
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Direction::= INTEGER{
#     sameDirection     (0),
#     oppositeDirection (1),
#     bothDirections    (2),
#     unavailable       (3)
#  } (0..3)
# ------------------------------------------------------------------------------
# *
# * This DE indicates a direction with respect to a defined reference direction.
# * Example: a reference direction may be implicitly defined by the definition of a geographical zone.
# *
# * The value shall be set to:
# * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,
# * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,
# * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,
# * - 3 - `unavailable`       - to indicate that the information is unavailable.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 3
uint8 SAME_DIRECTION = 0
uint8 OPPOSITE_DIRECTION = 1
uint8 BOTH_DIRECTIONS = 2
uint8 UNAVAILABLE = 3

================================================================================
MSG: etsi_its_cam_ts_msgs/LaneWidth
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LaneWidth::= INTEGER (0..1023)
# ------------------------------------------------------------------------------
# *
# * This DE represents the width of a lane measured at a defined position.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 1022`) if the lane width information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `1022` if the lane width is out of range, i.e. greater than 10,21 m,
# * - `1023` if the lane width information is not available.
# *
# * The value 0 shall not be used.
# *
# * @unit: 0,01 metre
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 1023


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadSectionId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSectionId::= INTEGER (0..8, ...)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates an ordinal number that represents the position of a component in the list @ref RoadConfigurationSectionList. 
# *
# * The value shall be set to:
# * - `0`     - if no road section is identified
# * - `1..8`  - for instances 1..8 of @ref RoadConfigurationSectionList 
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

int64 value
int64 MIN = 0
int64 MAX = 8

"""
  __slots__ = ['lane_number','direction','lane_width','lane_width_is_present','connecting_lane','connecting_lane_is_present','connecting_road_section','connecting_road_section_is_present']
  _slot_types = ['etsi_its_cam_ts_msgs/LanePosition','etsi_its_cam_ts_msgs/Direction','etsi_its_cam_ts_msgs/LaneWidth','bool','etsi_its_cam_ts_msgs/LanePosition','bool','etsi_its_cam_ts_msgs/RoadSectionId','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       lane_number,direction,lane_width,lane_width_is_present,connecting_lane,connecting_lane_is_present,connecting_road_section,connecting_road_section_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BasicLaneInformation, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.lane_number is None:
        self.lane_number = etsi_its_cam_ts_msgs.msg.LanePosition()
      if self.direction is None:
        self.direction = etsi_its_cam_ts_msgs.msg.Direction()
      if self.lane_width is None:
        self.lane_width = etsi_its_cam_ts_msgs.msg.LaneWidth()
      if self.lane_width_is_present is None:
        self.lane_width_is_present = False
      if self.connecting_lane is None:
        self.connecting_lane = etsi_its_cam_ts_msgs.msg.LanePosition()
      if self.connecting_lane_is_present is None:
        self.connecting_lane_is_present = False
      if self.connecting_road_section is None:
        self.connecting_road_section = etsi_its_cam_ts_msgs.msg.RoadSectionId()
      if self.connecting_road_section_is_present is None:
        self.connecting_road_section_is_present = False
    else:
      self.lane_number = etsi_its_cam_ts_msgs.msg.LanePosition()
      self.direction = etsi_its_cam_ts_msgs.msg.Direction()
      self.lane_width = etsi_its_cam_ts_msgs.msg.LaneWidth()
      self.lane_width_is_present = False
      self.connecting_lane = etsi_its_cam_ts_msgs.msg.LanePosition()
      self.connecting_lane_is_present = False
      self.connecting_road_section = etsi_its_cam_ts_msgs.msg.RoadSectionId()
      self.connecting_road_section_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_bBHBbBqB().pack(_x.lane_number.value, _x.direction.value, _x.lane_width.value, _x.lane_width_is_present, _x.connecting_lane.value, _x.connecting_lane_is_present, _x.connecting_road_section.value, _x.connecting_road_section_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.lane_number is None:
        self.lane_number = etsi_its_cam_ts_msgs.msg.LanePosition()
      if self.direction is None:
        self.direction = etsi_its_cam_ts_msgs.msg.Direction()
      if self.lane_width is None:
        self.lane_width = etsi_its_cam_ts_msgs.msg.LaneWidth()
      if self.connecting_lane is None:
        self.connecting_lane = etsi_its_cam_ts_msgs.msg.LanePosition()
      if self.connecting_road_section is None:
        self.connecting_road_section = etsi_its_cam_ts_msgs.msg.RoadSectionId()
      end = 0
      _x = self
      start = end
      end += 16
      (_x.lane_number.value, _x.direction.value, _x.lane_width.value, _x.lane_width_is_present, _x.connecting_lane.value, _x.connecting_lane_is_present, _x.connecting_road_section.value, _x.connecting_road_section_is_present,) = _get_struct_bBHBbBqB().unpack(str[start:end])
      self.lane_width_is_present = bool(self.lane_width_is_present)
      self.connecting_lane_is_present = bool(self.connecting_lane_is_present)
      self.connecting_road_section_is_present = bool(self.connecting_road_section_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_bBHBbBqB().pack(_x.lane_number.value, _x.direction.value, _x.lane_width.value, _x.lane_width_is_present, _x.connecting_lane.value, _x.connecting_lane_is_present, _x.connecting_road_section.value, _x.connecting_road_section_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.lane_number is None:
        self.lane_number = etsi_its_cam_ts_msgs.msg.LanePosition()
      if self.direction is None:
        self.direction = etsi_its_cam_ts_msgs.msg.Direction()
      if self.lane_width is None:
        self.lane_width = etsi_its_cam_ts_msgs.msg.LaneWidth()
      if self.connecting_lane is None:
        self.connecting_lane = etsi_its_cam_ts_msgs.msg.LanePosition()
      if self.connecting_road_section is None:
        self.connecting_road_section = etsi_its_cam_ts_msgs.msg.RoadSectionId()
      end = 0
      _x = self
      start = end
      end += 16
      (_x.lane_number.value, _x.direction.value, _x.lane_width.value, _x.lane_width_is_present, _x.connecting_lane.value, _x.connecting_lane_is_present, _x.connecting_road_section.value, _x.connecting_road_section_is_present,) = _get_struct_bBHBbBqB().unpack(str[start:end])
      self.lane_width_is_present = bool(self.lane_width_is_present)
      self.connecting_lane_is_present = bool(self.connecting_lane_is_present)
      self.connecting_road_section_is_present = bool(self.connecting_road_section_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_bBHBbBqB = None
def _get_struct_bBHBbBqB():
    global _struct_bBHBbBqB
    if _struct_bBHBbBqB is None:
        _struct_bBHBbBqB = struct.Struct("<bBHBbBqB")
    return _struct_bBHBbBqB
