# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/GeneralizedLanePositions.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class GeneralizedLanePositions(genpy.Message):
  _md5sum = "6cdb68db485cb9c95cb5381bd496120d"
  _type = "etsi_its_cam_ts_msgs/GeneralizedLanePositions"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# GeneralizedLanePositions ::= SEQUENCE (SIZE(1..4)) OF GeneralizedLanePosition
# ------------------------------------------------------------------------------
# *
# * This DF represents transversal position information with respect to the road, at an externally defined reference position. It shall contain a set of up to `4` @ref GeneralizedLanePosition.
# * Multiple entries can be used to describe several lane positions with the associated confidence, in cases where the reference position cannot be mapped to a single lane.
# *
# * @category: Road Topology information
# * @revision: Created in V2.2.1
# 

GeneralizedLanePosition[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 4

================================================================================
MSG: etsi_its_cam_ts_msgs/GeneralizedLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# GeneralizedLanePosition ::= SEQUENCE {
#     lanePositionBased     LanePositionOptions,
#     mapBased              MapPosition OPTIONAL,
#     confidence            MetaInformation,
#     ... 
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents the top-level DF to represent a lane position. A lane position is a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway.
# *
# * @note: This DF is the most general way to represent a lane position: it provides a complete set of information regarding a transversal (dimensionless) position on the carriageway at a specific 
# * reference position, i.e. it provides different options and synonyms to represent the lane at which the reference position (the point) is located. A confidence is used to describe the probability 
# * that the object is located in the provided lane. The dimension of the object or extension of an area are not considered: See @ref OccupiedLanesWithConfidence for describing the occupation of lanes, 
# * where the dimensions of an object or the extension of an area is considered.
# *
# * It shall include the following components: 
# *
# * @field lanePositionBased: lane position information for a defined reference position.
# * 
# * @field mapBased: optional lane position information described in the context of a MAPEM as specified in ETSI TS 103 301 [15]. 
# * If present, it shall describe the same reference position using the lane identification in the MAPEM. This component can be used only if a MAPEM is available for the reference position 
# * (e.g. on an intersection): In this case it is used as a synonym to the mandatory component lanePositionBased. 
# * 
# * @field confidence: confidence information for expressing the probability that the object is located at the indicated lane.  
# * If the value of the component lanePositionBased is generated directly from the absolute reference position and reference topology information, 
# * no sensor shall be indicated in the component usedDetectionInformation of the @ref MetaInformation.
# *
# * @category: Road Topology information
# * @revision: newly created in V2.2.1. The previous DF GeneralizedLanePosition is now renamed to @ref LanePositionOptions. 
# 

LanePositionOptions lane_position_based

MapPosition map_based
bool map_based_is_present

MetaInformation confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/LanePositionOptions
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePositionOptions ::= CHOICE {
#     simplelanePosition                   LanePosition,
#     simpleLaneType                       LaneType,
#     detailedlanePosition                 LanePositionAndType,
#     lanePositionWithLateralDetails       LanePositionWithLateralDetails,
#     trafficIslandPosition                TrafficIslandPosition,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a set of options to describe a lane position and is the second level DF to represent a lane position. The top-level DFs are @ref GeneralizedLanePosition or @ref OccupiedLanesWithConfidence. 
# * A lane position is a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway.
# *
# * The following options are available:
# *
# * @field simplelanePosition: a single lane position without any additional context information.
# *
# * @field simpleLaneType: a lane type, to be used when the lane position is unknown but the type of lane is known. This can be used in scenarios where a certain confidence about the used lane type is given 
# * but no or limited knowledge about the absolute lane number is available. For example, a cyclist on a cycle-lane or vehicles on a specific lane that is unique for the part of the road (e.g. a bus lane).
# * 
# * @field detailedlanePosition: a single lane position with additional lane details.
# * 
# * @field lanePositionWithLateralDetails: a single lane position with additional details and the lateral position within the lane.
# *
# * @field trafficIslandPosition: a position on a traffic island, i.e. between two lanes. 
# *
# * @category: Road Topology information
# * @revision: Created in V2.2.1 from the DF GeneralizedLanePosition of V2.1.1. 
# 

uint8 choice

LanePosition simplelane_position
uint8 CHOICE_SIMPLELANE_POSITION = 0

LaneType simple_lane_type
uint8 CHOICE_SIMPLE_LANE_TYPE = 1

LanePositionAndType detailedlane_position
uint8 CHOICE_DETAILEDLANE_POSITION = 2

LanePositionWithLateralDetails lane_position_with_lateral_details
uint8 CHOICE_LANE_POSITION_WITH_LATERAL_DETAILS = 3

TrafficIslandPosition traffic_island_position
uint8 CHOICE_TRAFFIC_ISLAND_POSITION = 4


================================================================================
MSG: etsi_its_cam_ts_msgs/LanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePosition ::= INTEGER {
#     offTheRoad           (-1), 
#     innerHardShoulder    (0), 
#     outerHardShoulder    (14) 
# } (-1..14)
# ------------------------------------------------------------------------------
# *
# * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
# *
# * For right-hand traffic roads, the value shall be set to:
# * - `-1` if the position is off, i.e. besides the road,
# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
# *
# * For left-hand traffic roads, the value shall be set to:
# * - `-1` if the position is off, i.e. besides the road,
# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
# *
# *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
# *
# * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
# * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
# * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
# *
# * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:
# * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the 
# *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.
# * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. 
# *   The remaining middle lane is assigned to both traffic directions as innermost lane.
# *
# * @category: Road topology information
# * @revision: Description of the legal separation of carriageways added in V2.2.1
#

int8 value
int8 MIN = -1
int8 MAX = 14
int8 OFF_THE_ROAD = -1
int8 INNER_HARD_SHOULDER = 0
int8 OUTER_HARD_SHOULDER = 14

================================================================================
MSG: etsi_its_cam_ts_msgs/LaneType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LaneType::= INTEGER{
# 	traffic              (0),
# 	through	             (1),
# 	reversible           (2),
# 	acceleration         (3),
# 	deceleration         (4),
# 	leftHandTurning      (5),
# 	rightHandTurning     (6),
# 	dedicatedVehicle     (7),
# 	bus                  (8),
# 	taxi                 (9),
# 	hov                  (10),
# 	hot                  (11),
# 	pedestrian           (12),
# 	cycleLane            (13),
# 	median               (14),   
# 	striping             (15),
# 	trackedVehicle       (16),
# 	parking	             (17),
# 	emergency            (18),
# 	verge                (19),
# 	minimumRiskManoeuvre (20),
#     exclusiveCycleLane   (21),
# 	unknown              (31)
# }(0..31)
# ------------------------------------------------------------------------------
# *
# * This DE represents the type of a lane. 
# * 
# * The value shall be set to:
# * - 0	- `traffic`            - Lane dedicated to the movement of vehicles,
# * - 1	- `through`            - Lane dedicated to the movement of vehicles travelling ahead and not turning,
# * - 2	- `reversible`         - Lane where the direction of traffic can be changed to match the peak flow,
# * - 3	- `acceleration`	   - Lane that allows vehicles entering a road to accelerate to the speed of through traffic before merging with it,
# * - 4	- `deceleration`       - Lane that allows vehicles exiting a road to decelerate before leaving it,
# * - 5	- `leftHandTurning`    - Lane reserved for slowing down and making a left turn, so as not to disrupt traffic,
# * - 6	- `rightHandTurning`   - Lane reserved for slowing down and making a right turn so as not to disrupt traffic,
# * - 7	- `dedicatedVehicle`   - Lane dedicated to movement of motor vehicles with specific characteristics, such as heavy goods vehicles, etc., 
# * - 8	- `bus`                - Lane dedicated to movement of buses providing public transport,
# * - 9	- `taxi`               - Lane dedicated to movement of taxis,
# * - 10	- `hov`                - Carpooling lane or high occupancy vehicle lane,
# * - 11	- `hot`                - High occupancy vehicle lanes that is allowed to be used without meeting the occupancy criteria by paying a toll,
# * - 12	- `pedestrian`         - Lanes dedicated to pedestrians such as pedestrian sidewalk paths,
# * - 13	- `cycleLane`	       - Lane dedicated to exclusive or preferred use by bicycles,
# * - 14	- `median`             - Lane not dedicated to movement of vehicles but representing a median / central reservation  such as the central median, 
#                                 separating the two directional carriageways of the highway,
# * - 15	- `striping`	       - Lane not dedicated to movement of vehicles but covered with roadway markings,
# * - 16	- `trackedVehicle`     - Lane dedicated to movement of trains, trams and trolleys,
# * - 17	- `parking`            - Lanes dedicated to vehicles parking, stopping and loading lanes,
# * - 18	- `emergency`          - Lane dedicated to vehicles in breakdown or to emergency vehicles also called hard shoulder,
# * - 19	- `verge`              - Lane representing the verge, i.e. a narrow strip of grass or plants and sometimes also trees located between 
#                                 the road surface edge and the boundary of a road,
# * - 20	`minimumRiskManoeuvre` - Lane dedicated to automated vehicles making a minimum risk manoeuvre,
# * - 21	`separatedCycleLane`   - Lane dedicated to exclusive or preferred use by bicycles that is phyisically separated from the vehicle-traffic lanes, e.g. by a verge.
# * - values 22 to 30             reserved for future use. 
# *
# * @category: Road topology information
# * @revision: Created in V2.1.1, named value 21 added in V2.2.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 31
uint8 TRAFFIC = 0
uint8 THROUGH = 1
uint8 REVERSIBLE = 2
uint8 ACCELERATION = 3
uint8 DECELERATION = 4
uint8 LEFT_HAND_TURNING = 5
uint8 RIGHT_HAND_TURNING = 6
uint8 DEDICATED_VEHICLE = 7
uint8 BUS = 8
uint8 TAXI = 9
uint8 HOV = 10
uint8 HOT = 11
uint8 PEDESTRIAN = 12
uint8 CYCLE_LANE = 13
uint8 MEDIAN = 14
uint8 STRIPING = 15
uint8 TRACKED_VEHICLE = 16
uint8 PARKING = 17
uint8 EMERGENCY = 18
uint8 VERGE = 19
uint8 MINIMUM_RISK_MANOEUVRE = 20
uint8 EXCLUSIVE_CYCLE_LANE = 21
uint8 UNKNOWN = 31

================================================================================
MSG: etsi_its_cam_ts_msgs/LanePositionAndType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePositionAndType::= SEQUENCE {
#     transversalPosition    LanePosition,
#     laneType               LaneType DEFAULT traffic,
#     direction              Direction DEFAULT sameDirection,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates a transversal position in resolution of lanes and other associated details.
# *
# * It shall include the following components: 
# * 
# * @field transversalPosition: the transversal position.
# * 
# * @field laneType: the type of the lane identified in the component transversalPosition. By default set to `traffic`.
# *
# * @field direction: the traffic direction for the lane position relative to a defined reference direction. By default set to `sameDirection`, i.e. following the reference direction.
# *
# * @category Road topology information
# * @revision: direction added in V2.2.1
# 

LanePosition transversal_position

LaneType lane_type

Direction direction


uint8 LANE_TYPE_DEFAULT = 0
uint8 DIRECTION_DEFAULT = 0

================================================================================
MSG: etsi_its_cam_ts_msgs/Direction
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Direction::= INTEGER{
#     sameDirection     (0),
#     oppositeDirection (1),
#     bothDirections    (2),
#     unavailable       (3)
#  } (0..3)
# ------------------------------------------------------------------------------
# *
# * This DE indicates a direction with respect to a defined reference direction.
# * Example: a reference direction may be implicitly defined by the definition of a geographical zone.
# *
# * The value shall be set to:
# * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,
# * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,
# * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,
# * - 3 - `unavailable`       - to indicate that the information is unavailable.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 3
uint8 SAME_DIRECTION = 0
uint8 OPPOSITE_DIRECTION = 1
uint8 BOTH_DIRECTIONS = 2
uint8 UNAVAILABLE = 3

================================================================================
MSG: etsi_its_cam_ts_msgs/LanePositionWithLateralDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePositionWithLateralDetails ::= SEQUENCE {
#     COMPONENTS OF               LanePositionAndType,
#     distanceToLeftBorder        StandardLength9b,
#     distanceToRightBorder       StandardLength9b,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF is a third-level DF that represents a lane position and is an extended version of @ref LanePositionAndType that adds the distances to the left and right lane border.
# *
# * It shall additionally include the following components: 
# *
# * @field distanceToLeftBorder: the distance of the transversal position to the left lane border. The real value shall be rounded to the next lower encoding-value.
# *
# * @field distanceToRightBorder: the distance of the transversal position to the right lane border. The real value shall be rounded to the next lower encoding-value.
# * 
# * @category: Road Topology information
# * @revision: Created in V2.2.1
# 

StandardLength9b distance_to_left_border

StandardLength9b distance_to_right_border

LanePosition transversal_position

LaneType lane_type

Direction direction


uint8 LANE_TYPE_DEFAULT = 0
uint8 DIRECTION_DEFAULT = 0

================================================================================
MSG: etsi_its_cam_ts_msgs/StandardLength9b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength9b::= INTEGER (0..511)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 511


================================================================================
MSG: etsi_its_cam_ts_msgs/TrafficIslandPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrafficIslandPosition ::= SEQUENCE {
#     oneSide      LanePositionAndType,
#     otherSide    LanePositionAndType,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * Ths DF represents the a position on a traffic island between two lanes. 
# *
# * It shall include the following components: 
# *
# * @field oneSide: represents one lane.
# * 
# * @field otherSide: represents the other lane.
# * 
# * @category: Road Topology information
# * @revision: Created in V2.1.1
# 

LanePositionAndType one_side

LanePositionAndType other_side


================================================================================
MSG: etsi_its_cam_ts_msgs/MapPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapPosition ::= SEQUENCE {
#     mapReference                MapReference OPTIONAL,
#     laneId                      Identifier1B OPTIONAL,
#     connectionId                Identifier1B OPTIONAL, 
#     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# * 
# * @field mapReference: optionally identifies the MAPEM containing the topology information.
# * It is absent if the MAPEM topology is known from the context.
# * 
# * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
# *
# * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
# * conflict area of an intersection which connects e.g an ingress with an egress lane.
# *
# * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection measured from the start of the lane/connection, along the lane.
# * 
# * @category: Road topology information
# * @revision: Created in V2.1.1, definition of longitudinalLanePosition amended in V2.2.1
# 

MapReference map_reference
bool map_reference_is_present

Identifier1B lane_id
bool lane_id_is_present

Identifier1B connection_id
bool connection_id_is_present

LongitudinalLanePosition longitudinal_lane_position
bool longitudinal_lane_position_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
# *
# * The following options are provided:
# * 
# * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
# * 
# * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
# *
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for a road segment
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the road segment.
# *
# * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cam_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cam_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the intersection
# *
# * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cam_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cam_ts_msgs/LongitudinalLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePosition ::= SEQUENCE {
#     longitudinalLanePositionValue         LongitudinalLanePositionValue,
#     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the estimated position along the longitudinal extension of a carriageway or lane. 
# *
# * It shall include the following components: 
# *
# * @field  longitudinalLanePositionValue: the mean value of the longitudinal position along the carriageway or lane w.r.t. an externally defined start position.
# *
# * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
# *
# * @category: Road topology information
# * @revision: created in V2.1.1, description revised in V2.2.1
# 

LongitudinalLanePositionValue longitudinal_lane_position_value

LongitudinalLanePositionConfidence longitudinal_lane_position_confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/LongitudinalLanePositionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePositionValue ::= INTEGER {
#     outOfRange(32766),
#     unavailable(32767)
# }(0..32767)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
# * 
# * The value shall be set to:
# * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
# * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
# * - `32 767` if the longitudinal offset information is not available. 
# *
# * @unit 0,1 metre
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 32767
uint16 OUT_OF_RANGE = 32766
uint16 UNAVAILABLE = 32767

================================================================================
MSG: etsi_its_cam_ts_msgs/LongitudinalLanePositionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePositionConfidence ::= INTEGER {
#     outOfRange  (1022),
#     unavailable (1023)  
# } (0..1023)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
# * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
# * - `1 023` if the confidence value is unavailable.
# *
# * @unit 0,1 metre
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023

================================================================================
MSG: etsi_its_cam_ts_msgs/MetaInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MetaInformation::=SEQUENCE{		
#   usedDetectionInformation   SensorTypes, 
#   usedStoredInformation      StoredInformationType,
#   confidenceValue            ConfidenceLevel OPTIONAL,
#   ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF provides information about the source of and confidence in information.
# *
# * It shall include the following components: 
# * 
# * @field usedDetectionInformation: the type of sensor(s) that is used to provide the detection information.
# * 
# * @field usedStoredInformation: the type of source of the stored information. 
# *
# * @field confidenceValue: an optional confidence value associated to the information. 
# * 
# * @category: Basic information
# * @revision: Created in V2.2.1
#

SensorTypes used_detection_information

StoredInformationType used_stored_information

ConfidenceLevel confidence_value
bool confidence_value_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/SensorTypes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorTypes ::= BIT STRING {
#     undefined         (0),
#     radar             (1),
#     lidar             (2),
#     monovideo         (3),
#     stereovision      (4),
#     nightvision       (5),
#     ultrasonic        (6),
#     pmd               (7),
#     inductionLoop     (8),
#     sphericalCamera   (9),
#     uwb               (10),
#     acoustic          (11),
#     localAggregation  (12),
#     itsAggregation    (13)
# } (SIZE (16,... ))
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of sensor(s).
# * The corresponding bit shall be set to 1 under the following conditions:
# * 
# * - 0  `undefined`         - in case the sensor type is undefined. 
# * - 1  `radar`             - in case the sensor is a radar,
# * - 2  `lidar`             - in case the sensor is a lidar,
# * - 3  `monovideo`         - in case the sensor is mono video,
# * - 4  `stereovision`      - in case the sensor is stereo vision,
# * - 5  `nightvision`       - in case the sensor is night vision,
# * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
# * - 7  `pmd`               - in case the sensor is photonic mixing device,
# * - 8  `inductionLoop`     - in case the sensor is an induction loop,
# * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
# * - 10 `uwb`               - in case the sensor is ultra wide band,
# * - 11 `acoustic`          - in case the sensor is acoustic,
# * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
# * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
# * - 14-15                  - are reserved for future usage.
# * 
# * @note: If all bits are set to 0, then no sensor type is used
# *
# * @category: Sensing Information
# * @revision: created in V2.2.1
#

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 16
int64 MAX_SIZE_BITS = 16
uint8 BIT_INDEX_UNDEFINED = 0
uint8 BIT_INDEX_RADAR = 1
uint8 BIT_INDEX_LIDAR = 2
uint8 BIT_INDEX_MONOVIDEO = 3
uint8 BIT_INDEX_STEREOVISION = 4
uint8 BIT_INDEX_NIGHTVISION = 5
uint8 BIT_INDEX_ULTRASONIC = 6
uint8 BIT_INDEX_PMD = 7
uint8 BIT_INDEX_INDUCTION_LOOP = 8
uint8 BIT_INDEX_SPHERICAL_CAMERA = 9
uint8 BIT_INDEX_UWB = 10
uint8 BIT_INDEX_ACOUSTIC = 11
uint8 BIT_INDEX_LOCAL_AGGREGATION = 12
uint8 BIT_INDEX_ITS_AGGREGATION = 13

================================================================================
MSG: etsi_its_cam_ts_msgs/StoredInformationType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StoredInformationType::= BIT STRING {
#     undefined       (0),
#     staticDb	    (1),    
#     dynamicDb   	(2),
#     realTimeDb  	(3),
#     map		    	(4)	
# } (SIZE (8,... )) 
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of stored information.
# *
# * The corresponding bit shall be set to 1 under the following conditions:
# * 
# * - `0` undefined        - in case the stored information type is undefined. 
# * - `1` staticDb         - in case the stored information type is a static database.
# * - `2` dynamicDb        - in case the stored information type is a dynamic database
# * - `3` realTimeDb       - in case the stored information type is a real time updated database.
# * - `4` map              - in case the stored information type is a road topology map.
# * - Bits 5 to 7          - are reserved for future use.
# *
# * @note: If all bits are set to 0, then no stored information type is used
# *
# * @category: Basic Information
# * @revision: created in V2.2.1
#

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 8
int64 MAX_SIZE_BITS = 8
uint8 BIT_INDEX_UNDEFINED = 0
uint8 BIT_INDEX_STATIC_DB = 1
uint8 BIT_INDEX_DYNAMIC_DB = 2
uint8 BIT_INDEX_REAL_TIME_DB = 3
uint8 BIT_INDEX_MAP = 4

================================================================================
MSG: etsi_its_cam_ts_msgs/ConfidenceLevel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ConfidenceLevel ::= INTEGER {
#     unavailable (101)  
# } (1..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a confidence level in percentage.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
# * - `101`                   : in case the confidence level is not available.
# *
# * @unit Percent 
# * @category: Basic information 
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 101
uint8 UNAVAILABLE = 101
"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 4

  __slots__ = ['array']
  _slot_types = ['etsi_its_cam_ts_msgs/GeneralizedLanePosition[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GeneralizedLanePositions, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.lane_position_based
        _x = _v1.choice
        buff.write(_get_struct_B().pack(_x))
        _v2 = _v1.simplelane_position
        _x = _v2.value
        buff.write(_get_struct_b().pack(_x))
        _v3 = _v1.simple_lane_type
        _x = _v3.value
        buff.write(_get_struct_B().pack(_x))
        _v4 = _v1.detailedlane_position
        _v5 = _v4.transversal_position
        _x = _v5.value
        buff.write(_get_struct_b().pack(_x))
        _v6 = _v4.lane_type
        _x = _v6.value
        buff.write(_get_struct_B().pack(_x))
        _v7 = _v4.direction
        _x = _v7.value
        buff.write(_get_struct_B().pack(_x))
        _v8 = _v1.lane_position_with_lateral_details
        _v9 = _v8.distance_to_left_border
        _x = _v9.value
        buff.write(_get_struct_H().pack(_x))
        _v10 = _v8.distance_to_right_border
        _x = _v10.value
        buff.write(_get_struct_H().pack(_x))
        _v11 = _v8.transversal_position
        _x = _v11.value
        buff.write(_get_struct_b().pack(_x))
        _v12 = _v8.lane_type
        _x = _v12.value
        buff.write(_get_struct_B().pack(_x))
        _v13 = _v8.direction
        _x = _v13.value
        buff.write(_get_struct_B().pack(_x))
        _v14 = _v1.traffic_island_position
        _v15 = _v14.one_side
        _v16 = _v15.transversal_position
        _x = _v16.value
        buff.write(_get_struct_b().pack(_x))
        _v17 = _v15.lane_type
        _x = _v17.value
        buff.write(_get_struct_B().pack(_x))
        _v18 = _v15.direction
        _x = _v18.value
        buff.write(_get_struct_B().pack(_x))
        _v19 = _v14.other_side
        _v20 = _v19.transversal_position
        _x = _v20.value
        buff.write(_get_struct_b().pack(_x))
        _v21 = _v19.lane_type
        _x = _v21.value
        buff.write(_get_struct_B().pack(_x))
        _v22 = _v19.direction
        _x = _v22.value
        buff.write(_get_struct_B().pack(_x))
        _v23 = val1.map_based
        _v24 = _v23.map_reference
        _x = _v24.choice
        buff.write(_get_struct_B().pack(_x))
        _v25 = _v24.roadsegment
        _v26 = _v25.region
        _x = _v26.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v25.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v27 = _v25.id
        _x = _v27.value
        buff.write(_get_struct_H().pack(_x))
        _v28 = _v24.intersection
        _v29 = _v28.region
        _x = _v29.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v28.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v30 = _v28.id
        _x = _v30.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v23.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v31 = _v23.lane_id
        _x = _v31.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v23.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v32 = _v23.connection_id
        _x = _v32.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v23.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v33 = _v23.longitudinal_lane_position
        _v34 = _v33.longitudinal_lane_position_value
        _x = _v34.value
        buff.write(_get_struct_H().pack(_x))
        _v35 = _v33.longitudinal_lane_position_confidence
        _x = _v35.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v23.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.map_based_is_present
        buff.write(_get_struct_B().pack(_x))
        _v36 = val1.confidence
        _v37 = _v36.used_detection_information
        _x = _v37.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v37.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v38 = _v36.used_stored_information
        _x = _v38.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v38.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v39 = _v36.confidence_value
        _x = _v39.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v36.confidence_value_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.GeneralizedLanePosition()
        _v40 = val1.lane_position_based
        start = end
        end += 1
        (_v40.choice,) = _get_struct_B().unpack(str[start:end])
        _v41 = _v40.simplelane_position
        start = end
        end += 1
        (_v41.value,) = _get_struct_b().unpack(str[start:end])
        _v42 = _v40.simple_lane_type
        start = end
        end += 1
        (_v42.value,) = _get_struct_B().unpack(str[start:end])
        _v43 = _v40.detailedlane_position
        _v44 = _v43.transversal_position
        start = end
        end += 1
        (_v44.value,) = _get_struct_b().unpack(str[start:end])
        _v45 = _v43.lane_type
        start = end
        end += 1
        (_v45.value,) = _get_struct_B().unpack(str[start:end])
        _v46 = _v43.direction
        start = end
        end += 1
        (_v46.value,) = _get_struct_B().unpack(str[start:end])
        _v47 = _v40.lane_position_with_lateral_details
        _v48 = _v47.distance_to_left_border
        start = end
        end += 2
        (_v48.value,) = _get_struct_H().unpack(str[start:end])
        _v49 = _v47.distance_to_right_border
        start = end
        end += 2
        (_v49.value,) = _get_struct_H().unpack(str[start:end])
        _v50 = _v47.transversal_position
        start = end
        end += 1
        (_v50.value,) = _get_struct_b().unpack(str[start:end])
        _v51 = _v47.lane_type
        start = end
        end += 1
        (_v51.value,) = _get_struct_B().unpack(str[start:end])
        _v52 = _v47.direction
        start = end
        end += 1
        (_v52.value,) = _get_struct_B().unpack(str[start:end])
        _v53 = _v40.traffic_island_position
        _v54 = _v53.one_side
        _v55 = _v54.transversal_position
        start = end
        end += 1
        (_v55.value,) = _get_struct_b().unpack(str[start:end])
        _v56 = _v54.lane_type
        start = end
        end += 1
        (_v56.value,) = _get_struct_B().unpack(str[start:end])
        _v57 = _v54.direction
        start = end
        end += 1
        (_v57.value,) = _get_struct_B().unpack(str[start:end])
        _v58 = _v53.other_side
        _v59 = _v58.transversal_position
        start = end
        end += 1
        (_v59.value,) = _get_struct_b().unpack(str[start:end])
        _v60 = _v58.lane_type
        start = end
        end += 1
        (_v60.value,) = _get_struct_B().unpack(str[start:end])
        _v61 = _v58.direction
        start = end
        end += 1
        (_v61.value,) = _get_struct_B().unpack(str[start:end])
        _v62 = val1.map_based
        _v63 = _v62.map_reference
        start = end
        end += 1
        (_v63.choice,) = _get_struct_B().unpack(str[start:end])
        _v64 = _v63.roadsegment
        _v65 = _v64.region
        start = end
        end += 2
        (_v65.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v64.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v64.region_is_present = bool(_v64.region_is_present)
        _v66 = _v64.id
        start = end
        end += 2
        (_v66.value,) = _get_struct_H().unpack(str[start:end])
        _v67 = _v63.intersection
        _v68 = _v67.region
        start = end
        end += 2
        (_v68.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v67.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v67.region_is_present = bool(_v67.region_is_present)
        _v69 = _v67.id
        start = end
        end += 2
        (_v69.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v62.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v62.map_reference_is_present = bool(_v62.map_reference_is_present)
        _v70 = _v62.lane_id
        start = end
        end += 1
        (_v70.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v62.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v62.lane_id_is_present = bool(_v62.lane_id_is_present)
        _v71 = _v62.connection_id
        start = end
        end += 1
        (_v71.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v62.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v62.connection_id_is_present = bool(_v62.connection_id_is_present)
        _v72 = _v62.longitudinal_lane_position
        _v73 = _v72.longitudinal_lane_position_value
        start = end
        end += 2
        (_v73.value,) = _get_struct_H().unpack(str[start:end])
        _v74 = _v72.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v74.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v62.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        _v62.longitudinal_lane_position_is_present = bool(_v62.longitudinal_lane_position_is_present)
        start = end
        end += 1
        (val1.map_based_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_based_is_present = bool(val1.map_based_is_present)
        _v75 = val1.confidence
        _v76 = _v75.used_detection_information
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v76.value = str[start:end]
        start = end
        end += 1
        (_v76.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v77 = _v75.used_stored_information
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v77.value = str[start:end]
        start = end
        end += 1
        (_v77.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v78 = _v75.confidence_value
        start = end
        end += 1
        (_v78.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v75.confidence_value_is_present,) = _get_struct_B().unpack(str[start:end])
        _v75.confidence_value_is_present = bool(_v75.confidence_value_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v79 = val1.lane_position_based
        _x = _v79.choice
        buff.write(_get_struct_B().pack(_x))
        _v80 = _v79.simplelane_position
        _x = _v80.value
        buff.write(_get_struct_b().pack(_x))
        _v81 = _v79.simple_lane_type
        _x = _v81.value
        buff.write(_get_struct_B().pack(_x))
        _v82 = _v79.detailedlane_position
        _v83 = _v82.transversal_position
        _x = _v83.value
        buff.write(_get_struct_b().pack(_x))
        _v84 = _v82.lane_type
        _x = _v84.value
        buff.write(_get_struct_B().pack(_x))
        _v85 = _v82.direction
        _x = _v85.value
        buff.write(_get_struct_B().pack(_x))
        _v86 = _v79.lane_position_with_lateral_details
        _v87 = _v86.distance_to_left_border
        _x = _v87.value
        buff.write(_get_struct_H().pack(_x))
        _v88 = _v86.distance_to_right_border
        _x = _v88.value
        buff.write(_get_struct_H().pack(_x))
        _v89 = _v86.transversal_position
        _x = _v89.value
        buff.write(_get_struct_b().pack(_x))
        _v90 = _v86.lane_type
        _x = _v90.value
        buff.write(_get_struct_B().pack(_x))
        _v91 = _v86.direction
        _x = _v91.value
        buff.write(_get_struct_B().pack(_x))
        _v92 = _v79.traffic_island_position
        _v93 = _v92.one_side
        _v94 = _v93.transversal_position
        _x = _v94.value
        buff.write(_get_struct_b().pack(_x))
        _v95 = _v93.lane_type
        _x = _v95.value
        buff.write(_get_struct_B().pack(_x))
        _v96 = _v93.direction
        _x = _v96.value
        buff.write(_get_struct_B().pack(_x))
        _v97 = _v92.other_side
        _v98 = _v97.transversal_position
        _x = _v98.value
        buff.write(_get_struct_b().pack(_x))
        _v99 = _v97.lane_type
        _x = _v99.value
        buff.write(_get_struct_B().pack(_x))
        _v100 = _v97.direction
        _x = _v100.value
        buff.write(_get_struct_B().pack(_x))
        _v101 = val1.map_based
        _v102 = _v101.map_reference
        _x = _v102.choice
        buff.write(_get_struct_B().pack(_x))
        _v103 = _v102.roadsegment
        _v104 = _v103.region
        _x = _v104.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v103.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v105 = _v103.id
        _x = _v105.value
        buff.write(_get_struct_H().pack(_x))
        _v106 = _v102.intersection
        _v107 = _v106.region
        _x = _v107.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v106.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v108 = _v106.id
        _x = _v108.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v101.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v109 = _v101.lane_id
        _x = _v109.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v101.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v110 = _v101.connection_id
        _x = _v110.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v101.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v111 = _v101.longitudinal_lane_position
        _v112 = _v111.longitudinal_lane_position_value
        _x = _v112.value
        buff.write(_get_struct_H().pack(_x))
        _v113 = _v111.longitudinal_lane_position_confidence
        _x = _v113.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v101.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
        _x = val1.map_based_is_present
        buff.write(_get_struct_B().pack(_x))
        _v114 = val1.confidence
        _v115 = _v114.used_detection_information
        _x = _v115.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v115.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v116 = _v114.used_stored_information
        _x = _v116.value
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = _v116.bits_unused
        buff.write(_get_struct_B().pack(_x))
        _v117 = _v114.confidence_value
        _x = _v117.value
        buff.write(_get_struct_B().pack(_x))
        _x = _v114.confidence_value_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.GeneralizedLanePosition()
        _v118 = val1.lane_position_based
        start = end
        end += 1
        (_v118.choice,) = _get_struct_B().unpack(str[start:end])
        _v119 = _v118.simplelane_position
        start = end
        end += 1
        (_v119.value,) = _get_struct_b().unpack(str[start:end])
        _v120 = _v118.simple_lane_type
        start = end
        end += 1
        (_v120.value,) = _get_struct_B().unpack(str[start:end])
        _v121 = _v118.detailedlane_position
        _v122 = _v121.transversal_position
        start = end
        end += 1
        (_v122.value,) = _get_struct_b().unpack(str[start:end])
        _v123 = _v121.lane_type
        start = end
        end += 1
        (_v123.value,) = _get_struct_B().unpack(str[start:end])
        _v124 = _v121.direction
        start = end
        end += 1
        (_v124.value,) = _get_struct_B().unpack(str[start:end])
        _v125 = _v118.lane_position_with_lateral_details
        _v126 = _v125.distance_to_left_border
        start = end
        end += 2
        (_v126.value,) = _get_struct_H().unpack(str[start:end])
        _v127 = _v125.distance_to_right_border
        start = end
        end += 2
        (_v127.value,) = _get_struct_H().unpack(str[start:end])
        _v128 = _v125.transversal_position
        start = end
        end += 1
        (_v128.value,) = _get_struct_b().unpack(str[start:end])
        _v129 = _v125.lane_type
        start = end
        end += 1
        (_v129.value,) = _get_struct_B().unpack(str[start:end])
        _v130 = _v125.direction
        start = end
        end += 1
        (_v130.value,) = _get_struct_B().unpack(str[start:end])
        _v131 = _v118.traffic_island_position
        _v132 = _v131.one_side
        _v133 = _v132.transversal_position
        start = end
        end += 1
        (_v133.value,) = _get_struct_b().unpack(str[start:end])
        _v134 = _v132.lane_type
        start = end
        end += 1
        (_v134.value,) = _get_struct_B().unpack(str[start:end])
        _v135 = _v132.direction
        start = end
        end += 1
        (_v135.value,) = _get_struct_B().unpack(str[start:end])
        _v136 = _v131.other_side
        _v137 = _v136.transversal_position
        start = end
        end += 1
        (_v137.value,) = _get_struct_b().unpack(str[start:end])
        _v138 = _v136.lane_type
        start = end
        end += 1
        (_v138.value,) = _get_struct_B().unpack(str[start:end])
        _v139 = _v136.direction
        start = end
        end += 1
        (_v139.value,) = _get_struct_B().unpack(str[start:end])
        _v140 = val1.map_based
        _v141 = _v140.map_reference
        start = end
        end += 1
        (_v141.choice,) = _get_struct_B().unpack(str[start:end])
        _v142 = _v141.roadsegment
        _v143 = _v142.region
        start = end
        end += 2
        (_v143.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v142.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v142.region_is_present = bool(_v142.region_is_present)
        _v144 = _v142.id
        start = end
        end += 2
        (_v144.value,) = _get_struct_H().unpack(str[start:end])
        _v145 = _v141.intersection
        _v146 = _v145.region
        start = end
        end += 2
        (_v146.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v145.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v145.region_is_present = bool(_v145.region_is_present)
        _v147 = _v145.id
        start = end
        end += 2
        (_v147.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v140.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        _v140.map_reference_is_present = bool(_v140.map_reference_is_present)
        _v148 = _v140.lane_id
        start = end
        end += 1
        (_v148.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v140.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v140.lane_id_is_present = bool(_v140.lane_id_is_present)
        _v149 = _v140.connection_id
        start = end
        end += 1
        (_v149.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v140.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        _v140.connection_id_is_present = bool(_v140.connection_id_is_present)
        _v150 = _v140.longitudinal_lane_position
        _v151 = _v150.longitudinal_lane_position_value
        start = end
        end += 2
        (_v151.value,) = _get_struct_H().unpack(str[start:end])
        _v152 = _v150.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v152.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v140.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        _v140.longitudinal_lane_position_is_present = bool(_v140.longitudinal_lane_position_is_present)
        start = end
        end += 1
        (val1.map_based_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_based_is_present = bool(val1.map_based_is_present)
        _v153 = val1.confidence
        _v154 = _v153.used_detection_information
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v154.value = str[start:end]
        start = end
        end += 1
        (_v154.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v155 = _v153.used_stored_information
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v155.value = str[start:end]
        start = end
        end += 1
        (_v155.bits_unused,) = _get_struct_B().unpack(str[start:end])
        _v156 = _v153.confidence_value
        start = end
        end += 1
        (_v156.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (_v153.confidence_value_is_present,) = _get_struct_B().unpack(str[start:end])
        _v153.confidence_value_is_present = bool(_v153.confidence_value_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
