# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/GeoPosition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class GeoPosition(genpy.Message):
  _md5sum = "21582c9df7e23683b4f8a80362f391aa"
  _type = "etsi_its_cam_ts_msgs/GeoPosition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# GeoPosition::= SEQUENCE{
# 	latitude   Latitude,
# 	longitude  Longitude,
#     altitude   AltitudeValue DEFAULT unavailable
# }
# ------------------------------------------------------------------------------
# * 
# * This DF indicates a geographical position.
# *
# * It shall include the following components: 
# *
# * @field latitude: the latitude of the geographical position.
# *
# * @field longitude: the longitude of the geographical position.
# *
# * @field altitude: the altitude of the geographical position with default value unavailable.
# *
#

Latitude latitude

Longitude longitude

AltitudeValue altitude


int32 ALTITUDE_DEFAULT = 800001

================================================================================
MSG: etsi_its_cam_ts_msgs/Latitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Latitude ::= INTEGER {
#     unavailable(900000001)
# } (-900000000..900000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
# * in south hemisphere.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
# * - `0` is used for the latitude of the equator,
# * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
# * - `900 000 001` when the information is unavailable.
# *
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Editorial update in V2.1.1
# 

int32 value
int32 MIN = -900000000
int32 MAX = 900000001
int32 UNAVAILABLE = 900000001

================================================================================
MSG: etsi_its_cam_ts_msgs/Longitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Longitude ::= INTEGER {
#     valueNotUsed (-1800000000),
#     unavailable  (1800000001)
# } (-1800000000..1800000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
# * to the east or to the west of the prime meridian.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
# * - `0` to indicate the prime meridian,
# * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
# * - `1 800 000 001` when the information is unavailable.
# *
# * The value -1 800 000 000 shall not be used. 
# * 
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1
# 

int32 value
int32 MIN = -1800000000
int32 MAX = 1800000001
int32 VALUE_NOT_USED = -1800000000
int32 UNAVAILABLE = 1800000001

================================================================================
MSG: etsi_its_cam_ts_msgs/AltitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AltitudeValue ::= INTEGER {
#     negativeOutOfRange (-100000),
#     postiveOutOfRange  (800000),
#     unavailable        (800001)
# } (-100000..800001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the altitude value in a WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `-100 000` if the altitude is equal to or less than -1 000 m,
# * - `n` (`n > -100 000` and `n < 800 000`) if the altitude is equal to or less than n  x 0,01 metre and greater than (n-1) x 0,01 metre,
# * - `800 000` if the altitude  greater than 7 999,99 m,
# * - `800 001` if the information is not available.
# *
# * @note: the range of this DE does not use the full binary encoding range, but all reasonable values are covered. In order to cover all possible altitude ranges a larger encoding would be necessary.
# * @unit: 0,01 metre
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1 (definition of 800 000 has slightly changed) 
# 

int32 value
int32 MIN = -100000
int32 MAX = 800001
int32 NEGATIVE_OUT_OF_RANGE = -100000
int32 POSTIVE_OUT_OF_RANGE = 800000
int32 UNAVAILABLE = 800001
"""
  # Pseudo-constants
  ALTITUDE_DEFAULT = 800001

  __slots__ = ['latitude','longitude','altitude']
  _slot_types = ['etsi_its_cam_ts_msgs/Latitude','etsi_its_cam_ts_msgs/Longitude','etsi_its_cam_ts_msgs/AltitudeValue']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       latitude,longitude,altitude

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GeoPosition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.latitude is None:
        self.latitude = etsi_its_cam_ts_msgs.msg.Latitude()
      if self.longitude is None:
        self.longitude = etsi_its_cam_ts_msgs.msg.Longitude()
      if self.altitude is None:
        self.altitude = etsi_its_cam_ts_msgs.msg.AltitudeValue()
    else:
      self.latitude = etsi_its_cam_ts_msgs.msg.Latitude()
      self.longitude = etsi_its_cam_ts_msgs.msg.Longitude()
      self.altitude = etsi_its_cam_ts_msgs.msg.AltitudeValue()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3i().pack(_x.latitude.value, _x.longitude.value, _x.altitude.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.latitude is None:
        self.latitude = etsi_its_cam_ts_msgs.msg.Latitude()
      if self.longitude is None:
        self.longitude = etsi_its_cam_ts_msgs.msg.Longitude()
      if self.altitude is None:
        self.altitude = etsi_its_cam_ts_msgs.msg.AltitudeValue()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.latitude.value, _x.longitude.value, _x.altitude.value,) = _get_struct_3i().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3i().pack(_x.latitude.value, _x.longitude.value, _x.altitude.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.latitude is None:
        self.latitude = etsi_its_cam_ts_msgs.msg.Latitude()
      if self.longitude is None:
        self.longitude = etsi_its_cam_ts_msgs.msg.Longitude()
      if self.altitude is None:
        self.altitude = etsi_its_cam_ts_msgs.msg.AltitudeValue()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.latitude.value, _x.longitude.value, _x.altitude.value,) = _get_struct_3i().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3i = None
def _get_struct_3i():
    global _struct_3i
    if _struct_3i is None:
        _struct_3i = struct.Struct("<3i")
    return _struct_3i
