# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/HumanPresenceOnTheRoadSubCauseCode.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class HumanPresenceOnTheRoadSubCauseCode(genpy.Message):
  _md5sum = "7d1308f65e86ca1d55dbb04f7063a4da"
  _type = "etsi_its_cam_ts_msgs/HumanPresenceOnTheRoadSubCauseCode"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# HumanPresenceOnTheRoadSubCauseCode ::= INTEGER {
#     unavailable                  (0), 
#     childrenOnRoadway            (1), 
#     cyclistOnRoadway             (2), 
#     motorcyclistOnRoadway        (3),
#     pedestrian                   (4),
#     ordinary-pedestrian          (5),
#     road-worker                  (6),
#     first-responder              (7),
#     lightVruVehicle              (8), 
#     bicyclist                    (9), 
#     wheelchair-user              (10), 
#     horse-and-rider              (11), 
#     rollerskater                 (12), 
#     e-scooter                    (13), 
#     personal-transporter         (14),
#     pedelec                      (15), 
#     speed-pedelec                (16),
#     ptw                          (17), 
#     moped                        (18), 
#     motorcycle                   (19), 
#     motorcycle-and-sidecar-right (20), 
#     motorcycle-and-sidecar-left  (21)
# } (0..255)
# ------------------------------------------------------------------------------
# *
# * This DE represents the value of the sub cause code of the @ref CauseCode `humanPresenceOnTheRoad`.
# * 
# * The value shall be set to:
# * - 0 - `unavailable`                    - in case further detailed information abou the human presence on the road is unavailable,
# * - 1 - `childrenOnRoadway`              - in case children are present on the road,
# * - 2 - `cyclistOnRoadway`               - in case cyclist(s) are present on the road,
# * - 3 - `motorcyclistOnRoadway`          - in case motorcyclist(s) are present on the road,
# * - 4 - `pedestrian`                     - in case pedestrian(s) of any type are present on the road,
# * - 5 - `ordinary-pedestrian`            - in case pedestrian(s) to which no more-specific profile applies are present on the road,
# * - 6 - `road-worker`                    - in case pedestrian(s) with the role of a road worker applies are present on the road,
# * - 7 - `first-responder`                - in case pedestrian(s) with the role of a first responder applies are present on the road,  
# * - 8 - `lightVruVehicle                 - in case light vru vehicle(s) of any type are present on the road,
# * - 9 - `bicyclist `                     - in case cycle(s) and their bicyclist(s) are present on the road,
# * - 10 - `wheelchair-user`               - in case wheelchair(s) and their user(s) are present on the road,
# * - 11 - `horse-and-rider`               - in case horse(s) and rider(s) are present on the road,
# * - 12 - `rollerskater`                  - in case rolleskater(s) and skater(s) are present on the road,
# * - 13 - `e-scooter`                     - in case e-scooter(s) and rider(s) are present on the road,
# * - 14 - `personal-transporter`          - in case personal-transporter(s) and rider(s) are present on the road,
# * - 15 - `pedelec`                       - in case pedelec(s) and rider(s) are present on the road,
# * - 16 - `speed-pedelec`                 - in case speed-pedelec(s) and rider(s) are present on the road,
# * - 17 - `ptw`                           - in case powered-two-wheeler(s) of any type are present on the road,
# * - 18 - `moped`                         - in case moped(s) and rider(s) are present on the road,
# * - 19 - `motorcycle`                    - in case motorcycle(s) and rider(s) are present on the road,
# * - 20 - `motorcycle-and-sidecar-right`  - in case motorcycle(s) with sidecar(s) on the right and rider are present on the road,
# * - 21 - `motorcycle-and-sidecar-left`   - in case motorcycle(s) with sidecar(s) on the left and rider are present on the road.
# * - 22-255                               - are reserved for future usage.
# *
# * @category: Traffic information
# * @revision: editorial revision in V2.1.1, named values 4-21 added in V2.2.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 CHILDREN_ON_ROADWAY = 1
uint8 CYCLIST_ON_ROADWAY = 2
uint8 MOTORCYCLIST_ON_ROADWAY = 3
uint8 PEDESTRIAN = 4
uint8 ORDINARY_PEDESTRIAN = 5
uint8 ROAD_WORKER = 6
uint8 FIRST_RESPONDER = 7
uint8 LIGHT_VRU_VEHICLE = 8
uint8 BICYCLIST = 9
uint8 WHEELCHAIR_USER = 10
uint8 HORSE_AND_RIDER = 11
uint8 ROLLERSKATER = 12
uint8 E_SCOOTER = 13
uint8 PERSONAL_TRANSPORTER = 14
uint8 PEDELEC = 15
uint8 SPEED_PEDELEC = 16
uint8 PTW = 17
uint8 MOPED = 18
uint8 MOTORCYCLE = 19
uint8 MOTORCYCLE_AND_SIDECAR_RIGHT = 20
uint8 MOTORCYCLE_AND_SIDECAR_LEFT = 21
"""
  # Pseudo-constants
  MIN = 0
  MAX = 255
  UNAVAILABLE = 0
  CHILDREN_ON_ROADWAY = 1
  CYCLIST_ON_ROADWAY = 2
  MOTORCYCLIST_ON_ROADWAY = 3
  PEDESTRIAN = 4
  ORDINARY_PEDESTRIAN = 5
  ROAD_WORKER = 6
  FIRST_RESPONDER = 7
  LIGHT_VRU_VEHICLE = 8
  BICYCLIST = 9
  WHEELCHAIR_USER = 10
  HORSE_AND_RIDER = 11
  ROLLERSKATER = 12
  E_SCOOTER = 13
  PERSONAL_TRANSPORTER = 14
  PEDELEC = 15
  SPEED_PEDELEC = 16
  PTW = 17
  MOPED = 18
  MOTORCYCLE = 19
  MOTORCYCLE_AND_SIDECAR_RIGHT = 20
  MOTORCYCLE_AND_SIDECAR_LEFT = 21

  __slots__ = ['value']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HumanPresenceOnTheRoadSubCauseCode, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = 0
    else:
      self.value = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
