# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/ImpassabilitySubCauseCode.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ImpassabilitySubCauseCode(genpy.Message):
  _md5sum = "de76245feccf4ac358ba21b3225b1a34"
  _type = "etsi_its_cam_ts_msgs/ImpassabilitySubCauseCode"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ImpassabilitySubCauseCode ::= INTEGER {
#     unavailable               (0), 
#     flooding                  (1),
#     dangerOfAvalanches        (2), 
#     blastingOfAvalanches      (3), 
#     landslips                 (4), 
#     chemicalSpillage          (5),
#     winterClosure             (6),
#     sinkhole                  (7),
#     earthquakeDamage          (8),
#     fallenTrees               (9),
#     rockfalls                 (10),
#     sewerOverflow             (11),
#     stormDamage               (12),
#     subsidence                (13),
#     burstPipe                 (14),
#     burstWaterMain            (15),
#     fallenPowerCables         (16),
#     snowDrifts                (17)
# } (0..255)
# ------------------------------------------------------------------------------
# *
# * This DE represents the value of the sub cause codes of the @ref CauseCode `impassability`
# * 
# * The value shall be set to:
# * - 0 `unavailable`              - in case further detailed information about the unmanaged road blockage is unavailable,
# * - 1 `flooding          `       - in case the road is affected by flooding,
# * - 2 `dangerOfAvalanches`       - in case the road is at risk of being affected or blocked by avalanches,
# * - 3 `blastingOfAvalanches`     - in case there is an active blasting of avalanches on or near the road,
# * - 4 `landslips`                - in case the road is affected by landslips,
# * - 5 `chemicalSpillage`         - in case the road is affected by chemical spillage,
# * - 6 `winterClosure`            - in case the road is impassable due to a winter closure.
# * - 7 `sinkhole`                 - in case the road is impassable due to large holes in the road surface.
# * - 8 `earthquakeDamage`         - in case the road is obstructed or partially obstructed because of damage caused by an earthquake.
# * - 9 `fallenTrees`              - in case the road is obstructed or partially obstructed by one or more fallen trees. 
# * - 10 `rockfalls`               - in case the road is obstructed or partially obstructed due to fallen rocks.
# * - 11 `sewerOverflow`           - in case the road is obstructed or partially obstructed by overflows from one or more sewers. 
# * - 12 `stormDamage`             - in case the road is obstructed or partially obstructed by debris caused by strong winds.
# * - 13 `subsidence`              - in case the road surface has sunken or collapsed in places.
# * - 14 `burstPipe`               - in case the road surface has sunken or collapsed in places due to burst pipes.
# * - 15 `burstWaterMain`          - in case the road is obstructed due to local flooding and/or subsidence. 
# * - 16 `fallenPowerCables`       - in case the road is obstructed or partly obstructed by one or more fallen power cables.
# * - 17 `snowDrifts`              - in case the road is obstructed or partially obstructed by snow drifting in progress or patches of deep snow due to earlier drifting.
# * - 15-255                       - are reserved for future usage.
# *
# * @category: Traffic information
# * @revision: Created in V2.2.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 FLOODING = 1
uint8 DANGER_OF_AVALANCHES = 2
uint8 BLASTING_OF_AVALANCHES = 3
uint8 LANDSLIPS = 4
uint8 CHEMICAL_SPILLAGE = 5
uint8 WINTER_CLOSURE = 6
uint8 SINKHOLE = 7
uint8 EARTHQUAKE_DAMAGE = 8
uint8 FALLEN_TREES = 9
uint8 ROCKFALLS = 10
uint8 SEWER_OVERFLOW = 11
uint8 STORM_DAMAGE = 12
uint8 SUBSIDENCE = 13
uint8 BURST_PIPE = 14
uint8 BURST_WATER_MAIN = 15
uint8 FALLEN_POWER_CABLES = 16
uint8 SNOW_DRIFTS = 17
"""
  # Pseudo-constants
  MIN = 0
  MAX = 255
  UNAVAILABLE = 0
  FLOODING = 1
  DANGER_OF_AVALANCHES = 2
  BLASTING_OF_AVALANCHES = 3
  LANDSLIPS = 4
  CHEMICAL_SPILLAGE = 5
  WINTER_CLOSURE = 6
  SINKHOLE = 7
  EARTHQUAKE_DAMAGE = 8
  FALLEN_TREES = 9
  ROCKFALLS = 10
  SEWER_OVERFLOW = 11
  STORM_DAMAGE = 12
  SUBSIDENCE = 13
  BURST_PIPE = 14
  BURST_WATER_MAIN = 15
  FALLEN_POWER_CABLES = 16
  SNOW_DRIFTS = 17

  __slots__ = ['value']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ImpassabilitySubCauseCode, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = 0
    else:
      self.value = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
