# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/IvimReference.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class IvimReference(genpy.Message):
  _md5sum = "711106f8fc533db4c4f0ce3f20eac088"
  _type = "etsi_its_cam_ts_msgs/IvimReference"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IvimReference::= SEQUENCE {
#     serviceProviderId         Provider, 
#     iviIdentificationNumber   IviIdentificationNumber
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the reference to the information contained in a IVIM according to ETSI TS 103 301 [15]. 
# *
# * It shall include the following components: 
# * 
# * @field serviceProviderId: identifier of the organization that provided the IVIM.
# *
# * @field iviIdentificationNumber: identifier of the IVIM, as assigned by the organization identified in serviceProviderId.
# *
# * @category: Communication information
# * @revision: Created in V2.2.1
# 

Provider service_provider_id

IviIdentificationNumber ivi_identification_number


================================================================================
MSG: etsi_its_cam_ts_msgs/Provider
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Provider ::= SEQUENCE {
# 	countryCode		CountryCode,
# 	providerIdentifier	IssuerIdentifier
# } 
# ------------------------------------------------------------------------------
# *
# * This DF identifies an organization.
# *
# * It shall include the following components: 
# * 
# * @field countryCode: represents the country code that identifies the country of the national registration administrator for issuers according to ISO 14816.
# *
# * @field providerIdentifier: identifies the organization according to the national ISO 14816 register for issuers.
# *
# * @note: See https://www.itsstandards.eu/registries/register-of-nra-i-cs1/ for a list of national registration administrators and their respective registers
# * 
# * @category: Communication information
# * @revision: Created in V2.2.1 based on ISO 17573-3 [24]
# 

CountryCode country_code

IssuerIdentifier provider_identifier


================================================================================
MSG: etsi_its_cam_ts_msgs/CountryCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CountryCode ::= BIT STRING(SIZE(10))
# ------------------------------------------------------------------------------
# * 
# * This DE represents an ISO 3166-1 [25] country code encoded using ITA-2 encoding.
# *
# * @category: Basic information
# * @revision: Created in V2.2.1 based on ISO 14816 [23]
#

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 10


================================================================================
MSG: etsi_its_cam_ts_msgs/IssuerIdentifier
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IssuerIdentifier ::= INTEGER(0 .. 16383)
# ------------------------------------------------------------------------------
# * 
# * This DE represent the identifier of an organization according to the applicable registry.
# *
# * @category: Basic information
# * @revision: Created in V2.2.1 based on ISO 14816 [23]
#

uint16 value
uint16 MIN = 0
uint16 MAX = 16383


================================================================================
MSG: etsi_its_cam_ts_msgs/IviIdentificationNumber
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IviIdentificationNumber::= INTEGER(1..32767,..., 8388607) 
# ------------------------------------------------------------------------------
# * 
# * This DE represents the identifier of the IVIM.
# *
# * @category: Basic information
# * @revision: Created in V2.2.1 based on ETSI TS 103 301 [15]
#

int64 value
int64 MIN = 1
int64 MAX = 32767

"""
  __slots__ = ['service_provider_id','ivi_identification_number']
  _slot_types = ['etsi_its_cam_ts_msgs/Provider','etsi_its_cam_ts_msgs/IviIdentificationNumber']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       service_provider_id,ivi_identification_number

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(IvimReference, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.service_provider_id is None:
        self.service_provider_id = etsi_its_cam_ts_msgs.msg.Provider()
      if self.ivi_identification_number is None:
        self.ivi_identification_number = etsi_its_cam_ts_msgs.msg.IviIdentificationNumber()
    else:
      self.service_provider_id = etsi_its_cam_ts_msgs.msg.Provider()
      self.ivi_identification_number = etsi_its_cam_ts_msgs.msg.IviIdentificationNumber()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.service_provider_id.country_code.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BHq().pack(_x.service_provider_id.country_code.bits_unused, _x.service_provider_id.provider_identifier.value, _x.ivi_identification_number.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.service_provider_id is None:
        self.service_provider_id = etsi_its_cam_ts_msgs.msg.Provider()
      if self.ivi_identification_number is None:
        self.ivi_identification_number = etsi_its_cam_ts_msgs.msg.IviIdentificationNumber()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.service_provider_id.country_code.value = str[start:end]
      _x = self
      start = end
      end += 11
      (_x.service_provider_id.country_code.bits_unused, _x.service_provider_id.provider_identifier.value, _x.ivi_identification_number.value,) = _get_struct_BHq().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.service_provider_id.country_code.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BHq().pack(_x.service_provider_id.country_code.bits_unused, _x.service_provider_id.provider_identifier.value, _x.ivi_identification_number.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.service_provider_id is None:
        self.service_provider_id = etsi_its_cam_ts_msgs.msg.Provider()
      if self.ivi_identification_number is None:
        self.ivi_identification_number = etsi_its_cam_ts_msgs.msg.IviIdentificationNumber()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.service_provider_id.country_code.value = str[start:end]
      _x = self
      start = end
      end += 11
      (_x.service_provider_id.country_code.bits_unused, _x.service_provider_id.provider_identifier.value, _x.ivi_identification_number.value,) = _get_struct_BHq().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_BHq = None
def _get_struct_BHq():
    global _struct_BHq
    if _struct_BHq is None:
        _struct_BHq = struct.Struct("<BHq")
    return _struct_BHq
