# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/MapReferences.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class MapReferences(genpy.Message):
  _md5sum = "4e2babd4a5742d43086fe034644fd1bb"
  _type = "etsi_its_cam_ts_msgs/MapReferences"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapReferences::= SEQUENCE (SIZE(1..8,...)) OF MapReference
# ------------------------------------------------------------------------------
# *
# * This DF shall contain a list of @ref MapReference.
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

MapReference[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cam_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
# *
# * The following options are provided:
# * 
# * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
# * 
# * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
# *
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for a road segment
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the road segment.
# *
# * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cam_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cam_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the intersection
# *
# * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id

"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 8

  __slots__ = ['array']
  _slot_types = ['etsi_its_cam_ts_msgs/MapReference[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MapReferences, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _x = val1.choice
        buff.write(_get_struct_B().pack(_x))
        _v1 = val1.roadsegment
        _v2 = _v1.region
        _x = _v2.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v1.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v3 = _v1.id
        _x = _v3.value
        buff.write(_get_struct_H().pack(_x))
        _v4 = val1.intersection
        _v5 = _v4.region
        _x = _v5.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v4.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v6 = _v4.id
        _x = _v6.value
        buff.write(_get_struct_H().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.MapReference()
        start = end
        end += 1
        (val1.choice,) = _get_struct_B().unpack(str[start:end])
        _v7 = val1.roadsegment
        _v8 = _v7.region
        start = end
        end += 2
        (_v8.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v7.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v7.region_is_present = bool(_v7.region_is_present)
        _v9 = _v7.id
        start = end
        end += 2
        (_v9.value,) = _get_struct_H().unpack(str[start:end])
        _v10 = val1.intersection
        _v11 = _v10.region
        start = end
        end += 2
        (_v11.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v10.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v10.region_is_present = bool(_v10.region_is_present)
        _v12 = _v10.id
        start = end
        end += 2
        (_v12.value,) = _get_struct_H().unpack(str[start:end])
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _x = val1.choice
        buff.write(_get_struct_B().pack(_x))
        _v13 = val1.roadsegment
        _v14 = _v13.region
        _x = _v14.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v13.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v15 = _v13.id
        _x = _v15.value
        buff.write(_get_struct_H().pack(_x))
        _v16 = val1.intersection
        _v17 = _v16.region
        _x = _v17.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v16.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v18 = _v16.id
        _x = _v18.value
        buff.write(_get_struct_H().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.MapReference()
        start = end
        end += 1
        (val1.choice,) = _get_struct_B().unpack(str[start:end])
        _v19 = val1.roadsegment
        _v20 = _v19.region
        start = end
        end += 2
        (_v20.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v19.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v19.region_is_present = bool(_v19.region_is_present)
        _v21 = _v19.id
        start = end
        end += 2
        (_v21.value,) = _get_struct_H().unpack(str[start:end])
        _v22 = val1.intersection
        _v23 = _v22.region
        start = end
        end += 2
        (_v23.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v22.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v22.region_is_present = bool(_v22.region_is_present)
        _v24 = _v22.id
        start = end
        end += 2
        (_v24.value,) = _get_struct_H().unpack(str[start:end])
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
