# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/MapemElementReference.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class MapemElementReference(genpy.Message):
  _md5sum = "b0c60c03e0f131b572cc7ee98e082a5d"
  _type = "etsi_its_cam_ts_msgs/MapemElementReference"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapemElementReference::= SEQUENCE {
#   mapReference      MapReference OPTIONAL,
#   laneIds           MapemLaneList  OPTIONAL,
#   connectionIds	    MapemConnectionList  OPTIONAL,		
#   ...
# } 
# ------------------------------------------------------------------------------
# * 
# * This DF provides references to an element described in a MAPEM according to ETSI TS 103 301 [i.15], such as a lane or connection at a specific intersection or road segment. 
# * 
# * It shall include the following components: 
# * 
# * @field mapReference: the optional reference to a MAPEM that describes the intersection or road segment. It is absent if the MAPEM topology is known from the context.
# * 
# * @field laneIds: the optional list of the identifiers of the lanes to be referenced. 
# * 
# * @field connectionIds: the optional list of the identifiers of the connections to be referenced. 
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

MapReference map_reference
bool map_reference_is_present

MapemLaneList lane_ids
bool lane_ids_is_present

MapemConnectionList connection_ids
bool connection_ids_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
# *
# * The following options are provided:
# * 
# * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
# * 
# * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
# *
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for a road segment
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the road segment.
# *
# * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cam_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cam_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the intersection
# *
# * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cam_ts_msgs/MapemLaneList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapemLaneList ::=  SEQUENCE (SIZE(1..8,...)) OF Identifier1B
# ------------------------------------------------------------------------------
# * 
# * This DF provides references to MAPEM lanes using a list of @ref Identifier1B.
# *
# * @category: Road topology information
# * @revision: Created in 2.2.1
#

Identifier1B[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cam_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cam_ts_msgs/MapemConnectionList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapemConnectionList ::=  SEQUENCE (SIZE(1..8,...)) OF Identifier1B
# ------------------------------------------------------------------------------
# * 
# * This DF provides references to MAPEM connections using a list of @ref Identifier1B.
# * Note: connections are  allowed �maneuvers� (e.g. an ingress / egress relation) on an intersection.
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

Identifier1B[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 8
"""
  __slots__ = ['map_reference','map_reference_is_present','lane_ids','lane_ids_is_present','connection_ids','connection_ids_is_present']
  _slot_types = ['etsi_its_cam_ts_msgs/MapReference','bool','etsi_its_cam_ts_msgs/MapemLaneList','bool','etsi_its_cam_ts_msgs/MapemConnectionList','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       map_reference,map_reference_is_present,lane_ids,lane_ids_is_present,connection_ids,connection_ids_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MapemElementReference, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.map_reference is None:
        self.map_reference = etsi_its_cam_ts_msgs.msg.MapReference()
      if self.map_reference_is_present is None:
        self.map_reference_is_present = False
      if self.lane_ids is None:
        self.lane_ids = etsi_its_cam_ts_msgs.msg.MapemLaneList()
      if self.lane_ids_is_present is None:
        self.lane_ids_is_present = False
      if self.connection_ids is None:
        self.connection_ids = etsi_its_cam_ts_msgs.msg.MapemConnectionList()
      if self.connection_ids_is_present is None:
        self.connection_ids_is_present = False
    else:
      self.map_reference = etsi_its_cam_ts_msgs.msg.MapReference()
      self.map_reference_is_present = False
      self.lane_ids = etsi_its_cam_ts_msgs.msg.MapemLaneList()
      self.lane_ids_is_present = False
      self.connection_ids = etsi_its_cam_ts_msgs.msg.MapemConnectionList()
      self.connection_ids_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_BHB2HBHB().pack(_x.map_reference.choice, _x.map_reference.roadsegment.region.value, _x.map_reference.roadsegment.region_is_present, _x.map_reference.roadsegment.id.value, _x.map_reference.intersection.region.value, _x.map_reference.intersection.region_is_present, _x.map_reference.intersection.id.value, _x.map_reference_is_present))
      length = len(self.lane_ids.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.lane_ids.array:
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      _x = self.lane_ids_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.connection_ids.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.connection_ids.array:
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      _x = self.connection_ids_is_present
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.map_reference is None:
        self.map_reference = etsi_its_cam_ts_msgs.msg.MapReference()
      if self.lane_ids is None:
        self.lane_ids = etsi_its_cam_ts_msgs.msg.MapemLaneList()
      if self.connection_ids is None:
        self.connection_ids = etsi_its_cam_ts_msgs.msg.MapemConnectionList()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.map_reference.choice, _x.map_reference.roadsegment.region.value, _x.map_reference.roadsegment.region_is_present, _x.map_reference.roadsegment.id.value, _x.map_reference.intersection.region.value, _x.map_reference.intersection.region_is_present, _x.map_reference.intersection.id.value, _x.map_reference_is_present,) = _get_struct_BHB2HBHB().unpack(str[start:end])
      self.map_reference.roadsegment.region_is_present = bool(self.map_reference.roadsegment.region_is_present)
      self.map_reference.intersection.region_is_present = bool(self.map_reference.intersection.region_is_present)
      self.map_reference_is_present = bool(self.map_reference_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lane_ids.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.Identifier1B()
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        self.lane_ids.array.append(val1)
      start = end
      end += 1
      (self.lane_ids_is_present,) = _get_struct_B().unpack(str[start:end])
      self.lane_ids_is_present = bool(self.lane_ids_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.connection_ids.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.Identifier1B()
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        self.connection_ids.array.append(val1)
      start = end
      end += 1
      (self.connection_ids_is_present,) = _get_struct_B().unpack(str[start:end])
      self.connection_ids_is_present = bool(self.connection_ids_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_BHB2HBHB().pack(_x.map_reference.choice, _x.map_reference.roadsegment.region.value, _x.map_reference.roadsegment.region_is_present, _x.map_reference.roadsegment.id.value, _x.map_reference.intersection.region.value, _x.map_reference.intersection.region_is_present, _x.map_reference.intersection.id.value, _x.map_reference_is_present))
      length = len(self.lane_ids.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.lane_ids.array:
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      _x = self.lane_ids_is_present
      buff.write(_get_struct_B().pack(_x))
      length = len(self.connection_ids.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.connection_ids.array:
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      _x = self.connection_ids_is_present
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.map_reference is None:
        self.map_reference = etsi_its_cam_ts_msgs.msg.MapReference()
      if self.lane_ids is None:
        self.lane_ids = etsi_its_cam_ts_msgs.msg.MapemLaneList()
      if self.connection_ids is None:
        self.connection_ids = etsi_its_cam_ts_msgs.msg.MapemConnectionList()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.map_reference.choice, _x.map_reference.roadsegment.region.value, _x.map_reference.roadsegment.region_is_present, _x.map_reference.roadsegment.id.value, _x.map_reference.intersection.region.value, _x.map_reference.intersection.region_is_present, _x.map_reference.intersection.id.value, _x.map_reference_is_present,) = _get_struct_BHB2HBHB().unpack(str[start:end])
      self.map_reference.roadsegment.region_is_present = bool(self.map_reference.roadsegment.region_is_present)
      self.map_reference.intersection.region_is_present = bool(self.map_reference.intersection.region_is_present)
      self.map_reference_is_present = bool(self.map_reference_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lane_ids.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.Identifier1B()
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        self.lane_ids.array.append(val1)
      start = end
      end += 1
      (self.lane_ids_is_present,) = _get_struct_B().unpack(str[start:end])
      self.lane_ids_is_present = bool(self.lane_ids_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.connection_ids.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.Identifier1B()
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        self.connection_ids.array.append(val1)
      start = end
      end += 1
      (self.connection_ids_is_present,) = _get_struct_B().unpack(str[start:end])
      self.connection_ids_is_present = bool(self.connection_ids_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_BHB2HBHB = None
def _get_struct_BHB2HBHB():
    global _struct_BHB2HBHB
    if _struct_BHB2HBHB is None:
        _struct_BHB2HBHB = struct.Struct("<BHB2HBHB")
    return _struct_BHB2HBHB
