# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/MetaInformation.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class MetaInformation(genpy.Message):
  _md5sum = "76660bcc3b59dc12ea5d954fca2bb80f"
  _type = "etsi_its_cam_ts_msgs/MetaInformation"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MetaInformation::=SEQUENCE{		
#   usedDetectionInformation   SensorTypes, 
#   usedStoredInformation      StoredInformationType,
#   confidenceValue            ConfidenceLevel OPTIONAL,
#   ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF provides information about the source of and confidence in information.
# *
# * It shall include the following components: 
# * 
# * @field usedDetectionInformation: the type of sensor(s) that is used to provide the detection information.
# * 
# * @field usedStoredInformation: the type of source of the stored information. 
# *
# * @field confidenceValue: an optional confidence value associated to the information. 
# * 
# * @category: Basic information
# * @revision: Created in V2.2.1
#

SensorTypes used_detection_information

StoredInformationType used_stored_information

ConfidenceLevel confidence_value
bool confidence_value_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/SensorTypes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorTypes ::= BIT STRING {
#     undefined         (0),
#     radar             (1),
#     lidar             (2),
#     monovideo         (3),
#     stereovision      (4),
#     nightvision       (5),
#     ultrasonic        (6),
#     pmd               (7),
#     inductionLoop     (8),
#     sphericalCamera   (9),
#     uwb               (10),
#     acoustic          (11),
#     localAggregation  (12),
#     itsAggregation    (13)
# } (SIZE (16,... ))
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of sensor(s).
# * The corresponding bit shall be set to 1 under the following conditions:
# * 
# * - 0  `undefined`         - in case the sensor type is undefined. 
# * - 1  `radar`             - in case the sensor is a radar,
# * - 2  `lidar`             - in case the sensor is a lidar,
# * - 3  `monovideo`         - in case the sensor is mono video,
# * - 4  `stereovision`      - in case the sensor is stereo vision,
# * - 5  `nightvision`       - in case the sensor is night vision,
# * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
# * - 7  `pmd`               - in case the sensor is photonic mixing device,
# * - 8  `inductionLoop`     - in case the sensor is an induction loop,
# * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
# * - 10 `uwb`               - in case the sensor is ultra wide band,
# * - 11 `acoustic`          - in case the sensor is acoustic,
# * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
# * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
# * - 14-15                  - are reserved for future usage.
# * 
# * @note: If all bits are set to 0, then no sensor type is used
# *
# * @category: Sensing Information
# * @revision: created in V2.2.1
#

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 16
int64 MAX_SIZE_BITS = 16
uint8 BIT_INDEX_UNDEFINED = 0
uint8 BIT_INDEX_RADAR = 1
uint8 BIT_INDEX_LIDAR = 2
uint8 BIT_INDEX_MONOVIDEO = 3
uint8 BIT_INDEX_STEREOVISION = 4
uint8 BIT_INDEX_NIGHTVISION = 5
uint8 BIT_INDEX_ULTRASONIC = 6
uint8 BIT_INDEX_PMD = 7
uint8 BIT_INDEX_INDUCTION_LOOP = 8
uint8 BIT_INDEX_SPHERICAL_CAMERA = 9
uint8 BIT_INDEX_UWB = 10
uint8 BIT_INDEX_ACOUSTIC = 11
uint8 BIT_INDEX_LOCAL_AGGREGATION = 12
uint8 BIT_INDEX_ITS_AGGREGATION = 13

================================================================================
MSG: etsi_its_cam_ts_msgs/StoredInformationType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StoredInformationType::= BIT STRING {
#     undefined       (0),
#     staticDb	    (1),    
#     dynamicDb   	(2),
#     realTimeDb  	(3),
#     map		    	(4)	
# } (SIZE (8,... )) 
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of stored information.
# *
# * The corresponding bit shall be set to 1 under the following conditions:
# * 
# * - `0` undefined        - in case the stored information type is undefined. 
# * - `1` staticDb         - in case the stored information type is a static database.
# * - `2` dynamicDb        - in case the stored information type is a dynamic database
# * - `3` realTimeDb       - in case the stored information type is a real time updated database.
# * - `4` map              - in case the stored information type is a road topology map.
# * - Bits 5 to 7          - are reserved for future use.
# *
# * @note: If all bits are set to 0, then no stored information type is used
# *
# * @category: Basic Information
# * @revision: created in V2.2.1
#

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 8
int64 MAX_SIZE_BITS = 8
uint8 BIT_INDEX_UNDEFINED = 0
uint8 BIT_INDEX_STATIC_DB = 1
uint8 BIT_INDEX_DYNAMIC_DB = 2
uint8 BIT_INDEX_REAL_TIME_DB = 3
uint8 BIT_INDEX_MAP = 4

================================================================================
MSG: etsi_its_cam_ts_msgs/ConfidenceLevel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ConfidenceLevel ::= INTEGER {
#     unavailable (101)  
# } (1..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a confidence level in percentage.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
# * - `101`                   : in case the confidence level is not available.
# *
# * @unit Percent 
# * @category: Basic information 
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 101
uint8 UNAVAILABLE = 101
"""
  __slots__ = ['used_detection_information','used_stored_information','confidence_value','confidence_value_is_present']
  _slot_types = ['etsi_its_cam_ts_msgs/SensorTypes','etsi_its_cam_ts_msgs/StoredInformationType','etsi_its_cam_ts_msgs/ConfidenceLevel','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       used_detection_information,used_stored_information,confidence_value,confidence_value_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MetaInformation, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.used_detection_information is None:
        self.used_detection_information = etsi_its_cam_ts_msgs.msg.SensorTypes()
      if self.used_stored_information is None:
        self.used_stored_information = etsi_its_cam_ts_msgs.msg.StoredInformationType()
      if self.confidence_value is None:
        self.confidence_value = etsi_its_cam_ts_msgs.msg.ConfidenceLevel()
      if self.confidence_value_is_present is None:
        self.confidence_value_is_present = False
    else:
      self.used_detection_information = etsi_its_cam_ts_msgs.msg.SensorTypes()
      self.used_stored_information = etsi_its_cam_ts_msgs.msg.StoredInformationType()
      self.confidence_value = etsi_its_cam_ts_msgs.msg.ConfidenceLevel()
      self.confidence_value_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.used_detection_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.used_detection_information.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.used_stored_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.used_stored_information.bits_unused, _x.confidence_value.value, _x.confidence_value_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.used_detection_information is None:
        self.used_detection_information = etsi_its_cam_ts_msgs.msg.SensorTypes()
      if self.used_stored_information is None:
        self.used_stored_information = etsi_its_cam_ts_msgs.msg.StoredInformationType()
      if self.confidence_value is None:
        self.confidence_value = etsi_its_cam_ts_msgs.msg.ConfidenceLevel()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.used_detection_information.value = str[start:end]
      start = end
      end += 1
      (self.used_detection_information.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.used_stored_information.value = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.used_stored_information.bits_unused, _x.confidence_value.value, _x.confidence_value_is_present,) = _get_struct_3B().unpack(str[start:end])
      self.confidence_value_is_present = bool(self.confidence_value_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.used_detection_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.used_detection_information.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.used_stored_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.used_stored_information.bits_unused, _x.confidence_value.value, _x.confidence_value_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.used_detection_information is None:
        self.used_detection_information = etsi_its_cam_ts_msgs.msg.SensorTypes()
      if self.used_stored_information is None:
        self.used_stored_information = etsi_its_cam_ts_msgs.msg.StoredInformationType()
      if self.confidence_value is None:
        self.confidence_value = etsi_its_cam_ts_msgs.msg.ConfidenceLevel()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.used_detection_information.value = str[start:end]
      start = end
      end += 1
      (self.used_detection_information.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.used_stored_information.value = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.used_stored_information.bits_unused, _x.confidence_value.value, _x.confidence_value_is_present,) = _get_struct_3B().unpack(str[start:end])
      self.confidence_value_is_present = bool(self.confidence_value_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3B = None
def _get_struct_3B():
    global _struct_3B
    if _struct_3B is None:
        _struct_3B = struct.Struct("<3B")
    return _struct_3B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
