# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/OccupiedLanesWithConfidence.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class OccupiedLanesWithConfidence(genpy.Message):
  _md5sum = "72a6ec9d2e9d630fe51ce0332da0d128"
  _type = "etsi_its_cam_ts_msgs/OccupiedLanesWithConfidence"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# OccupiedLanesWithConfidence::= SEQUENCE {
#     lanePositionBased     SEQUENCE (SIZE(1..4)) OF LanePositionOptions,
#     mapBased              SEQUENCE (SIZE(1..4)) OF MapPosition  OPTIONAL,
#     confidence            MetaInformation,
#     ... 
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a set of lanes which are partially or fully occupied by an object or event at an externally defined reference position. 
# *
# * @note: In contrast to @ref GeneralizedLanePosition, the dimension of the object or event area (width and length) is taken into account to determine the occupancy, 
# * i.e. this DF describes the lanes which are blocked by an object or event and not the position of the object / event itself. A confidence is used to describe the 
# * probability that exactly all the provided lanes are occupied. 
# *
# * It shall include the following components: 
# *
# * @field lanePositionBased: a set of up to `4` lanes that are partially or fully occupied by an object or event, ordered by increasing value of @ref LanePosition. 
# * Lanes that are partially occupied can be described using the component lanePositionWithLateralDetails of @ref  Options, with the following constraints: 
# * The distance to lane borders which are covered by the object / event shall be set to 0. Only the distances to the leftmost and/or rightmost border which are not covered by 
# * the object / event shall be provided with values > 0. Those values shall be added to the respective instances of @ref LanePositionOptions, i.e. the first entry shall contain the component distanceToLeftBorder > 0 , 
# * and/or the last entry shall contain the component distanceToRightBorder > 0; the respective other components of these entries shall be set to 0.
# * 
# * @field mapBased: optional lane information described in the context of a MAPEM as specified in ETSI TS 103 301 [15]. 
# * If present, it shall describe the same lane(s) as listed in the component lanePositionBased, but using the lane identification of the MAPEM. This component can be used only if a 
# * MAPEM is available for the reference position (e.g. on an intersection): In this case it is used as a synonym to the mandatory component lanePositionBased. 
# *
# * @field confidence: mandatory confidence information for expressing the probability that all the provided lanes are occupied. It also provides information on how the lane 
# * information were generated. If none of the sensors were used, the lane information is assumed to be derived directly from the absolute reference position and the related dimension.
# *
# * @category: Road Topology information
# * @revision: Created in V2.2.1
# 

LanePositionOptions[] lane_position_based
uint8 LANE_POSITION_BASED_MIN_SIZE = 1
uint8 LANE_POSITION_BASED_MAX_SIZE = 4

MapPosition[] map_based
bool map_based_is_present
uint8 MAP_BASED_MIN_SIZE = 1
uint8 MAP_BASED_MAX_SIZE = 4

MetaInformation confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/LanePositionOptions
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePositionOptions ::= CHOICE {
#     simplelanePosition                   LanePosition,
#     simpleLaneType                       LaneType,
#     detailedlanePosition                 LanePositionAndType,
#     lanePositionWithLateralDetails       LanePositionWithLateralDetails,
#     trafficIslandPosition                TrafficIslandPosition,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a set of options to describe a lane position and is the second level DF to represent a lane position. The top-level DFs are @ref GeneralizedLanePosition or @ref OccupiedLanesWithConfidence. 
# * A lane position is a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway.
# *
# * The following options are available:
# *
# * @field simplelanePosition: a single lane position without any additional context information.
# *
# * @field simpleLaneType: a lane type, to be used when the lane position is unknown but the type of lane is known. This can be used in scenarios where a certain confidence about the used lane type is given 
# * but no or limited knowledge about the absolute lane number is available. For example, a cyclist on a cycle-lane or vehicles on a specific lane that is unique for the part of the road (e.g. a bus lane).
# * 
# * @field detailedlanePosition: a single lane position with additional lane details.
# * 
# * @field lanePositionWithLateralDetails: a single lane position with additional details and the lateral position within the lane.
# *
# * @field trafficIslandPosition: a position on a traffic island, i.e. between two lanes. 
# *
# * @category: Road Topology information
# * @revision: Created in V2.2.1 from the DF GeneralizedLanePosition of V2.1.1. 
# 

uint8 choice

LanePosition simplelane_position
uint8 CHOICE_SIMPLELANE_POSITION = 0

LaneType simple_lane_type
uint8 CHOICE_SIMPLE_LANE_TYPE = 1

LanePositionAndType detailedlane_position
uint8 CHOICE_DETAILEDLANE_POSITION = 2

LanePositionWithLateralDetails lane_position_with_lateral_details
uint8 CHOICE_LANE_POSITION_WITH_LATERAL_DETAILS = 3

TrafficIslandPosition traffic_island_position
uint8 CHOICE_TRAFFIC_ISLAND_POSITION = 4


================================================================================
MSG: etsi_its_cam_ts_msgs/LanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePosition ::= INTEGER {
#     offTheRoad           (-1), 
#     innerHardShoulder    (0), 
#     outerHardShoulder    (14) 
# } (-1..14)
# ------------------------------------------------------------------------------
# *
# * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
# *
# * For right-hand traffic roads, the value shall be set to:
# * - `-1` if the position is off, i.e. besides the road,
# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
# *
# * For left-hand traffic roads, the value shall be set to:
# * - `-1` if the position is off, i.e. besides the road,
# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
# *
# *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
# *
# * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
# * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
# * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
# *
# * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:
# * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the 
# *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.
# * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. 
# *   The remaining middle lane is assigned to both traffic directions as innermost lane.
# *
# * @category: Road topology information
# * @revision: Description of the legal separation of carriageways added in V2.2.1
#

int8 value
int8 MIN = -1
int8 MAX = 14
int8 OFF_THE_ROAD = -1
int8 INNER_HARD_SHOULDER = 0
int8 OUTER_HARD_SHOULDER = 14

================================================================================
MSG: etsi_its_cam_ts_msgs/LaneType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LaneType::= INTEGER{
# 	traffic              (0),
# 	through	             (1),
# 	reversible           (2),
# 	acceleration         (3),
# 	deceleration         (4),
# 	leftHandTurning      (5),
# 	rightHandTurning     (6),
# 	dedicatedVehicle     (7),
# 	bus                  (8),
# 	taxi                 (9),
# 	hov                  (10),
# 	hot                  (11),
# 	pedestrian           (12),
# 	cycleLane            (13),
# 	median               (14),   
# 	striping             (15),
# 	trackedVehicle       (16),
# 	parking	             (17),
# 	emergency            (18),
# 	verge                (19),
# 	minimumRiskManoeuvre (20),
#     exclusiveCycleLane   (21),
# 	unknown              (31)
# }(0..31)
# ------------------------------------------------------------------------------
# *
# * This DE represents the type of a lane. 
# * 
# * The value shall be set to:
# * - 0	- `traffic`            - Lane dedicated to the movement of vehicles,
# * - 1	- `through`            - Lane dedicated to the movement of vehicles travelling ahead and not turning,
# * - 2	- `reversible`         - Lane where the direction of traffic can be changed to match the peak flow,
# * - 3	- `acceleration`	   - Lane that allows vehicles entering a road to accelerate to the speed of through traffic before merging with it,
# * - 4	- `deceleration`       - Lane that allows vehicles exiting a road to decelerate before leaving it,
# * - 5	- `leftHandTurning`    - Lane reserved for slowing down and making a left turn, so as not to disrupt traffic,
# * - 6	- `rightHandTurning`   - Lane reserved for slowing down and making a right turn so as not to disrupt traffic,
# * - 7	- `dedicatedVehicle`   - Lane dedicated to movement of motor vehicles with specific characteristics, such as heavy goods vehicles, etc., 
# * - 8	- `bus`                - Lane dedicated to movement of buses providing public transport,
# * - 9	- `taxi`               - Lane dedicated to movement of taxis,
# * - 10	- `hov`                - Carpooling lane or high occupancy vehicle lane,
# * - 11	- `hot`                - High occupancy vehicle lanes that is allowed to be used without meeting the occupancy criteria by paying a toll,
# * - 12	- `pedestrian`         - Lanes dedicated to pedestrians such as pedestrian sidewalk paths,
# * - 13	- `cycleLane`	       - Lane dedicated to exclusive or preferred use by bicycles,
# * - 14	- `median`             - Lane not dedicated to movement of vehicles but representing a median / central reservation  such as the central median, 
#                                 separating the two directional carriageways of the highway,
# * - 15	- `striping`	       - Lane not dedicated to movement of vehicles but covered with roadway markings,
# * - 16	- `trackedVehicle`     - Lane dedicated to movement of trains, trams and trolleys,
# * - 17	- `parking`            - Lanes dedicated to vehicles parking, stopping and loading lanes,
# * - 18	- `emergency`          - Lane dedicated to vehicles in breakdown or to emergency vehicles also called hard shoulder,
# * - 19	- `verge`              - Lane representing the verge, i.e. a narrow strip of grass or plants and sometimes also trees located between 
#                                 the road surface edge and the boundary of a road,
# * - 20	`minimumRiskManoeuvre` - Lane dedicated to automated vehicles making a minimum risk manoeuvre,
# * - 21	`separatedCycleLane`   - Lane dedicated to exclusive or preferred use by bicycles that is phyisically separated from the vehicle-traffic lanes, e.g. by a verge.
# * - values 22 to 30             reserved for future use. 
# *
# * @category: Road topology information
# * @revision: Created in V2.1.1, named value 21 added in V2.2.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 31
uint8 TRAFFIC = 0
uint8 THROUGH = 1
uint8 REVERSIBLE = 2
uint8 ACCELERATION = 3
uint8 DECELERATION = 4
uint8 LEFT_HAND_TURNING = 5
uint8 RIGHT_HAND_TURNING = 6
uint8 DEDICATED_VEHICLE = 7
uint8 BUS = 8
uint8 TAXI = 9
uint8 HOV = 10
uint8 HOT = 11
uint8 PEDESTRIAN = 12
uint8 CYCLE_LANE = 13
uint8 MEDIAN = 14
uint8 STRIPING = 15
uint8 TRACKED_VEHICLE = 16
uint8 PARKING = 17
uint8 EMERGENCY = 18
uint8 VERGE = 19
uint8 MINIMUM_RISK_MANOEUVRE = 20
uint8 EXCLUSIVE_CYCLE_LANE = 21
uint8 UNKNOWN = 31

================================================================================
MSG: etsi_its_cam_ts_msgs/LanePositionAndType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePositionAndType::= SEQUENCE {
#     transversalPosition    LanePosition,
#     laneType               LaneType DEFAULT traffic,
#     direction              Direction DEFAULT sameDirection,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates a transversal position in resolution of lanes and other associated details.
# *
# * It shall include the following components: 
# * 
# * @field transversalPosition: the transversal position.
# * 
# * @field laneType: the type of the lane identified in the component transversalPosition. By default set to `traffic`.
# *
# * @field direction: the traffic direction for the lane position relative to a defined reference direction. By default set to `sameDirection`, i.e. following the reference direction.
# *
# * @category Road topology information
# * @revision: direction added in V2.2.1
# 

LanePosition transversal_position

LaneType lane_type

Direction direction


uint8 LANE_TYPE_DEFAULT = 0
uint8 DIRECTION_DEFAULT = 0

================================================================================
MSG: etsi_its_cam_ts_msgs/Direction
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Direction::= INTEGER{
#     sameDirection     (0),
#     oppositeDirection (1),
#     bothDirections    (2),
#     unavailable       (3)
#  } (0..3)
# ------------------------------------------------------------------------------
# *
# * This DE indicates a direction with respect to a defined reference direction.
# * Example: a reference direction may be implicitly defined by the definition of a geographical zone.
# *
# * The value shall be set to:
# * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,
# * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,
# * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,
# * - 3 - `unavailable`       - to indicate that the information is unavailable.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 3
uint8 SAME_DIRECTION = 0
uint8 OPPOSITE_DIRECTION = 1
uint8 BOTH_DIRECTIONS = 2
uint8 UNAVAILABLE = 3

================================================================================
MSG: etsi_its_cam_ts_msgs/LanePositionWithLateralDetails
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePositionWithLateralDetails ::= SEQUENCE {
#     COMPONENTS OF               LanePositionAndType,
#     distanceToLeftBorder        StandardLength9b,
#     distanceToRightBorder       StandardLength9b,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF is a third-level DF that represents a lane position and is an extended version of @ref LanePositionAndType that adds the distances to the left and right lane border.
# *
# * It shall additionally include the following components: 
# *
# * @field distanceToLeftBorder: the distance of the transversal position to the left lane border. The real value shall be rounded to the next lower encoding-value.
# *
# * @field distanceToRightBorder: the distance of the transversal position to the right lane border. The real value shall be rounded to the next lower encoding-value.
# * 
# * @category: Road Topology information
# * @revision: Created in V2.2.1
# 

StandardLength9b distance_to_left_border

StandardLength9b distance_to_right_border

LanePosition transversal_position

LaneType lane_type

Direction direction


uint8 LANE_TYPE_DEFAULT = 0
uint8 DIRECTION_DEFAULT = 0

================================================================================
MSG: etsi_its_cam_ts_msgs/StandardLength9b
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength9b::= INTEGER (0..511)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object. 
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 511


================================================================================
MSG: etsi_its_cam_ts_msgs/TrafficIslandPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# TrafficIslandPosition ::= SEQUENCE {
#     oneSide      LanePositionAndType,
#     otherSide    LanePositionAndType,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * Ths DF represents the a position on a traffic island between two lanes. 
# *
# * It shall include the following components: 
# *
# * @field oneSide: represents one lane.
# * 
# * @field otherSide: represents the other lane.
# * 
# * @category: Road Topology information
# * @revision: Created in V2.1.1
# 

LanePositionAndType one_side

LanePositionAndType other_side


================================================================================
MSG: etsi_its_cam_ts_msgs/MapPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapPosition ::= SEQUENCE {
#     mapReference                MapReference OPTIONAL,
#     laneId                      Identifier1B OPTIONAL,
#     connectionId                Identifier1B OPTIONAL, 
#     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# * 
# * @field mapReference: optionally identifies the MAPEM containing the topology information.
# * It is absent if the MAPEM topology is known from the context.
# * 
# * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
# *
# * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
# * conflict area of an intersection which connects e.g an ingress with an egress lane.
# *
# * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection measured from the start of the lane/connection, along the lane.
# * 
# * @category: Road topology information
# * @revision: Created in V2.1.1, definition of longitudinalLanePosition amended in V2.2.1
# 

MapReference map_reference
bool map_reference_is_present

Identifier1B lane_id
bool lane_id_is_present

Identifier1B connection_id
bool connection_id_is_present

LongitudinalLanePosition longitudinal_lane_position
bool longitudinal_lane_position_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
# *
# * The following options are provided:
# * 
# * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
# * 
# * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
# *
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for a road segment
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the road segment.
# *
# * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cam_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cam_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the intersection
# *
# * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cam_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cam_ts_msgs/LongitudinalLanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePosition ::= SEQUENCE {
#     longitudinalLanePositionValue         LongitudinalLanePositionValue,
#     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
# }
# ------------------------------------------------------------------------------
# * 
# * This DF represents the estimated position along the longitudinal extension of a carriageway or lane. 
# *
# * It shall include the following components: 
# *
# * @field  longitudinalLanePositionValue: the mean value of the longitudinal position along the carriageway or lane w.r.t. an externally defined start position.
# *
# * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
# *
# * @category: Road topology information
# * @revision: created in V2.1.1, description revised in V2.2.1
# 

LongitudinalLanePositionValue longitudinal_lane_position_value

LongitudinalLanePositionConfidence longitudinal_lane_position_confidence


================================================================================
MSG: etsi_its_cam_ts_msgs/LongitudinalLanePositionValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePositionValue ::= INTEGER {
#     outOfRange(32766),
#     unavailable(32767)
# }(0..32767)
# ------------------------------------------------------------------------------
# * 
# * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
# * 
# * The value shall be set to:
# * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
# * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
# * - `32 767` if the longitudinal offset information is not available. 
# *
# * @unit 0,1 metre
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 32767
uint16 OUT_OF_RANGE = 32766
uint16 UNAVAILABLE = 32767

================================================================================
MSG: etsi_its_cam_ts_msgs/LongitudinalLanePositionConfidence
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LongitudinalLanePositionConfidence ::= INTEGER {
#     outOfRange  (1022),
#     unavailable (1023)  
# } (0..1023)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
# * If required, the confidence level can be defined by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
# * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
# * - `1 023` if the confidence value is unavailable.
# *
# * @unit 0,1 metre
# * @category: GeoReference information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 1023
uint16 OUT_OF_RANGE = 1022
uint16 UNAVAILABLE = 1023

================================================================================
MSG: etsi_its_cam_ts_msgs/MetaInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MetaInformation::=SEQUENCE{		
#   usedDetectionInformation   SensorTypes, 
#   usedStoredInformation      StoredInformationType,
#   confidenceValue            ConfidenceLevel OPTIONAL,
#   ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF provides information about the source of and confidence in information.
# *
# * It shall include the following components: 
# * 
# * @field usedDetectionInformation: the type of sensor(s) that is used to provide the detection information.
# * 
# * @field usedStoredInformation: the type of source of the stored information. 
# *
# * @field confidenceValue: an optional confidence value associated to the information. 
# * 
# * @category: Basic information
# * @revision: Created in V2.2.1
#

SensorTypes used_detection_information

StoredInformationType used_stored_information

ConfidenceLevel confidence_value
bool confidence_value_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/SensorTypes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorTypes ::= BIT STRING {
#     undefined         (0),
#     radar             (1),
#     lidar             (2),
#     monovideo         (3),
#     stereovision      (4),
#     nightvision       (5),
#     ultrasonic        (6),
#     pmd               (7),
#     inductionLoop     (8),
#     sphericalCamera   (9),
#     uwb               (10),
#     acoustic          (11),
#     localAggregation  (12),
#     itsAggregation    (13)
# } (SIZE (16,... ))
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of sensor(s).
# * The corresponding bit shall be set to 1 under the following conditions:
# * 
# * - 0  `undefined`         - in case the sensor type is undefined. 
# * - 1  `radar`             - in case the sensor is a radar,
# * - 2  `lidar`             - in case the sensor is a lidar,
# * - 3  `monovideo`         - in case the sensor is mono video,
# * - 4  `stereovision`      - in case the sensor is stereo vision,
# * - 5  `nightvision`       - in case the sensor is night vision,
# * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
# * - 7  `pmd`               - in case the sensor is photonic mixing device,
# * - 8  `inductionLoop`     - in case the sensor is an induction loop,
# * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
# * - 10 `uwb`               - in case the sensor is ultra wide band,
# * - 11 `acoustic`          - in case the sensor is acoustic,
# * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
# * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
# * - 14-15                  - are reserved for future usage.
# * 
# * @note: If all bits are set to 0, then no sensor type is used
# *
# * @category: Sensing Information
# * @revision: created in V2.2.1
#

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 16
int64 MAX_SIZE_BITS = 16
uint8 BIT_INDEX_UNDEFINED = 0
uint8 BIT_INDEX_RADAR = 1
uint8 BIT_INDEX_LIDAR = 2
uint8 BIT_INDEX_MONOVIDEO = 3
uint8 BIT_INDEX_STEREOVISION = 4
uint8 BIT_INDEX_NIGHTVISION = 5
uint8 BIT_INDEX_ULTRASONIC = 6
uint8 BIT_INDEX_PMD = 7
uint8 BIT_INDEX_INDUCTION_LOOP = 8
uint8 BIT_INDEX_SPHERICAL_CAMERA = 9
uint8 BIT_INDEX_UWB = 10
uint8 BIT_INDEX_ACOUSTIC = 11
uint8 BIT_INDEX_LOCAL_AGGREGATION = 12
uint8 BIT_INDEX_ITS_AGGREGATION = 13

================================================================================
MSG: etsi_its_cam_ts_msgs/StoredInformationType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StoredInformationType::= BIT STRING {
#     undefined       (0),
#     staticDb	    (1),    
#     dynamicDb   	(2),
#     realTimeDb  	(3),
#     map		    	(4)	
# } (SIZE (8,... )) 
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of stored information.
# *
# * The corresponding bit shall be set to 1 under the following conditions:
# * 
# * - `0` undefined        - in case the stored information type is undefined. 
# * - `1` staticDb         - in case the stored information type is a static database.
# * - `2` dynamicDb        - in case the stored information type is a dynamic database
# * - `3` realTimeDb       - in case the stored information type is a real time updated database.
# * - `4` map              - in case the stored information type is a road topology map.
# * - Bits 5 to 7          - are reserved for future use.
# *
# * @note: If all bits are set to 0, then no stored information type is used
# *
# * @category: Basic Information
# * @revision: created in V2.2.1
#

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 8
int64 MAX_SIZE_BITS = 8
uint8 BIT_INDEX_UNDEFINED = 0
uint8 BIT_INDEX_STATIC_DB = 1
uint8 BIT_INDEX_DYNAMIC_DB = 2
uint8 BIT_INDEX_REAL_TIME_DB = 3
uint8 BIT_INDEX_MAP = 4

================================================================================
MSG: etsi_its_cam_ts_msgs/ConfidenceLevel
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# ConfidenceLevel ::= INTEGER {
#     unavailable (101)  
# } (1..101)
# ------------------------------------------------------------------------------
# * 
# * This DE represents a confidence level in percentage.
# * 
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
# * - `101`                   : in case the confidence level is not available.
# *
# * @unit Percent 
# * @category: Basic information 
# * @revision: Created in V2.1.1 
#

uint8 value
uint8 MIN = 1
uint8 MAX = 101
uint8 UNAVAILABLE = 101
"""
  # Pseudo-constants
  LANE_POSITION_BASED_MIN_SIZE = 1
  LANE_POSITION_BASED_MAX_SIZE = 4
  MAP_BASED_MIN_SIZE = 1
  MAP_BASED_MAX_SIZE = 4

  __slots__ = ['lane_position_based','map_based','map_based_is_present','confidence']
  _slot_types = ['etsi_its_cam_ts_msgs/LanePositionOptions[]','etsi_its_cam_ts_msgs/MapPosition[]','bool','etsi_its_cam_ts_msgs/MetaInformation']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       lane_position_based,map_based,map_based_is_present,confidence

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(OccupiedLanesWithConfidence, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.lane_position_based is None:
        self.lane_position_based = []
      if self.map_based is None:
        self.map_based = []
      if self.map_based_is_present is None:
        self.map_based_is_present = False
      if self.confidence is None:
        self.confidence = etsi_its_cam_ts_msgs.msg.MetaInformation()
    else:
      self.lane_position_based = []
      self.map_based = []
      self.map_based_is_present = False
      self.confidence = etsi_its_cam_ts_msgs.msg.MetaInformation()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.lane_position_based)
      buff.write(_struct_I.pack(length))
      for val1 in self.lane_position_based:
        _x = val1.choice
        buff.write(_get_struct_B().pack(_x))
        _v1 = val1.simplelane_position
        _x = _v1.value
        buff.write(_get_struct_b().pack(_x))
        _v2 = val1.simple_lane_type
        _x = _v2.value
        buff.write(_get_struct_B().pack(_x))
        _v3 = val1.detailedlane_position
        _v4 = _v3.transversal_position
        _x = _v4.value
        buff.write(_get_struct_b().pack(_x))
        _v5 = _v3.lane_type
        _x = _v5.value
        buff.write(_get_struct_B().pack(_x))
        _v6 = _v3.direction
        _x = _v6.value
        buff.write(_get_struct_B().pack(_x))
        _v7 = val1.lane_position_with_lateral_details
        _v8 = _v7.distance_to_left_border
        _x = _v8.value
        buff.write(_get_struct_H().pack(_x))
        _v9 = _v7.distance_to_right_border
        _x = _v9.value
        buff.write(_get_struct_H().pack(_x))
        _v10 = _v7.transversal_position
        _x = _v10.value
        buff.write(_get_struct_b().pack(_x))
        _v11 = _v7.lane_type
        _x = _v11.value
        buff.write(_get_struct_B().pack(_x))
        _v12 = _v7.direction
        _x = _v12.value
        buff.write(_get_struct_B().pack(_x))
        _v13 = val1.traffic_island_position
        _v14 = _v13.one_side
        _v15 = _v14.transversal_position
        _x = _v15.value
        buff.write(_get_struct_b().pack(_x))
        _v16 = _v14.lane_type
        _x = _v16.value
        buff.write(_get_struct_B().pack(_x))
        _v17 = _v14.direction
        _x = _v17.value
        buff.write(_get_struct_B().pack(_x))
        _v18 = _v13.other_side
        _v19 = _v18.transversal_position
        _x = _v19.value
        buff.write(_get_struct_b().pack(_x))
        _v20 = _v18.lane_type
        _x = _v20.value
        buff.write(_get_struct_B().pack(_x))
        _v21 = _v18.direction
        _x = _v21.value
        buff.write(_get_struct_B().pack(_x))
      length = len(self.map_based)
      buff.write(_struct_I.pack(length))
      for val1 in self.map_based:
        _v22 = val1.map_reference
        _x = _v22.choice
        buff.write(_get_struct_B().pack(_x))
        _v23 = _v22.roadsegment
        _v24 = _v23.region
        _x = _v24.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v23.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v25 = _v23.id
        _x = _v25.value
        buff.write(_get_struct_H().pack(_x))
        _v26 = _v22.intersection
        _v27 = _v26.region
        _x = _v27.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v26.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v28 = _v26.id
        _x = _v28.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v29 = val1.lane_id
        _x = _v29.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v30 = val1.connection_id
        _x = _v30.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v31 = val1.longitudinal_lane_position
        _v32 = _v31.longitudinal_lane_position_value
        _x = _v32.value
        buff.write(_get_struct_H().pack(_x))
        _v33 = _v31.longitudinal_lane_position_confidence
        _x = _v33.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.map_based_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.confidence.used_detection_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.confidence.used_detection_information.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.confidence.used_stored_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.confidence.used_stored_information.bits_unused, _x.confidence.confidence_value.value, _x.confidence.confidence_value_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.lane_position_based is None:
        self.lane_position_based = None
      if self.map_based is None:
        self.map_based = None
      if self.confidence is None:
        self.confidence = etsi_its_cam_ts_msgs.msg.MetaInformation()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lane_position_based = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.LanePositionOptions()
        start = end
        end += 1
        (val1.choice,) = _get_struct_B().unpack(str[start:end])
        _v34 = val1.simplelane_position
        start = end
        end += 1
        (_v34.value,) = _get_struct_b().unpack(str[start:end])
        _v35 = val1.simple_lane_type
        start = end
        end += 1
        (_v35.value,) = _get_struct_B().unpack(str[start:end])
        _v36 = val1.detailedlane_position
        _v37 = _v36.transversal_position
        start = end
        end += 1
        (_v37.value,) = _get_struct_b().unpack(str[start:end])
        _v38 = _v36.lane_type
        start = end
        end += 1
        (_v38.value,) = _get_struct_B().unpack(str[start:end])
        _v39 = _v36.direction
        start = end
        end += 1
        (_v39.value,) = _get_struct_B().unpack(str[start:end])
        _v40 = val1.lane_position_with_lateral_details
        _v41 = _v40.distance_to_left_border
        start = end
        end += 2
        (_v41.value,) = _get_struct_H().unpack(str[start:end])
        _v42 = _v40.distance_to_right_border
        start = end
        end += 2
        (_v42.value,) = _get_struct_H().unpack(str[start:end])
        _v43 = _v40.transversal_position
        start = end
        end += 1
        (_v43.value,) = _get_struct_b().unpack(str[start:end])
        _v44 = _v40.lane_type
        start = end
        end += 1
        (_v44.value,) = _get_struct_B().unpack(str[start:end])
        _v45 = _v40.direction
        start = end
        end += 1
        (_v45.value,) = _get_struct_B().unpack(str[start:end])
        _v46 = val1.traffic_island_position
        _v47 = _v46.one_side
        _v48 = _v47.transversal_position
        start = end
        end += 1
        (_v48.value,) = _get_struct_b().unpack(str[start:end])
        _v49 = _v47.lane_type
        start = end
        end += 1
        (_v49.value,) = _get_struct_B().unpack(str[start:end])
        _v50 = _v47.direction
        start = end
        end += 1
        (_v50.value,) = _get_struct_B().unpack(str[start:end])
        _v51 = _v46.other_side
        _v52 = _v51.transversal_position
        start = end
        end += 1
        (_v52.value,) = _get_struct_b().unpack(str[start:end])
        _v53 = _v51.lane_type
        start = end
        end += 1
        (_v53.value,) = _get_struct_B().unpack(str[start:end])
        _v54 = _v51.direction
        start = end
        end += 1
        (_v54.value,) = _get_struct_B().unpack(str[start:end])
        self.lane_position_based.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.map_based = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.MapPosition()
        _v55 = val1.map_reference
        start = end
        end += 1
        (_v55.choice,) = _get_struct_B().unpack(str[start:end])
        _v56 = _v55.roadsegment
        _v57 = _v56.region
        start = end
        end += 2
        (_v57.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v56.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v56.region_is_present = bool(_v56.region_is_present)
        _v58 = _v56.id
        start = end
        end += 2
        (_v58.value,) = _get_struct_H().unpack(str[start:end])
        _v59 = _v55.intersection
        _v60 = _v59.region
        start = end
        end += 2
        (_v60.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v59.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v59.region_is_present = bool(_v59.region_is_present)
        _v61 = _v59.id
        start = end
        end += 2
        (_v61.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_reference_is_present = bool(val1.map_reference_is_present)
        _v62 = val1.lane_id
        start = end
        end += 1
        (_v62.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lane_id_is_present = bool(val1.lane_id_is_present)
        _v63 = val1.connection_id
        start = end
        end += 1
        (_v63.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.connection_id_is_present = bool(val1.connection_id_is_present)
        _v64 = val1.longitudinal_lane_position
        _v65 = _v64.longitudinal_lane_position_value
        start = end
        end += 2
        (_v65.value,) = _get_struct_H().unpack(str[start:end])
        _v66 = _v64.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v66.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.longitudinal_lane_position_is_present = bool(val1.longitudinal_lane_position_is_present)
        self.map_based.append(val1)
      start = end
      end += 1
      (self.map_based_is_present,) = _get_struct_B().unpack(str[start:end])
      self.map_based_is_present = bool(self.map_based_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.confidence.used_detection_information.value = str[start:end]
      start = end
      end += 1
      (self.confidence.used_detection_information.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.confidence.used_stored_information.value = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.confidence.used_stored_information.bits_unused, _x.confidence.confidence_value.value, _x.confidence.confidence_value_is_present,) = _get_struct_3B().unpack(str[start:end])
      self.confidence.confidence_value_is_present = bool(self.confidence.confidence_value_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.lane_position_based)
      buff.write(_struct_I.pack(length))
      for val1 in self.lane_position_based:
        _x = val1.choice
        buff.write(_get_struct_B().pack(_x))
        _v67 = val1.simplelane_position
        _x = _v67.value
        buff.write(_get_struct_b().pack(_x))
        _v68 = val1.simple_lane_type
        _x = _v68.value
        buff.write(_get_struct_B().pack(_x))
        _v69 = val1.detailedlane_position
        _v70 = _v69.transversal_position
        _x = _v70.value
        buff.write(_get_struct_b().pack(_x))
        _v71 = _v69.lane_type
        _x = _v71.value
        buff.write(_get_struct_B().pack(_x))
        _v72 = _v69.direction
        _x = _v72.value
        buff.write(_get_struct_B().pack(_x))
        _v73 = val1.lane_position_with_lateral_details
        _v74 = _v73.distance_to_left_border
        _x = _v74.value
        buff.write(_get_struct_H().pack(_x))
        _v75 = _v73.distance_to_right_border
        _x = _v75.value
        buff.write(_get_struct_H().pack(_x))
        _v76 = _v73.transversal_position
        _x = _v76.value
        buff.write(_get_struct_b().pack(_x))
        _v77 = _v73.lane_type
        _x = _v77.value
        buff.write(_get_struct_B().pack(_x))
        _v78 = _v73.direction
        _x = _v78.value
        buff.write(_get_struct_B().pack(_x))
        _v79 = val1.traffic_island_position
        _v80 = _v79.one_side
        _v81 = _v80.transversal_position
        _x = _v81.value
        buff.write(_get_struct_b().pack(_x))
        _v82 = _v80.lane_type
        _x = _v82.value
        buff.write(_get_struct_B().pack(_x))
        _v83 = _v80.direction
        _x = _v83.value
        buff.write(_get_struct_B().pack(_x))
        _v84 = _v79.other_side
        _v85 = _v84.transversal_position
        _x = _v85.value
        buff.write(_get_struct_b().pack(_x))
        _v86 = _v84.lane_type
        _x = _v86.value
        buff.write(_get_struct_B().pack(_x))
        _v87 = _v84.direction
        _x = _v87.value
        buff.write(_get_struct_B().pack(_x))
      length = len(self.map_based)
      buff.write(_struct_I.pack(length))
      for val1 in self.map_based:
        _v88 = val1.map_reference
        _x = _v88.choice
        buff.write(_get_struct_B().pack(_x))
        _v89 = _v88.roadsegment
        _v90 = _v89.region
        _x = _v90.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v89.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v91 = _v89.id
        _x = _v91.value
        buff.write(_get_struct_H().pack(_x))
        _v92 = _v88.intersection
        _v93 = _v92.region
        _x = _v93.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v92.region_is_present
        buff.write(_get_struct_B().pack(_x))
        _v94 = _v92.id
        _x = _v94.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.map_reference_is_present
        buff.write(_get_struct_B().pack(_x))
        _v95 = val1.lane_id
        _x = _v95.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.lane_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v96 = val1.connection_id
        _x = _v96.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.connection_id_is_present
        buff.write(_get_struct_B().pack(_x))
        _v97 = val1.longitudinal_lane_position
        _v98 = _v97.longitudinal_lane_position_value
        _x = _v98.value
        buff.write(_get_struct_H().pack(_x))
        _v99 = _v97.longitudinal_lane_position_confidence
        _x = _v99.value
        buff.write(_get_struct_H().pack(_x))
        _x = val1.longitudinal_lane_position_is_present
        buff.write(_get_struct_B().pack(_x))
      _x = self.map_based_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.confidence.used_detection_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.confidence.used_detection_information.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.confidence.used_stored_information.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.confidence.used_stored_information.bits_unused, _x.confidence.confidence_value.value, _x.confidence.confidence_value_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.lane_position_based is None:
        self.lane_position_based = None
      if self.map_based is None:
        self.map_based = None
      if self.confidence is None:
        self.confidence = etsi_its_cam_ts_msgs.msg.MetaInformation()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lane_position_based = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.LanePositionOptions()
        start = end
        end += 1
        (val1.choice,) = _get_struct_B().unpack(str[start:end])
        _v100 = val1.simplelane_position
        start = end
        end += 1
        (_v100.value,) = _get_struct_b().unpack(str[start:end])
        _v101 = val1.simple_lane_type
        start = end
        end += 1
        (_v101.value,) = _get_struct_B().unpack(str[start:end])
        _v102 = val1.detailedlane_position
        _v103 = _v102.transversal_position
        start = end
        end += 1
        (_v103.value,) = _get_struct_b().unpack(str[start:end])
        _v104 = _v102.lane_type
        start = end
        end += 1
        (_v104.value,) = _get_struct_B().unpack(str[start:end])
        _v105 = _v102.direction
        start = end
        end += 1
        (_v105.value,) = _get_struct_B().unpack(str[start:end])
        _v106 = val1.lane_position_with_lateral_details
        _v107 = _v106.distance_to_left_border
        start = end
        end += 2
        (_v107.value,) = _get_struct_H().unpack(str[start:end])
        _v108 = _v106.distance_to_right_border
        start = end
        end += 2
        (_v108.value,) = _get_struct_H().unpack(str[start:end])
        _v109 = _v106.transversal_position
        start = end
        end += 1
        (_v109.value,) = _get_struct_b().unpack(str[start:end])
        _v110 = _v106.lane_type
        start = end
        end += 1
        (_v110.value,) = _get_struct_B().unpack(str[start:end])
        _v111 = _v106.direction
        start = end
        end += 1
        (_v111.value,) = _get_struct_B().unpack(str[start:end])
        _v112 = val1.traffic_island_position
        _v113 = _v112.one_side
        _v114 = _v113.transversal_position
        start = end
        end += 1
        (_v114.value,) = _get_struct_b().unpack(str[start:end])
        _v115 = _v113.lane_type
        start = end
        end += 1
        (_v115.value,) = _get_struct_B().unpack(str[start:end])
        _v116 = _v113.direction
        start = end
        end += 1
        (_v116.value,) = _get_struct_B().unpack(str[start:end])
        _v117 = _v112.other_side
        _v118 = _v117.transversal_position
        start = end
        end += 1
        (_v118.value,) = _get_struct_b().unpack(str[start:end])
        _v119 = _v117.lane_type
        start = end
        end += 1
        (_v119.value,) = _get_struct_B().unpack(str[start:end])
        _v120 = _v117.direction
        start = end
        end += 1
        (_v120.value,) = _get_struct_B().unpack(str[start:end])
        self.lane_position_based.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.map_based = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.MapPosition()
        _v121 = val1.map_reference
        start = end
        end += 1
        (_v121.choice,) = _get_struct_B().unpack(str[start:end])
        _v122 = _v121.roadsegment
        _v123 = _v122.region
        start = end
        end += 2
        (_v123.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v122.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v122.region_is_present = bool(_v122.region_is_present)
        _v124 = _v122.id
        start = end
        end += 2
        (_v124.value,) = _get_struct_H().unpack(str[start:end])
        _v125 = _v121.intersection
        _v126 = _v125.region
        start = end
        end += 2
        (_v126.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v125.region_is_present,) = _get_struct_B().unpack(str[start:end])
        _v125.region_is_present = bool(_v125.region_is_present)
        _v127 = _v125.id
        start = end
        end += 2
        (_v127.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.map_reference_is_present = bool(val1.map_reference_is_present)
        _v128 = val1.lane_id
        start = end
        end += 1
        (_v128.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.lane_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lane_id_is_present = bool(val1.lane_id_is_present)
        _v129 = val1.connection_id
        start = end
        end += 1
        (_v129.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.connection_id_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.connection_id_is_present = bool(val1.connection_id_is_present)
        _v130 = val1.longitudinal_lane_position
        _v131 = _v130.longitudinal_lane_position_value
        start = end
        end += 2
        (_v131.value,) = _get_struct_H().unpack(str[start:end])
        _v132 = _v130.longitudinal_lane_position_confidence
        start = end
        end += 2
        (_v132.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (val1.longitudinal_lane_position_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.longitudinal_lane_position_is_present = bool(val1.longitudinal_lane_position_is_present)
        self.map_based.append(val1)
      start = end
      end += 1
      (self.map_based_is_present,) = _get_struct_B().unpack(str[start:end])
      self.map_based_is_present = bool(self.map_based_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.confidence.used_detection_information.value = str[start:end]
      start = end
      end += 1
      (self.confidence.used_detection_information.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.confidence.used_stored_information.value = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.confidence.used_stored_information.bits_unused, _x.confidence.confidence_value.value, _x.confidence.confidence_value_is_present,) = _get_struct_3B().unpack(str[start:end])
      self.confidence.confidence_value_is_present = bool(self.confidence.confidence_value_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3B = None
def _get_struct_3B():
    global _struct_3B
    if _struct_3B is None:
        _struct_3B = struct.Struct("<3B")
    return _struct_3B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
