# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/PathDeltaTimeChoice.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class PathDeltaTimeChoice(genpy.Message):
  _md5sum = "02d5a94d9e94bf5c16a773a80e5f89e3"
  _type = "etsi_its_cam_ts_msgs/PathDeltaTimeChoice"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PathDeltaTimeChoice::= CHOICE {
#     deltaTimeHighPrecision	DeltaTimeTenthOfSecond,
#     deltaTimeBigRange	    DeltaTimeTenSeconds,
#     ...
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents estimated/predicted travel time between a position and a predefined reference position. 
# *
# * the following options are available:
# * 
# * @field deltaTimeHighPrecision: delta time with precision of 0,1 s.
# *
# * @field deltaTimeBigRange: delta time with precision of 10 s.
# *
# * @category: Basic information
# * @revision: Created in V2.2.1
# 

uint8 choice

DeltaTimeTenthOfSecond delta_time_high_precision
uint8 CHOICE_DELTA_TIME_HIGH_PRECISION = 0

DeltaTimeTenSeconds delta_time_big_range
uint8 CHOICE_DELTA_TIME_BIG_RANGE = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/DeltaTimeTenthOfSecond
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaTimeTenthOfSecond::= INTEGER {
#     unavailable (127)  
# } (0..127) 
# ------------------------------------------------------------------------------
# * 
# * This DE represents a difference in time with respect to a reference time.
# *
# * The value shall be set to:
# * - `0` for a difference in time of 0 seconds. 
# * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 0,1 s, and greater than (n-1) x 0,1 s,
# *
# * @unit: 0,1 s
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 127
uint8 UNAVAILABLE = 127

================================================================================
MSG: etsi_its_cam_ts_msgs/DeltaTimeTenSeconds
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DeltaTimeTenSeconds ::= INTEGER  (0..127)  
# ------------------------------------------------------------------------------
# *
# * This DE represents a difference in time with respect to a reference time.
# *
# * The value shall be set to:
# * - `-0` for a difference in time of 0 seconds. 
# * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 10 s, and greater than (n-1) x 10 s,
# *
# * @unit: 10 s
# * @category: Basic information
# * @revision: Created in V2.2.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 127

"""
  # Pseudo-constants
  CHOICE_DELTA_TIME_HIGH_PRECISION = 0
  CHOICE_DELTA_TIME_BIG_RANGE = 1

  __slots__ = ['choice','delta_time_high_precision','delta_time_big_range']
  _slot_types = ['uint8','etsi_its_cam_ts_msgs/DeltaTimeTenthOfSecond','etsi_its_cam_ts_msgs/DeltaTimeTenSeconds']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       choice,delta_time_high_precision,delta_time_big_range

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PathDeltaTimeChoice, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.choice is None:
        self.choice = 0
      if self.delta_time_high_precision is None:
        self.delta_time_high_precision = etsi_its_cam_ts_msgs.msg.DeltaTimeTenthOfSecond()
      if self.delta_time_big_range is None:
        self.delta_time_big_range = etsi_its_cam_ts_msgs.msg.DeltaTimeTenSeconds()
    else:
      self.choice = 0
      self.delta_time_high_precision = etsi_its_cam_ts_msgs.msg.DeltaTimeTenthOfSecond()
      self.delta_time_big_range = etsi_its_cam_ts_msgs.msg.DeltaTimeTenSeconds()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3B().pack(_x.choice, _x.delta_time_high_precision.value, _x.delta_time_big_range.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.delta_time_high_precision is None:
        self.delta_time_high_precision = etsi_its_cam_ts_msgs.msg.DeltaTimeTenthOfSecond()
      if self.delta_time_big_range is None:
        self.delta_time_big_range = etsi_its_cam_ts_msgs.msg.DeltaTimeTenSeconds()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.choice, _x.delta_time_high_precision.value, _x.delta_time_big_range.value,) = _get_struct_3B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3B().pack(_x.choice, _x.delta_time_high_precision.value, _x.delta_time_big_range.value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.delta_time_high_precision is None:
        self.delta_time_high_precision = etsi_its_cam_ts_msgs.msg.DeltaTimeTenthOfSecond()
      if self.delta_time_big_range is None:
        self.delta_time_big_range = etsi_its_cam_ts_msgs.msg.DeltaTimeTenSeconds()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.choice, _x.delta_time_high_precision.value, _x.delta_time_big_range.value,) = _get_struct_3B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3B = None
def _get_struct_3B():
    global _struct_3B
    if _struct_3B is None:
        _struct_3B = struct.Struct("<3B")
    return _struct_3B
