# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/PathId.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class PathId(genpy.Message):
  _md5sum = "98a1f204dff2dea05c28f659b99d9f0e"
  _type = "etsi_its_cam_ts_msgs/PathId"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PathId ::= INTEGER {
#     noPath        (0),
#     path1         (1),
#     path2         (2),
#     path3         (3),
#     path4         (4),
#     path5         (5),
#     path6         (6),
#     path7         (7),
#     pathExtended1 (8),
#     pathExtended2 (9),
#     pathExtended3 (10),
#     pathExtended4 (11),
#     pathExtended5 (12),
#     pathExtended6 (13),
#     pathExtended7 (14)
# } (0..14)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates an ordinal number that represents the position of a component in the list of @ref Traces or @ref TracesExtended. 
# *
# * The value shall be set to:
# * - `0` - noPath  - if no path is identified
# * - `1..7`        - for instances 1..7 of @ref Traces 
# * - `8..14`       - for instances 1..7 of @ref TracesExtended. 
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 14
uint8 NO_PATH = 0
uint8 PATH1 = 1
uint8 PATH2 = 2
uint8 PATH3 = 3
uint8 PATH4 = 4
uint8 PATH5 = 5
uint8 PATH6 = 6
uint8 PATH7 = 7
uint8 PATH_EXTENDED1 = 8
uint8 PATH_EXTENDED2 = 9
uint8 PATH_EXTENDED3 = 10
uint8 PATH_EXTENDED4 = 11
uint8 PATH_EXTENDED5 = 12
uint8 PATH_EXTENDED6 = 13
uint8 PATH_EXTENDED7 = 14
"""
  # Pseudo-constants
  MIN = 0
  MAX = 14
  NO_PATH = 0
  PATH1 = 1
  PATH2 = 2
  PATH3 = 3
  PATH4 = 4
  PATH5 = 5
  PATH6 = 6
  PATH7 = 7
  PATH_EXTENDED1 = 8
  PATH_EXTENDED2 = 9
  PATH_EXTENDED3 = 10
  PATH_EXTENDED4 = 11
  PATH_EXTENDED5 = 12
  PATH_EXTENDED6 = 13
  PATH_EXTENDED7 = 14

  __slots__ = ['value']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PathId, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = 0
    else:
      self.value = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.value,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
