# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/RoadConfigurationSectionList.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class RoadConfigurationSectionList(genpy.Message):
  _md5sum = "d83c021b44c9daa41724932602ca61c0"
  _type = "etsi_its_cam_ts_msgs/RoadConfigurationSectionList"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadConfigurationSectionList::=  SEQUENCE (SIZE(1..8,...))  OF RoadConfigurationSection
# ------------------------------------------------------------------------------
# *
# * This DF shall contain a list of @ref RoadConfigurationSection.
# * 
# * @category: Road Topology information
# * @revision: Created in V2.2.1
# 

RoadConfigurationSection[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cam_ts_msgs/RoadConfigurationSection
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadConfigurationSection ::= SEQUENCE {
#   roadSectionDefinition  RoadSectionDefinition,
#   roadType               RoadType OPTIONAL, 
#   laneConfiguration      BasicLaneConfiguration OPTIONAL,
#   mapemConfiguration     MapemConfiguration OPTIONAL,
#   ...
# } 
# ------------------------------------------------------------------------------
# * 
# * This DF provides configuration information about a road section.
# *
# * It shall include the following components: 
# *
# * @field roadSectionDefinition: the topological definition of the road section for which the information in the other components applies throughout its entire length.
# * 
# * @field roadType: the optional type of road on which the section is located.
# * 
# * @field laneConfiguration: the optional configuration of the road section in terms of basic information per lane.
# *
# * @field mapemConfiguration: the optional configuration of the road section in terms of MAPEM lanes or connections.
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

RoadSectionDefinition road_section_definition

RoadType road_type
bool road_type_is_present

BasicLaneConfiguration lane_configuration
bool lane_configuration_is_present

MapemConfiguration mapem_configuration
bool mapem_configuration_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadSectionDefinition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSectionDefinition::= SEQUENCE {
#   startingPointSection      GeoPosition,
#   lengthOfSection	  	    StandardLength2B OPTIONAL,
#   endingPointSection       	GeoPosition OPTIONAL, 
#   connectedPaths		    PathReferences,	
#   includedPaths          	PathReferences,
#   isEventZoneIncluded       BOOLEAN,  
#   isEventZoneConnected      BOOLEAN,
#   ...
# }  
# ------------------------------------------------------------------------------
# * 
# * This DF provides the basic topological definition of a road section.
# *
# * It shall include the following components: 
# * 
# * @field startingPointSection: the position of the starting point of the section. 
# * 
# * @field lengthOfSection: the optional length of the section along the road profile (i.e. including curves).
# * 
# * @field endingPointSection: the optional position of the ending point of the section. 
# * If this component is absent, the ending position is implicitly defined by other means, e.g. the starting point of the next RoadConfigurationSection, or the section�s length.
# *
# * @field connectedPaths: the identifier(s) of the path(s) having one or an ordered subset of waypoints located upstream of the RoadConfigurationSection� starting point. 
# * 
# * @field includedPaths: the identifier(s) of the path(s) that covers (either with all its length or with a part of it) a RoadConfigurationSection. 
# *
# * @field isEventZoneIncluded: indicates, if set to TRUE, that the @ref EventZone incl. its reference position covers a RoadConfigurationSection (either with all its length or with a part of it). 
# * 
# * @field isEventZoneConnected: indicates, if set to TRUE, that the @ref EventZone incl. its reference position has one or an ordered subset of waypoints located upstream of the RoadConfigurationSection� starting point.
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

GeoPosition starting_point_section

StandardLength2B length_of_section
bool length_of_section_is_present

GeoPosition ending_point_section
bool ending_point_section_is_present

PathReferences connected_paths

PathReferences included_paths

bool is_event_zone_included

bool is_event_zone_connected


================================================================================
MSG: etsi_its_cam_ts_msgs/GeoPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# GeoPosition::= SEQUENCE{
# 	latitude   Latitude,
# 	longitude  Longitude,
#     altitude   AltitudeValue DEFAULT unavailable
# }
# ------------------------------------------------------------------------------
# * 
# * This DF indicates a geographical position.
# *
# * It shall include the following components: 
# *
# * @field latitude: the latitude of the geographical position.
# *
# * @field longitude: the longitude of the geographical position.
# *
# * @field altitude: the altitude of the geographical position with default value unavailable.
# *
#

Latitude latitude

Longitude longitude

AltitudeValue altitude


int32 ALTITUDE_DEFAULT = 800001

================================================================================
MSG: etsi_its_cam_ts_msgs/Latitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Latitude ::= INTEGER {
#     unavailable(900000001)
# } (-900000000..900000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
# * in south hemisphere.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
# * - `0` is used for the latitude of the equator,
# * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
# * - `900 000 001` when the information is unavailable.
# *
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Editorial update in V2.1.1
# 

int32 value
int32 MIN = -900000000
int32 MAX = 900000001
int32 UNAVAILABLE = 900000001

================================================================================
MSG: etsi_its_cam_ts_msgs/Longitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Longitude ::= INTEGER {
#     valueNotUsed (-1800000000),
#     unavailable  (1800000001)
# } (-1800000000..1800000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
# * to the east or to the west of the prime meridian.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
# * - `0` to indicate the prime meridian,
# * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
# * - `1 800 000 001` when the information is unavailable.
# *
# * The value -1 800 000 000 shall not be used. 
# * 
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1
# 

int32 value
int32 MIN = -1800000000
int32 MAX = 1800000001
int32 VALUE_NOT_USED = -1800000000
int32 UNAVAILABLE = 1800000001

================================================================================
MSG: etsi_its_cam_ts_msgs/AltitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AltitudeValue ::= INTEGER {
#     negativeOutOfRange (-100000),
#     postiveOutOfRange  (800000),
#     unavailable        (800001)
# } (-100000..800001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the altitude value in a WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `-100 000` if the altitude is equal to or less than -1 000 m,
# * - `n` (`n > -100 000` and `n < 800 000`) if the altitude is equal to or less than n  x 0,01 metre and greater than (n-1) x 0,01 metre,
# * - `800 000` if the altitude  greater than 7 999,99 m,
# * - `800 001` if the information is not available.
# *
# * @note: the range of this DE does not use the full binary encoding range, but all reasonable values are covered. In order to cover all possible altitude ranges a larger encoding would be necessary.
# * @unit: 0,01 metre
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1 (definition of 800 000 has slightly changed) 
# 

int32 value
int32 MIN = -100000
int32 MAX = 800001
int32 NEGATIVE_OUT_OF_RANGE = -100000
int32 POSTIVE_OUT_OF_RANGE = 800000
int32 UNAVAILABLE = 800001

================================================================================
MSG: etsi_its_cam_ts_msgs/StandardLength2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength2B::= INTEGER (0..65535)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object.  
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cam_ts_msgs/PathReferences
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PathReferences ::= SEQUENCE (SIZE(1..14)) OF PathId
# ------------------------------------------------------------------------------
# * 
# * This DF represents a list of references to the components of a @ref Traces or @ref TracesExtended DF using the @ref PathId. 
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

PathId[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 14

================================================================================
MSG: etsi_its_cam_ts_msgs/PathId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PathId ::= INTEGER {
#     noPath        (0),
#     path1         (1),
#     path2         (2),
#     path3         (3),
#     path4         (4),
#     path5         (5),
#     path6         (6),
#     path7         (7),
#     pathExtended1 (8),
#     pathExtended2 (9),
#     pathExtended3 (10),
#     pathExtended4 (11),
#     pathExtended5 (12),
#     pathExtended6 (13),
#     pathExtended7 (14)
# } (0..14)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates an ordinal number that represents the position of a component in the list of @ref Traces or @ref TracesExtended. 
# *
# * The value shall be set to:
# * - `0` - noPath  - if no path is identified
# * - `1..7`        - for instances 1..7 of @ref Traces 
# * - `8..14`       - for instances 1..7 of @ref TracesExtended. 
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 14
uint8 NO_PATH = 0
uint8 PATH1 = 1
uint8 PATH2 = 2
uint8 PATH3 = 3
uint8 PATH4 = 4
uint8 PATH5 = 5
uint8 PATH6 = 6
uint8 PATH7 = 7
uint8 PATH_EXTENDED1 = 8
uint8 PATH_EXTENDED2 = 9
uint8 PATH_EXTENDED3 = 10
uint8 PATH_EXTENDED4 = 11
uint8 PATH_EXTENDED5 = 12
uint8 PATH_EXTENDED6 = 13
uint8 PATH_EXTENDED7 = 14

================================================================================
MSG: etsi_its_cam_ts_msgs/RoadType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadType ::= ENUMERATED {
#     urban-NoStructuralSeparationToOppositeLanes      (0),
#     urban-WithStructuralSeparationToOppositeLanes    (1),
#     nonUrban-NoStructuralSeparationToOppositeLanes   (2),
#     nonUrban-WithStructuralSeparationToOppositeLanes (3)
# }
# ------------------------------------------------------------------------------
# *
# * This DE indicates the type of a road segment.
# * 
# * The value shall be set to:
# * - 0 `urban-NoStructuralSeparationToOppositeLanes`       - for an urban road with no structural separation between lanes carrying traffic in opposite directions,
# * - 1 `urban-WithStructuralSeparationToOppositeLanes`     - for an urban road with structural separation between lanes carrying traffic in opposite directions,
# * - 2 `nonUrban-NoStructuralSeparationToOppositeLanes`    - for an non urban road with no structural separation between lanes carrying traffic in opposite directions,
# * - 3 `nonUrban-WithStructuralSeparationToOppositeLanes`  - for an non urban road with structural separation between lanes carrying traffic in opposite directions.
# *
# * @category: Road Topology Information
# * @revision: Editorial update in V2.1.1
# 

uint8 value
uint8 URBAN_NO_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 0
uint8 URBAN_WITH_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 1
uint8 NON_URBAN_NO_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 2
uint8 NON_URBAN_WITH_STRUCTURAL_SEPARATION_TO_OPPOSITE_LANES = 3


================================================================================
MSG: etsi_its_cam_ts_msgs/BasicLaneConfiguration
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# BasicLaneConfiguration::= SEQUENCE(SIZE(1..16,...)) OF BasicLaneInformation 
# ------------------------------------------------------------------------------
# * 
# * This DF provides information about the configuration of a road section in terms of lanes using a list of @ref LanePositionAndType .
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

BasicLaneInformation[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cam_ts_msgs/BasicLaneInformation
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# BasicLaneInformation::= SEQUENCE{
#   laneNumber	         LanePosition,
#   direction		         Direction,
#   laneWidth		         LaneWidth OPTIONAL,
#   connectingLane         LanePosition OPTIONAL,
#   connectingRoadSection  RoadSectionId OPTIONAL,
#   ...
# }
# ------------------------------------------------------------------------------
# * 
# * This DF provides basic information about a single lane of a road segment.
# * It includes the following components: 
# * 
# * @field laneNumber: the number associated to the lane that provides a transversal identification. 
# * 
# * @field direction: the direction of traffic flow allowed on the lane. 
# * 
# * @field laneWidth: the optional width of the lane.
# *
# * @field connectingLane: the number of the connecting lane in the next road section, i.e. the number of the lane which the vehicle will use when travelling from one section to the next,
# * if it does not actively change lanes. If this component is absent, the lane name number remains the same in the next section.
# *
# * @field connectingRoadSection: the identifier of the next road section in direction of traffic, that is connecting to the current road section. 
# * If this component is absent, the connecting road section is the one following the instance where this DF is placed in the @ref RoadConfigurationSectionList.
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

LanePosition lane_number

Direction direction

LaneWidth lane_width
bool lane_width_is_present

LanePosition connecting_lane
bool connecting_lane_is_present

RoadSectionId connecting_road_section
bool connecting_road_section_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/LanePosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LanePosition ::= INTEGER {
#     offTheRoad           (-1), 
#     innerHardShoulder    (0), 
#     outerHardShoulder    (14) 
# } (-1..14)
# ------------------------------------------------------------------------------
# *
# * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
# *
# * For right-hand traffic roads, the value shall be set to:
# * - `-1` if the position is off, i.e. besides the road,
# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
# *
# * For left-hand traffic roads, the value shall be set to:
# * - `-1` if the position is off, i.e. besides the road,
# * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
# * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
# * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
# *
# *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
# *
# * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
# * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
# * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
# *
# * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:
# * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the 
# *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.
# * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. 
# *   The remaining middle lane is assigned to both traffic directions as innermost lane.
# *
# * @category: Road topology information
# * @revision: Description of the legal separation of carriageways added in V2.2.1
#

int8 value
int8 MIN = -1
int8 MAX = 14
int8 OFF_THE_ROAD = -1
int8 INNER_HARD_SHOULDER = 0
int8 OUTER_HARD_SHOULDER = 14

================================================================================
MSG: etsi_its_cam_ts_msgs/Direction
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Direction::= INTEGER{
#     sameDirection     (0),
#     oppositeDirection (1),
#     bothDirections    (2),
#     unavailable       (3)
#  } (0..3)
# ------------------------------------------------------------------------------
# *
# * This DE indicates a direction with respect to a defined reference direction.
# * Example: a reference direction may be implicitly defined by the definition of a geographical zone.
# *
# * The value shall be set to:
# * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,
# * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,
# * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,
# * - 3 - `unavailable`       - to indicate that the information is unavailable.
# *
# * @category: GeoReference information
# * @revision: Created in V2.1.1
# 

uint8 value
uint8 MIN = 0
uint8 MAX = 3
uint8 SAME_DIRECTION = 0
uint8 OPPOSITE_DIRECTION = 1
uint8 BOTH_DIRECTIONS = 2
uint8 UNAVAILABLE = 3

================================================================================
MSG: etsi_its_cam_ts_msgs/LaneWidth
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# LaneWidth::= INTEGER (0..1023)
# ------------------------------------------------------------------------------
# *
# * This DE represents the width of a lane measured at a defined position.
# *
# * The value shall be set to:
# * - `n` (`n > 0` and `n < 1022`) if the lane width information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
# * - `1022` if the lane width is out of range, i.e. greater than 10,21 m,
# * - `1023` if the lane width information is not available.
# *
# * The value 0 shall not be used.
# *
# * @unit: 0,01 metre
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 1023


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadSectionId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSectionId::= INTEGER (0..8, ...)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates an ordinal number that represents the position of a component in the list @ref RoadConfigurationSectionList. 
# *
# * The value shall be set to:
# * - `0`     - if no road section is identified
# * - `1..8`  - for instances 1..8 of @ref RoadConfigurationSectionList 
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

int64 value
int64 MIN = 0
int64 MAX = 8


================================================================================
MSG: etsi_its_cam_ts_msgs/MapemConfiguration
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapemConfiguration::= SEQUENCE(SIZE(1..16,...)) OF MapemElementReference
# ------------------------------------------------------------------------------
# * 
# * This DF provides information about the configuration of a road section in terms of MAPEM lanes or connections using a list of @ref MapemExtractedElementReference. 
#
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

MapemElementReference[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 16

================================================================================
MSG: etsi_its_cam_ts_msgs/MapemElementReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapemElementReference::= SEQUENCE {
#   mapReference      MapReference OPTIONAL,
#   laneIds           MapemLaneList  OPTIONAL,
#   connectionIds	    MapemConnectionList  OPTIONAL,		
#   ...
# } 
# ------------------------------------------------------------------------------
# * 
# * This DF provides references to an element described in a MAPEM according to ETSI TS 103 301 [i.15], such as a lane or connection at a specific intersection or road segment. 
# * 
# * It shall include the following components: 
# * 
# * @field mapReference: the optional reference to a MAPEM that describes the intersection or road segment. It is absent if the MAPEM topology is known from the context.
# * 
# * @field laneIds: the optional list of the identifiers of the lanes to be referenced. 
# * 
# * @field connectionIds: the optional list of the identifiers of the connections to be referenced. 
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

MapReference map_reference
bool map_reference_is_present

MapemLaneList lane_ids
bool lane_ids_is_present

MapemConnectionList connection_ids
bool connection_ids_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/MapReference
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapReference::= CHOICE {
# 	roadsegment     RoadSegmentReferenceId,
# 	intersection    IntersectionReferenceId
# }
# ------------------------------------------------------------------------------
# *
# * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
# *
# * The following options are provided:
# * 
# * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
# * 
# * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
# *
# * @category: Road topology information
# * @revision: Created in V2.1.1
# 

uint8 choice

RoadSegmentReferenceId roadsegment
uint8 CHOICE_ROADSEGMENT = 0

IntersectionReferenceId intersection
uint8 CHOICE_INTERSECTION = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadSegmentReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSegmentReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for a road segment
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the road segment.
# *
# * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
# * @category: GeoReference information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cam_ts_msgs/Identifier2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier2B ::= INTEGER (0..65535)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cam_ts_msgs/IntersectionReferenceId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# IntersectionReferenceId ::= SEQUENCE {
#     region    Identifier2B OPTIONAL,
#     id        Identifier2B
# }
# ------------------------------------------------------------------------------
# *
# * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
# *
# * It shall include the following components: 
# *
# * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
# * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
# *
# * @field id: the identifier of the intersection
# *
# * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
# * @category: Road topology information
# * @revision: created in V2.1.1
# 

Identifier2B region
bool region_is_present

Identifier2B id


================================================================================
MSG: etsi_its_cam_ts_msgs/MapemLaneList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapemLaneList ::=  SEQUENCE (SIZE(1..8,...)) OF Identifier1B
# ------------------------------------------------------------------------------
# * 
# * This DF provides references to MAPEM lanes using a list of @ref Identifier1B.
# *
# * @category: Road topology information
# * @revision: Created in 2.2.1
#

Identifier1B[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 8

================================================================================
MSG: etsi_its_cam_ts_msgs/Identifier1B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Identifier1B ::= INTEGER (0..255)
# ------------------------------------------------------------------------------
# * 
# * This DE is a general identifier.
# * 
# * @category: Basic information
# * @revision: Created in V2.1.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_cam_ts_msgs/MapemConnectionList
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# MapemConnectionList ::=  SEQUENCE (SIZE(1..8,...)) OF Identifier1B
# ------------------------------------------------------------------------------
# * 
# * This DF provides references to MAPEM connections using a list of @ref Identifier1B.
# * Note: connections are  allowed �maneuvers� (e.g. an ingress / egress relation) on an intersection.
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

Identifier1B[] array
int64 MIN_SIZE = 1
int64 MAX_SIZE = 8
"""
  # Pseudo-constants
  MIN_SIZE = 1
  MAX_SIZE = 8

  __slots__ = ['array']
  _slot_types = ['etsi_its_cam_ts_msgs/RoadConfigurationSection[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       array

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RoadConfigurationSectionList, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.array is None:
        self.array = []
    else:
      self.array = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v1 = val1.road_section_definition
        _v2 = _v1.starting_point_section
        _v3 = _v2.latitude
        _x = _v3.value
        buff.write(_get_struct_i().pack(_x))
        _v4 = _v2.longitude
        _x = _v4.value
        buff.write(_get_struct_i().pack(_x))
        _v5 = _v2.altitude
        _x = _v5.value
        buff.write(_get_struct_i().pack(_x))
        _v6 = _v1.length_of_section
        _x = _v6.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v1.length_of_section_is_present
        buff.write(_get_struct_B().pack(_x))
        _v7 = _v1.ending_point_section
        _v8 = _v7.latitude
        _x = _v8.value
        buff.write(_get_struct_i().pack(_x))
        _v9 = _v7.longitude
        _x = _v9.value
        buff.write(_get_struct_i().pack(_x))
        _v10 = _v7.altitude
        _x = _v10.value
        buff.write(_get_struct_i().pack(_x))
        _x = _v1.ending_point_section_is_present
        buff.write(_get_struct_B().pack(_x))
        _v11 = _v1.connected_paths
        length = len(_v11.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v11.array:
          _x = val4.value
          buff.write(_get_struct_B().pack(_x))
        _v12 = _v1.included_paths
        length = len(_v12.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v12.array:
          _x = val4.value
          buff.write(_get_struct_B().pack(_x))
        _x = _v1
        buff.write(_get_struct_2B().pack(_x.is_event_zone_included, _x.is_event_zone_connected))
        _v13 = val1.road_type
        _x = _v13.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.road_type_is_present
        buff.write(_get_struct_B().pack(_x))
        _v14 = val1.lane_configuration
        length = len(_v14.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v14.array:
          _v15 = val3.lane_number
          _x = _v15.value
          buff.write(_get_struct_b().pack(_x))
          _v16 = val3.direction
          _x = _v16.value
          buff.write(_get_struct_B().pack(_x))
          _v17 = val3.lane_width
          _x = _v17.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.lane_width_is_present
          buff.write(_get_struct_B().pack(_x))
          _v18 = val3.connecting_lane
          _x = _v18.value
          buff.write(_get_struct_b().pack(_x))
          _x = val3.connecting_lane_is_present
          buff.write(_get_struct_B().pack(_x))
          _v19 = val3.connecting_road_section
          _x = _v19.value
          buff.write(_get_struct_q().pack(_x))
          _x = val3.connecting_road_section_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = val1.lane_configuration_is_present
        buff.write(_get_struct_B().pack(_x))
        _v20 = val1.mapem_configuration
        length = len(_v20.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v20.array:
          _v21 = val3.map_reference
          _x = _v21.choice
          buff.write(_get_struct_B().pack(_x))
          _v22 = _v21.roadsegment
          _v23 = _v22.region
          _x = _v23.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v22.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v24 = _v22.id
          _x = _v24.value
          buff.write(_get_struct_H().pack(_x))
          _v25 = _v21.intersection
          _v26 = _v25.region
          _x = _v26.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v25.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v27 = _v25.id
          _x = _v27.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.map_reference_is_present
          buff.write(_get_struct_B().pack(_x))
          _v28 = val3.lane_ids
          length = len(_v28.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v28.array:
            _x = val5.value
            buff.write(_get_struct_B().pack(_x))
          _x = val3.lane_ids_is_present
          buff.write(_get_struct_B().pack(_x))
          _v29 = val3.connection_ids
          length = len(_v29.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v29.array:
            _x = val5.value
            buff.write(_get_struct_B().pack(_x))
          _x = val3.connection_ids_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = val1.mapem_configuration_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.RoadConfigurationSection()
        _v30 = val1.road_section_definition
        _v31 = _v30.starting_point_section
        _v32 = _v31.latitude
        start = end
        end += 4
        (_v32.value,) = _get_struct_i().unpack(str[start:end])
        _v33 = _v31.longitude
        start = end
        end += 4
        (_v33.value,) = _get_struct_i().unpack(str[start:end])
        _v34 = _v31.altitude
        start = end
        end += 4
        (_v34.value,) = _get_struct_i().unpack(str[start:end])
        _v35 = _v30.length_of_section
        start = end
        end += 2
        (_v35.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v30.length_of_section_is_present,) = _get_struct_B().unpack(str[start:end])
        _v30.length_of_section_is_present = bool(_v30.length_of_section_is_present)
        _v36 = _v30.ending_point_section
        _v37 = _v36.latitude
        start = end
        end += 4
        (_v37.value,) = _get_struct_i().unpack(str[start:end])
        _v38 = _v36.longitude
        start = end
        end += 4
        (_v38.value,) = _get_struct_i().unpack(str[start:end])
        _v39 = _v36.altitude
        start = end
        end += 4
        (_v39.value,) = _get_struct_i().unpack(str[start:end])
        start = end
        end += 1
        (_v30.ending_point_section_is_present,) = _get_struct_B().unpack(str[start:end])
        _v30.ending_point_section_is_present = bool(_v30.ending_point_section_is_present)
        _v40 = _v30.connected_paths
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v40.array = []
        for i in range(0, length):
          val4 = etsi_its_cam_ts_msgs.msg.PathId()
          start = end
          end += 1
          (val4.value,) = _get_struct_B().unpack(str[start:end])
          _v40.array.append(val4)
        _v41 = _v30.included_paths
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v41.array = []
        for i in range(0, length):
          val4 = etsi_its_cam_ts_msgs.msg.PathId()
          start = end
          end += 1
          (val4.value,) = _get_struct_B().unpack(str[start:end])
          _v41.array.append(val4)
        _x = _v30
        start = end
        end += 2
        (_x.is_event_zone_included, _x.is_event_zone_connected,) = _get_struct_2B().unpack(str[start:end])
        _v30.is_event_zone_included = bool(_v30.is_event_zone_included)
        _v30.is_event_zone_connected = bool(_v30.is_event_zone_connected)
        _v42 = val1.road_type
        start = end
        end += 1
        (_v42.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.road_type_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.road_type_is_present = bool(val1.road_type_is_present)
        _v43 = val1.lane_configuration
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v43.array = []
        for i in range(0, length):
          val3 = etsi_its_cam_ts_msgs.msg.BasicLaneInformation()
          _v44 = val3.lane_number
          start = end
          end += 1
          (_v44.value,) = _get_struct_b().unpack(str[start:end])
          _v45 = val3.direction
          start = end
          end += 1
          (_v45.value,) = _get_struct_B().unpack(str[start:end])
          _v46 = val3.lane_width
          start = end
          end += 2
          (_v46.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.lane_width_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.lane_width_is_present = bool(val3.lane_width_is_present)
          _v47 = val3.connecting_lane
          start = end
          end += 1
          (_v47.value,) = _get_struct_b().unpack(str[start:end])
          start = end
          end += 1
          (val3.connecting_lane_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.connecting_lane_is_present = bool(val3.connecting_lane_is_present)
          _v48 = val3.connecting_road_section
          start = end
          end += 8
          (_v48.value,) = _get_struct_q().unpack(str[start:end])
          start = end
          end += 1
          (val3.connecting_road_section_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.connecting_road_section_is_present = bool(val3.connecting_road_section_is_present)
          _v43.array.append(val3)
        start = end
        end += 1
        (val1.lane_configuration_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lane_configuration_is_present = bool(val1.lane_configuration_is_present)
        _v49 = val1.mapem_configuration
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v49.array = []
        for i in range(0, length):
          val3 = etsi_its_cam_ts_msgs.msg.MapemElementReference()
          _v50 = val3.map_reference
          start = end
          end += 1
          (_v50.choice,) = _get_struct_B().unpack(str[start:end])
          _v51 = _v50.roadsegment
          _v52 = _v51.region
          start = end
          end += 2
          (_v52.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v51.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v51.region_is_present = bool(_v51.region_is_present)
          _v53 = _v51.id
          start = end
          end += 2
          (_v53.value,) = _get_struct_H().unpack(str[start:end])
          _v54 = _v50.intersection
          _v55 = _v54.region
          start = end
          end += 2
          (_v55.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v54.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v54.region_is_present = bool(_v54.region_is_present)
          _v56 = _v54.id
          start = end
          end += 2
          (_v56.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.map_reference_is_present = bool(val3.map_reference_is_present)
          _v57 = val3.lane_ids
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v57.array = []
          for i in range(0, length):
            val5 = etsi_its_cam_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val5.value,) = _get_struct_B().unpack(str[start:end])
            _v57.array.append(val5)
          start = end
          end += 1
          (val3.lane_ids_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.lane_ids_is_present = bool(val3.lane_ids_is_present)
          _v58 = val3.connection_ids
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v58.array = []
          for i in range(0, length):
            val5 = etsi_its_cam_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val5.value,) = _get_struct_B().unpack(str[start:end])
            _v58.array.append(val5)
          start = end
          end += 1
          (val3.connection_ids_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.connection_ids_is_present = bool(val3.connection_ids_is_present)
          _v49.array.append(val3)
        start = end
        end += 1
        (val1.mapem_configuration_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.mapem_configuration_is_present = bool(val1.mapem_configuration_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.array:
        _v59 = val1.road_section_definition
        _v60 = _v59.starting_point_section
        _v61 = _v60.latitude
        _x = _v61.value
        buff.write(_get_struct_i().pack(_x))
        _v62 = _v60.longitude
        _x = _v62.value
        buff.write(_get_struct_i().pack(_x))
        _v63 = _v60.altitude
        _x = _v63.value
        buff.write(_get_struct_i().pack(_x))
        _v64 = _v59.length_of_section
        _x = _v64.value
        buff.write(_get_struct_H().pack(_x))
        _x = _v59.length_of_section_is_present
        buff.write(_get_struct_B().pack(_x))
        _v65 = _v59.ending_point_section
        _v66 = _v65.latitude
        _x = _v66.value
        buff.write(_get_struct_i().pack(_x))
        _v67 = _v65.longitude
        _x = _v67.value
        buff.write(_get_struct_i().pack(_x))
        _v68 = _v65.altitude
        _x = _v68.value
        buff.write(_get_struct_i().pack(_x))
        _x = _v59.ending_point_section_is_present
        buff.write(_get_struct_B().pack(_x))
        _v69 = _v59.connected_paths
        length = len(_v69.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v69.array:
          _x = val4.value
          buff.write(_get_struct_B().pack(_x))
        _v70 = _v59.included_paths
        length = len(_v70.array)
        buff.write(_struct_I.pack(length))
        for val4 in _v70.array:
          _x = val4.value
          buff.write(_get_struct_B().pack(_x))
        _x = _v59
        buff.write(_get_struct_2B().pack(_x.is_event_zone_included, _x.is_event_zone_connected))
        _v71 = val1.road_type
        _x = _v71.value
        buff.write(_get_struct_B().pack(_x))
        _x = val1.road_type_is_present
        buff.write(_get_struct_B().pack(_x))
        _v72 = val1.lane_configuration
        length = len(_v72.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v72.array:
          _v73 = val3.lane_number
          _x = _v73.value
          buff.write(_get_struct_b().pack(_x))
          _v74 = val3.direction
          _x = _v74.value
          buff.write(_get_struct_B().pack(_x))
          _v75 = val3.lane_width
          _x = _v75.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.lane_width_is_present
          buff.write(_get_struct_B().pack(_x))
          _v76 = val3.connecting_lane
          _x = _v76.value
          buff.write(_get_struct_b().pack(_x))
          _x = val3.connecting_lane_is_present
          buff.write(_get_struct_B().pack(_x))
          _v77 = val3.connecting_road_section
          _x = _v77.value
          buff.write(_get_struct_q().pack(_x))
          _x = val3.connecting_road_section_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = val1.lane_configuration_is_present
        buff.write(_get_struct_B().pack(_x))
        _v78 = val1.mapem_configuration
        length = len(_v78.array)
        buff.write(_struct_I.pack(length))
        for val3 in _v78.array:
          _v79 = val3.map_reference
          _x = _v79.choice
          buff.write(_get_struct_B().pack(_x))
          _v80 = _v79.roadsegment
          _v81 = _v80.region
          _x = _v81.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v80.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v82 = _v80.id
          _x = _v82.value
          buff.write(_get_struct_H().pack(_x))
          _v83 = _v79.intersection
          _v84 = _v83.region
          _x = _v84.value
          buff.write(_get_struct_H().pack(_x))
          _x = _v83.region_is_present
          buff.write(_get_struct_B().pack(_x))
          _v85 = _v83.id
          _x = _v85.value
          buff.write(_get_struct_H().pack(_x))
          _x = val3.map_reference_is_present
          buff.write(_get_struct_B().pack(_x))
          _v86 = val3.lane_ids
          length = len(_v86.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v86.array:
            _x = val5.value
            buff.write(_get_struct_B().pack(_x))
          _x = val3.lane_ids_is_present
          buff.write(_get_struct_B().pack(_x))
          _v87 = val3.connection_ids
          length = len(_v87.array)
          buff.write(_struct_I.pack(length))
          for val5 in _v87.array:
            _x = val5.value
            buff.write(_get_struct_B().pack(_x))
          _x = val3.connection_ids_is_present
          buff.write(_get_struct_B().pack(_x))
        _x = val1.mapem_configuration_is_present
        buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.array is None:
        self.array = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.RoadConfigurationSection()
        _v88 = val1.road_section_definition
        _v89 = _v88.starting_point_section
        _v90 = _v89.latitude
        start = end
        end += 4
        (_v90.value,) = _get_struct_i().unpack(str[start:end])
        _v91 = _v89.longitude
        start = end
        end += 4
        (_v91.value,) = _get_struct_i().unpack(str[start:end])
        _v92 = _v89.altitude
        start = end
        end += 4
        (_v92.value,) = _get_struct_i().unpack(str[start:end])
        _v93 = _v88.length_of_section
        start = end
        end += 2
        (_v93.value,) = _get_struct_H().unpack(str[start:end])
        start = end
        end += 1
        (_v88.length_of_section_is_present,) = _get_struct_B().unpack(str[start:end])
        _v88.length_of_section_is_present = bool(_v88.length_of_section_is_present)
        _v94 = _v88.ending_point_section
        _v95 = _v94.latitude
        start = end
        end += 4
        (_v95.value,) = _get_struct_i().unpack(str[start:end])
        _v96 = _v94.longitude
        start = end
        end += 4
        (_v96.value,) = _get_struct_i().unpack(str[start:end])
        _v97 = _v94.altitude
        start = end
        end += 4
        (_v97.value,) = _get_struct_i().unpack(str[start:end])
        start = end
        end += 1
        (_v88.ending_point_section_is_present,) = _get_struct_B().unpack(str[start:end])
        _v88.ending_point_section_is_present = bool(_v88.ending_point_section_is_present)
        _v98 = _v88.connected_paths
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v98.array = []
        for i in range(0, length):
          val4 = etsi_its_cam_ts_msgs.msg.PathId()
          start = end
          end += 1
          (val4.value,) = _get_struct_B().unpack(str[start:end])
          _v98.array.append(val4)
        _v99 = _v88.included_paths
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v99.array = []
        for i in range(0, length):
          val4 = etsi_its_cam_ts_msgs.msg.PathId()
          start = end
          end += 1
          (val4.value,) = _get_struct_B().unpack(str[start:end])
          _v99.array.append(val4)
        _x = _v88
        start = end
        end += 2
        (_x.is_event_zone_included, _x.is_event_zone_connected,) = _get_struct_2B().unpack(str[start:end])
        _v88.is_event_zone_included = bool(_v88.is_event_zone_included)
        _v88.is_event_zone_connected = bool(_v88.is_event_zone_connected)
        _v100 = val1.road_type
        start = end
        end += 1
        (_v100.value,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 1
        (val1.road_type_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.road_type_is_present = bool(val1.road_type_is_present)
        _v101 = val1.lane_configuration
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v101.array = []
        for i in range(0, length):
          val3 = etsi_its_cam_ts_msgs.msg.BasicLaneInformation()
          _v102 = val3.lane_number
          start = end
          end += 1
          (_v102.value,) = _get_struct_b().unpack(str[start:end])
          _v103 = val3.direction
          start = end
          end += 1
          (_v103.value,) = _get_struct_B().unpack(str[start:end])
          _v104 = val3.lane_width
          start = end
          end += 2
          (_v104.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.lane_width_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.lane_width_is_present = bool(val3.lane_width_is_present)
          _v105 = val3.connecting_lane
          start = end
          end += 1
          (_v105.value,) = _get_struct_b().unpack(str[start:end])
          start = end
          end += 1
          (val3.connecting_lane_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.connecting_lane_is_present = bool(val3.connecting_lane_is_present)
          _v106 = val3.connecting_road_section
          start = end
          end += 8
          (_v106.value,) = _get_struct_q().unpack(str[start:end])
          start = end
          end += 1
          (val3.connecting_road_section_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.connecting_road_section_is_present = bool(val3.connecting_road_section_is_present)
          _v101.array.append(val3)
        start = end
        end += 1
        (val1.lane_configuration_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.lane_configuration_is_present = bool(val1.lane_configuration_is_present)
        _v107 = val1.mapem_configuration
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v107.array = []
        for i in range(0, length):
          val3 = etsi_its_cam_ts_msgs.msg.MapemElementReference()
          _v108 = val3.map_reference
          start = end
          end += 1
          (_v108.choice,) = _get_struct_B().unpack(str[start:end])
          _v109 = _v108.roadsegment
          _v110 = _v109.region
          start = end
          end += 2
          (_v110.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v109.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v109.region_is_present = bool(_v109.region_is_present)
          _v111 = _v109.id
          start = end
          end += 2
          (_v111.value,) = _get_struct_H().unpack(str[start:end])
          _v112 = _v108.intersection
          _v113 = _v112.region
          start = end
          end += 2
          (_v113.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (_v112.region_is_present,) = _get_struct_B().unpack(str[start:end])
          _v112.region_is_present = bool(_v112.region_is_present)
          _v114 = _v112.id
          start = end
          end += 2
          (_v114.value,) = _get_struct_H().unpack(str[start:end])
          start = end
          end += 1
          (val3.map_reference_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.map_reference_is_present = bool(val3.map_reference_is_present)
          _v115 = val3.lane_ids
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v115.array = []
          for i in range(0, length):
            val5 = etsi_its_cam_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val5.value,) = _get_struct_B().unpack(str[start:end])
            _v115.array.append(val5)
          start = end
          end += 1
          (val3.lane_ids_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.lane_ids_is_present = bool(val3.lane_ids_is_present)
          _v116 = val3.connection_ids
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v116.array = []
          for i in range(0, length):
            val5 = etsi_its_cam_ts_msgs.msg.Identifier1B()
            start = end
            end += 1
            (val5.value,) = _get_struct_B().unpack(str[start:end])
            _v116.array.append(val5)
          start = end
          end += 1
          (val3.connection_ids_is_present,) = _get_struct_B().unpack(str[start:end])
          val3.connection_ids_is_present = bool(val3.connection_ids_is_present)
          _v107.array.append(val3)
        start = end
        end += 1
        (val1.mapem_configuration_is_present,) = _get_struct_B().unpack(str[start:end])
        val1.mapem_configuration_is_present = bool(val1.mapem_configuration_is_present)
        self.array.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
_struct_b = None
def _get_struct_b():
    global _struct_b
    if _struct_b is None:
        _struct_b = struct.Struct("<b")
    return _struct_b
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
_struct_q = None
def _get_struct_q():
    global _struct_q
    if _struct_q is None:
        _struct_q = struct.Struct("<q")
    return _struct_q
