# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/RoadSectionDefinition.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class RoadSectionDefinition(genpy.Message):
  _md5sum = "2797915d28290341bcc9d9ba56c4adf6"
  _type = "etsi_its_cam_ts_msgs/RoadSectionDefinition"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# RoadSectionDefinition::= SEQUENCE {
#   startingPointSection      GeoPosition,
#   lengthOfSection	  	    StandardLength2B OPTIONAL,
#   endingPointSection       	GeoPosition OPTIONAL, 
#   connectedPaths		    PathReferences,	
#   includedPaths          	PathReferences,
#   isEventZoneIncluded       BOOLEAN,  
#   isEventZoneConnected      BOOLEAN,
#   ...
# }  
# ------------------------------------------------------------------------------
# * 
# * This DF provides the basic topological definition of a road section.
# *
# * It shall include the following components: 
# * 
# * @field startingPointSection: the position of the starting point of the section. 
# * 
# * @field lengthOfSection: the optional length of the section along the road profile (i.e. including curves).
# * 
# * @field endingPointSection: the optional position of the ending point of the section. 
# * If this component is absent, the ending position is implicitly defined by other means, e.g. the starting point of the next RoadConfigurationSection, or the section�s length.
# *
# * @field connectedPaths: the identifier(s) of the path(s) having one or an ordered subset of waypoints located upstream of the RoadConfigurationSection� starting point. 
# * 
# * @field includedPaths: the identifier(s) of the path(s) that covers (either with all its length or with a part of it) a RoadConfigurationSection. 
# *
# * @field isEventZoneIncluded: indicates, if set to TRUE, that the @ref EventZone incl. its reference position covers a RoadConfigurationSection (either with all its length or with a part of it). 
# * 
# * @field isEventZoneConnected: indicates, if set to TRUE, that the @ref EventZone incl. its reference position has one or an ordered subset of waypoints located upstream of the RoadConfigurationSection� starting point.
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

GeoPosition starting_point_section

StandardLength2B length_of_section
bool length_of_section_is_present

GeoPosition ending_point_section
bool ending_point_section_is_present

PathReferences connected_paths

PathReferences included_paths

bool is_event_zone_included

bool is_event_zone_connected


================================================================================
MSG: etsi_its_cam_ts_msgs/GeoPosition
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# GeoPosition::= SEQUENCE{
# 	latitude   Latitude,
# 	longitude  Longitude,
#     altitude   AltitudeValue DEFAULT unavailable
# }
# ------------------------------------------------------------------------------
# * 
# * This DF indicates a geographical position.
# *
# * It shall include the following components: 
# *
# * @field latitude: the latitude of the geographical position.
# *
# * @field longitude: the longitude of the geographical position.
# *
# * @field altitude: the altitude of the geographical position with default value unavailable.
# *
#

Latitude latitude

Longitude longitude

AltitudeValue altitude


int32 ALTITUDE_DEFAULT = 800001

================================================================================
MSG: etsi_its_cam_ts_msgs/Latitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Latitude ::= INTEGER {
#     unavailable(900000001)
# } (-900000000..900000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
# * in south hemisphere.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
# * - `0` is used for the latitude of the equator,
# * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
# * - `900 000 001` when the information is unavailable.
# *
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Editorial update in V2.1.1
# 

int32 value
int32 MIN = -900000000
int32 MAX = 900000001
int32 UNAVAILABLE = 900000001

================================================================================
MSG: etsi_its_cam_ts_msgs/Longitude
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# Longitude ::= INTEGER {
#     valueNotUsed (-1800000000),
#     unavailable  (1800000001)
# } (-1800000000..1800000001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
# * to the east or to the west of the prime meridian.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to:
# * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
# * - `0` to indicate the prime meridian,
# * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
# * - `1 800 000 001` when the information is unavailable.
# *
# * The value -1 800 000 000 shall not be used. 
# * 
# * @unit: 10^-7 degree
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1
# 

int32 value
int32 MIN = -1800000000
int32 MAX = 1800000001
int32 VALUE_NOT_USED = -1800000000
int32 UNAVAILABLE = 1800000001

================================================================================
MSG: etsi_its_cam_ts_msgs/AltitudeValue
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# AltitudeValue ::= INTEGER {
#     negativeOutOfRange (-100000),
#     postiveOutOfRange  (800000),
#     unavailable        (800001)
# } (-100000..800001)
# ------------------------------------------------------------------------------
# *
# * This DE represents the altitude value in a WGS84 coordinate system.
# * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
# *
# * The value shall be set to: 
# * - `-100 000` if the altitude is equal to or less than -1 000 m,
# * - `n` (`n > -100 000` and `n < 800 000`) if the altitude is equal to or less than n  x 0,01 metre and greater than (n-1) x 0,01 metre,
# * - `800 000` if the altitude  greater than 7 999,99 m,
# * - `800 001` if the information is not available.
# *
# * @note: the range of this DE does not use the full binary encoding range, but all reasonable values are covered. In order to cover all possible altitude ranges a larger encoding would be necessary.
# * @unit: 0,01 metre
# * @category: GeoReference information
# * @revision: Description revised in V2.1.1 (definition of 800 000 has slightly changed) 
# 

int32 value
int32 MIN = -100000
int32 MAX = 800001
int32 NEGATIVE_OUT_OF_RANGE = -100000
int32 POSTIVE_OUT_OF_RANGE = 800000
int32 UNAVAILABLE = 800001

================================================================================
MSG: etsi_its_cam_ts_msgs/StandardLength2B
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StandardLength2B::= INTEGER (0..65535)
# ------------------------------------------------------------------------------
# *
# * The DE represents length as a measure of distance between points or as a dimension of an object.  
# *
# * @unit: 0,1 metre
# * @category: Basic information
# * @revision: Created in V2.1.1
# 

uint16 value
uint16 MIN = 0
uint16 MAX = 65535


================================================================================
MSG: etsi_its_cam_ts_msgs/PathReferences
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PathReferences ::= SEQUENCE (SIZE(1..14)) OF PathId
# ------------------------------------------------------------------------------
# * 
# * This DF represents a list of references to the components of a @ref Traces or @ref TracesExtended DF using the @ref PathId. 
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

PathId[] array
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 14

================================================================================
MSG: etsi_its_cam_ts_msgs/PathId
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PathId ::= INTEGER {
#     noPath        (0),
#     path1         (1),
#     path2         (2),
#     path3         (3),
#     path4         (4),
#     path5         (5),
#     path6         (6),
#     path7         (7),
#     pathExtended1 (8),
#     pathExtended2 (9),
#     pathExtended3 (10),
#     pathExtended4 (11),
#     pathExtended5 (12),
#     pathExtended6 (13),
#     pathExtended7 (14)
# } (0..14)
# ------------------------------------------------------------------------------
# * 
# * This DE indicates an ordinal number that represents the position of a component in the list of @ref Traces or @ref TracesExtended. 
# *
# * The value shall be set to:
# * - `0` - noPath  - if no path is identified
# * - `1..7`        - for instances 1..7 of @ref Traces 
# * - `8..14`       - for instances 1..7 of @ref TracesExtended. 
# *
# * @category: Road topology information
# * @revision: Created in V2.2.1
#

uint8 value
uint8 MIN = 0
uint8 MAX = 14
uint8 NO_PATH = 0
uint8 PATH1 = 1
uint8 PATH2 = 2
uint8 PATH3 = 3
uint8 PATH4 = 4
uint8 PATH5 = 5
uint8 PATH6 = 6
uint8 PATH7 = 7
uint8 PATH_EXTENDED1 = 8
uint8 PATH_EXTENDED2 = 9
uint8 PATH_EXTENDED3 = 10
uint8 PATH_EXTENDED4 = 11
uint8 PATH_EXTENDED5 = 12
uint8 PATH_EXTENDED6 = 13
uint8 PATH_EXTENDED7 = 14
"""
  __slots__ = ['starting_point_section','length_of_section','length_of_section_is_present','ending_point_section','ending_point_section_is_present','connected_paths','included_paths','is_event_zone_included','is_event_zone_connected']
  _slot_types = ['etsi_its_cam_ts_msgs/GeoPosition','etsi_its_cam_ts_msgs/StandardLength2B','bool','etsi_its_cam_ts_msgs/GeoPosition','bool','etsi_its_cam_ts_msgs/PathReferences','etsi_its_cam_ts_msgs/PathReferences','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       starting_point_section,length_of_section,length_of_section_is_present,ending_point_section,ending_point_section_is_present,connected_paths,included_paths,is_event_zone_included,is_event_zone_connected

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RoadSectionDefinition, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.starting_point_section is None:
        self.starting_point_section = etsi_its_cam_ts_msgs.msg.GeoPosition()
      if self.length_of_section is None:
        self.length_of_section = etsi_its_cam_ts_msgs.msg.StandardLength2B()
      if self.length_of_section_is_present is None:
        self.length_of_section_is_present = False
      if self.ending_point_section is None:
        self.ending_point_section = etsi_its_cam_ts_msgs.msg.GeoPosition()
      if self.ending_point_section_is_present is None:
        self.ending_point_section_is_present = False
      if self.connected_paths is None:
        self.connected_paths = etsi_its_cam_ts_msgs.msg.PathReferences()
      if self.included_paths is None:
        self.included_paths = etsi_its_cam_ts_msgs.msg.PathReferences()
      if self.is_event_zone_included is None:
        self.is_event_zone_included = False
      if self.is_event_zone_connected is None:
        self.is_event_zone_connected = False
    else:
      self.starting_point_section = etsi_its_cam_ts_msgs.msg.GeoPosition()
      self.length_of_section = etsi_its_cam_ts_msgs.msg.StandardLength2B()
      self.length_of_section_is_present = False
      self.ending_point_section = etsi_its_cam_ts_msgs.msg.GeoPosition()
      self.ending_point_section_is_present = False
      self.connected_paths = etsi_its_cam_ts_msgs.msg.PathReferences()
      self.included_paths = etsi_its_cam_ts_msgs.msg.PathReferences()
      self.is_event_zone_included = False
      self.is_event_zone_connected = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3iHB3iB().pack(_x.starting_point_section.latitude.value, _x.starting_point_section.longitude.value, _x.starting_point_section.altitude.value, _x.length_of_section.value, _x.length_of_section_is_present, _x.ending_point_section.latitude.value, _x.ending_point_section.longitude.value, _x.ending_point_section.altitude.value, _x.ending_point_section_is_present))
      length = len(self.connected_paths.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.connected_paths.array:
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      length = len(self.included_paths.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.included_paths.array:
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.is_event_zone_included, _x.is_event_zone_connected))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.starting_point_section is None:
        self.starting_point_section = etsi_its_cam_ts_msgs.msg.GeoPosition()
      if self.length_of_section is None:
        self.length_of_section = etsi_its_cam_ts_msgs.msg.StandardLength2B()
      if self.ending_point_section is None:
        self.ending_point_section = etsi_its_cam_ts_msgs.msg.GeoPosition()
      if self.connected_paths is None:
        self.connected_paths = etsi_its_cam_ts_msgs.msg.PathReferences()
      if self.included_paths is None:
        self.included_paths = etsi_its_cam_ts_msgs.msg.PathReferences()
      end = 0
      _x = self
      start = end
      end += 28
      (_x.starting_point_section.latitude.value, _x.starting_point_section.longitude.value, _x.starting_point_section.altitude.value, _x.length_of_section.value, _x.length_of_section_is_present, _x.ending_point_section.latitude.value, _x.ending_point_section.longitude.value, _x.ending_point_section.altitude.value, _x.ending_point_section_is_present,) = _get_struct_3iHB3iB().unpack(str[start:end])
      self.length_of_section_is_present = bool(self.length_of_section_is_present)
      self.ending_point_section_is_present = bool(self.ending_point_section_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.connected_paths.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.PathId()
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        self.connected_paths.array.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.included_paths.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.PathId()
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        self.included_paths.array.append(val1)
      _x = self
      start = end
      end += 2
      (_x.is_event_zone_included, _x.is_event_zone_connected,) = _get_struct_2B().unpack(str[start:end])
      self.is_event_zone_included = bool(self.is_event_zone_included)
      self.is_event_zone_connected = bool(self.is_event_zone_connected)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3iHB3iB().pack(_x.starting_point_section.latitude.value, _x.starting_point_section.longitude.value, _x.starting_point_section.altitude.value, _x.length_of_section.value, _x.length_of_section_is_present, _x.ending_point_section.latitude.value, _x.ending_point_section.longitude.value, _x.ending_point_section.altitude.value, _x.ending_point_section_is_present))
      length = len(self.connected_paths.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.connected_paths.array:
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      length = len(self.included_paths.array)
      buff.write(_struct_I.pack(length))
      for val1 in self.included_paths.array:
        _x = val1.value
        buff.write(_get_struct_B().pack(_x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.is_event_zone_included, _x.is_event_zone_connected))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.starting_point_section is None:
        self.starting_point_section = etsi_its_cam_ts_msgs.msg.GeoPosition()
      if self.length_of_section is None:
        self.length_of_section = etsi_its_cam_ts_msgs.msg.StandardLength2B()
      if self.ending_point_section is None:
        self.ending_point_section = etsi_its_cam_ts_msgs.msg.GeoPosition()
      if self.connected_paths is None:
        self.connected_paths = etsi_its_cam_ts_msgs.msg.PathReferences()
      if self.included_paths is None:
        self.included_paths = etsi_its_cam_ts_msgs.msg.PathReferences()
      end = 0
      _x = self
      start = end
      end += 28
      (_x.starting_point_section.latitude.value, _x.starting_point_section.longitude.value, _x.starting_point_section.altitude.value, _x.length_of_section.value, _x.length_of_section_is_present, _x.ending_point_section.latitude.value, _x.ending_point_section.longitude.value, _x.ending_point_section.altitude.value, _x.ending_point_section_is_present,) = _get_struct_3iHB3iB().unpack(str[start:end])
      self.length_of_section_is_present = bool(self.length_of_section_is_present)
      self.ending_point_section_is_present = bool(self.ending_point_section_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.connected_paths.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.PathId()
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        self.connected_paths.array.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.included_paths.array = []
      for i in range(0, length):
        val1 = etsi_its_cam_ts_msgs.msg.PathId()
        start = end
        end += 1
        (val1.value,) = _get_struct_B().unpack(str[start:end])
        self.included_paths.array.append(val1)
      _x = self
      start = end
      end += 2
      (_x.is_event_zone_included, _x.is_event_zone_connected,) = _get_struct_2B().unpack(str[start:end])
      self.is_event_zone_included = bool(self.is_event_zone_included)
      self.is_event_zone_connected = bool(self.is_event_zone_connected)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_3iHB3iB = None
def _get_struct_3iHB3iB():
    global _struct_3iHB3iB
    if _struct_3iHB3iB is None:
        _struct_3iHB3iB = struct.Struct("<3iHB3iB")
    return _struct_3iHB3iB
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
