# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/SensorTypes.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SensorTypes(genpy.Message):
  _md5sum = "54eb078e61926cf12633fb4a0b4dc157"
  _type = "etsi_its_cam_ts_msgs/SensorTypes"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SensorTypes ::= BIT STRING {
#     undefined         (0),
#     radar             (1),
#     lidar             (2),
#     monovideo         (3),
#     stereovision      (4),
#     nightvision       (5),
#     ultrasonic        (6),
#     pmd               (7),
#     inductionLoop     (8),
#     sphericalCamera   (9),
#     uwb               (10),
#     acoustic          (11),
#     localAggregation  (12),
#     itsAggregation    (13)
# } (SIZE (16,... ))
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of sensor(s).
# * The corresponding bit shall be set to 1 under the following conditions:
# * 
# * - 0  `undefined`         - in case the sensor type is undefined. 
# * - 1  `radar`             - in case the sensor is a radar,
# * - 2  `lidar`             - in case the sensor is a lidar,
# * - 3  `monovideo`         - in case the sensor is mono video,
# * - 4  `stereovision`      - in case the sensor is stereo vision,
# * - 5  `nightvision`       - in case the sensor is night vision,
# * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
# * - 7  `pmd`               - in case the sensor is photonic mixing device,
# * - 8  `inductionLoop`     - in case the sensor is an induction loop,
# * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
# * - 10 `uwb`               - in case the sensor is ultra wide band,
# * - 11 `acoustic`          - in case the sensor is acoustic,
# * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
# * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
# * - 14-15                  - are reserved for future usage.
# * 
# * @note: If all bits are set to 0, then no sensor type is used
# *
# * @category: Sensing Information
# * @revision: created in V2.2.1
#

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 16
int64 MAX_SIZE_BITS = 16
uint8 BIT_INDEX_UNDEFINED = 0
uint8 BIT_INDEX_RADAR = 1
uint8 BIT_INDEX_LIDAR = 2
uint8 BIT_INDEX_MONOVIDEO = 3
uint8 BIT_INDEX_STEREOVISION = 4
uint8 BIT_INDEX_NIGHTVISION = 5
uint8 BIT_INDEX_ULTRASONIC = 6
uint8 BIT_INDEX_PMD = 7
uint8 BIT_INDEX_INDUCTION_LOOP = 8
uint8 BIT_INDEX_SPHERICAL_CAMERA = 9
uint8 BIT_INDEX_UWB = 10
uint8 BIT_INDEX_ACOUSTIC = 11
uint8 BIT_INDEX_LOCAL_AGGREGATION = 12
uint8 BIT_INDEX_ITS_AGGREGATION = 13
"""
  # Pseudo-constants
  MIN_SIZE_BITS = 16
  MAX_SIZE_BITS = 16
  BIT_INDEX_UNDEFINED = 0
  BIT_INDEX_RADAR = 1
  BIT_INDEX_LIDAR = 2
  BIT_INDEX_MONOVIDEO = 3
  BIT_INDEX_STEREOVISION = 4
  BIT_INDEX_NIGHTVISION = 5
  BIT_INDEX_ULTRASONIC = 6
  BIT_INDEX_PMD = 7
  BIT_INDEX_INDUCTION_LOOP = 8
  BIT_INDEX_SPHERICAL_CAMERA = 9
  BIT_INDEX_UWB = 10
  BIT_INDEX_ACOUSTIC = 11
  BIT_INDEX_LOCAL_AGGREGATION = 12
  BIT_INDEX_ITS_AGGREGATION = 13

  __slots__ = ['value','bits_unused']
  _slot_types = ['uint8[]','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value,bits_unused

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SensorTypes, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = b''
      if self.bits_unused is None:
        self.bits_unused = 0
    else:
      self.value = b''
      self.bits_unused = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.bits_unused
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.value = str[start:end]
      start = end
      end += 1
      (self.bits_unused,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.bits_unused
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.value = str[start:end]
      start = end
      end += 1
      (self.bits_unused,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
