# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/StoredInformationType.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class StoredInformationType(genpy.Message):
  _md5sum = "e9a8dccaefaa23b81e3e496025111548"
  _type = "etsi_its_cam_ts_msgs/StoredInformationType"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
# Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by asn1ToRosMsg.py ----------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StoredInformationType::= BIT STRING {
#     undefined       (0),
#     staticDb	    (1),    
#     dynamicDb   	(2),
#     realTimeDb  	(3),
#     map		    	(4)	
# } (SIZE (8,... )) 
# ------------------------------------------------------------------------------
# * 
# * This DE indicates the type of stored information.
# *
# * The corresponding bit shall be set to 1 under the following conditions:
# * 
# * - `0` undefined        - in case the stored information type is undefined. 
# * - `1` staticDb         - in case the stored information type is a static database.
# * - `2` dynamicDb        - in case the stored information type is a dynamic database
# * - `3` realTimeDb       - in case the stored information type is a real time updated database.
# * - `4` map              - in case the stored information type is a road topology map.
# * - Bits 5 to 7          - are reserved for future use.
# *
# * @note: If all bits are set to 0, then no stored information type is used
# *
# * @category: Basic Information
# * @revision: created in V2.2.1
#

uint8[] value
uint8 bits_unused
int64 MIN_SIZE_BITS = 8
int64 MAX_SIZE_BITS = 8
uint8 BIT_INDEX_UNDEFINED = 0
uint8 BIT_INDEX_STATIC_DB = 1
uint8 BIT_INDEX_DYNAMIC_DB = 2
uint8 BIT_INDEX_REAL_TIME_DB = 3
uint8 BIT_INDEX_MAP = 4
"""
  # Pseudo-constants
  MIN_SIZE_BITS = 8
  MAX_SIZE_BITS = 8
  BIT_INDEX_UNDEFINED = 0
  BIT_INDEX_STATIC_DB = 1
  BIT_INDEX_DYNAMIC_DB = 2
  BIT_INDEX_REAL_TIME_DB = 3
  BIT_INDEX_MAP = 4

  __slots__ = ['value','bits_unused']
  _slot_types = ['uint8[]','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       value,bits_unused

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(StoredInformationType, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.value is None:
        self.value = b''
      if self.bits_unused is None:
        self.bits_unused = 0
    else:
      self.value = b''
      self.bits_unused = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.bits_unused
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.value = str[start:end]
      start = end
      end += 1
      (self.bits_unused,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.bits_unused
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.value = str[start:end]
      start = end
      end += 1
      (self.bits_unused,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
