// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let BasicLaneInformation = require('./BasicLaneInformation.js');

//-----------------------------------------------------------

class BasicLaneConfiguration {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.array = null;
    }
    else {
      if (initObj.hasOwnProperty('array')) {
        this.array = initObj.array
      }
      else {
        this.array = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type BasicLaneConfiguration
    // Serialize message field [array]
    // Serialize the length for message field [array]
    bufferOffset = _serializer.uint32(obj.array.length, buffer, bufferOffset);
    obj.array.forEach((val) => {
      bufferOffset = BasicLaneInformation.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type BasicLaneConfiguration
    let len;
    let data = new BasicLaneConfiguration(null);
    // Deserialize message field [array]
    // Deserialize array length for message field [array]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.array = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.array[i] = BasicLaneInformation.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 16 * object.array.length;
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/BasicLaneConfiguration';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '363ecbd66c16487f3a22a191c6284deb';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # BasicLaneConfiguration::= SEQUENCE(SIZE(1..16,...)) OF BasicLaneInformation 
    # ------------------------------------------------------------------------------
    # * 
    # * This DF provides information about the configuration of a road section in terms of lanes using a list of @ref LanePositionAndType .
    # *
    # * @category: Road topology information
    # * @revision: Created in V2.2.1
    #
    
    BasicLaneInformation[] array
    int64 MIN_SIZE = 1
    int64 MAX_SIZE = 16
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/BasicLaneInformation
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # BasicLaneInformation::= SEQUENCE{
    #   laneNumber	         LanePosition,
    #   direction		         Direction,
    #   laneWidth		         LaneWidth OPTIONAL,
    #   connectingLane         LanePosition OPTIONAL,
    #   connectingRoadSection  RoadSectionId OPTIONAL,
    #   ...
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF provides basic information about a single lane of a road segment.
    # * It includes the following components: 
    # * 
    # * @field laneNumber: the number associated to the lane that provides a transversal identification. 
    # * 
    # * @field direction: the direction of traffic flow allowed on the lane. 
    # * 
    # * @field laneWidth: the optional width of the lane.
    # *
    # * @field connectingLane: the number of the connecting lane in the next road section, i.e. the number of the lane which the vehicle will use when travelling from one section to the next,
    # * if it does not actively change lanes. If this component is absent, the lane name number remains the same in the next section.
    # *
    # * @field connectingRoadSection: the identifier of the next road section in direction of traffic, that is connecting to the current road section. 
    # * If this component is absent, the connecting road section is the one following the instance where this DF is placed in the @ref RoadConfigurationSectionList.
    # *
    # * @category: Road topology information
    # * @revision: Created in V2.2.1
    #
    
    LanePosition lane_number
    
    Direction direction
    
    LaneWidth lane_width
    bool lane_width_is_present
    
    LanePosition connecting_lane
    bool connecting_lane_is_present
    
    RoadSectionId connecting_road_section
    bool connecting_road_section_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LanePosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LanePosition ::= INTEGER {
    #     offTheRoad           (-1), 
    #     innerHardShoulder    (0), 
    #     outerHardShoulder    (14) 
    # } (-1..14)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
    # *
    # * For right-hand traffic roads, the value shall be set to:
    # * - `-1` if the position is off, i.e. besides the road,
    # * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
    # * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
    # * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
    # *
    # * For left-hand traffic roads, the value shall be set to:
    # * - `-1` if the position is off, i.e. besides the road,
    # * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
    # * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
    # * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
    # *
    # *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
    # *
    # * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
    # * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
    # * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
    # *
    # * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:
    # * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the 
    # *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.
    # * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. 
    # *   The remaining middle lane is assigned to both traffic directions as innermost lane.
    # *
    # * @category: Road topology information
    # * @revision: Description of the legal separation of carriageways added in V2.2.1
    #
    
    int8 value
    int8 MIN = -1
    int8 MAX = 14
    int8 OFF_THE_ROAD = -1
    int8 INNER_HARD_SHOULDER = 0
    int8 OUTER_HARD_SHOULDER = 14
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Direction
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Direction::= INTEGER{
    #     sameDirection     (0),
    #     oppositeDirection (1),
    #     bothDirections    (2),
    #     unavailable       (3)
    #  } (0..3)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates a direction with respect to a defined reference direction.
    # * Example: a reference direction may be implicitly defined by the definition of a geographical zone.
    # *
    # * The value shall be set to:
    # * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,
    # * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,
    # * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,
    # * - 3 - `unavailable`       - to indicate that the information is unavailable.
    # *
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 3
    uint8 SAME_DIRECTION = 0
    uint8 OPPOSITE_DIRECTION = 1
    uint8 BOTH_DIRECTIONS = 2
    uint8 UNAVAILABLE = 3
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LaneWidth
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LaneWidth::= INTEGER (0..1023)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the width of a lane measured at a defined position.
    # *
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 1022`) if the lane width information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
    # * - `1022` if the lane width is out of range, i.e. greater than 10,21 m,
    # * - `1023` if the lane width information is not available.
    # *
    # * The value 0 shall not be used.
    # *
    # * @unit: 0,01 metre
    # * @category: Road topology information
    # * @revision: Created in V2.1.1
    # 
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 1023
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/RoadSectionId
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RoadSectionId::= INTEGER (0..8, ...)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates an ordinal number that represents the position of a component in the list @ref RoadConfigurationSectionList. 
    # *
    # * The value shall be set to:
    # * - `0`     - if no road section is identified
    # * - `1..8`  - for instances 1..8 of @ref RoadConfigurationSectionList 
    # *
    # * @category: Road topology information
    # * @revision: Created in V2.2.1
    #
    
    int64 value
    int64 MIN = 0
    int64 MAX = 8
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new BasicLaneConfiguration(null);
    if (msg.array !== undefined) {
      resolved.array = new Array(msg.array.length);
      for (let i = 0; i < resolved.array.length; ++i) {
        resolved.array[i] = BasicLaneInformation.Resolve(msg.array[i]);
      }
    }
    else {
      resolved.array = []
    }

    return resolved;
    }
};

// Constants for message
BasicLaneConfiguration.Constants = {
  MIN_SIZE: 1,
  MAX_SIZE: 16,
}

module.exports = BasicLaneConfiguration;
