// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let VehicleRole = require('./VehicleRole.js');
let ExteriorLights = require('./ExteriorLights.js');
let Path = require('./Path.js');

//-----------------------------------------------------------

class BasicVehicleContainerLowFrequency {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.vehicle_role = null;
      this.exterior_lights = null;
      this.path_history = null;
    }
    else {
      if (initObj.hasOwnProperty('vehicle_role')) {
        this.vehicle_role = initObj.vehicle_role
      }
      else {
        this.vehicle_role = new VehicleRole();
      }
      if (initObj.hasOwnProperty('exterior_lights')) {
        this.exterior_lights = initObj.exterior_lights
      }
      else {
        this.exterior_lights = new ExteriorLights();
      }
      if (initObj.hasOwnProperty('path_history')) {
        this.path_history = initObj.path_history
      }
      else {
        this.path_history = new Path();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type BasicVehicleContainerLowFrequency
    // Serialize message field [vehicle_role]
    bufferOffset = VehicleRole.serialize(obj.vehicle_role, buffer, bufferOffset);
    // Serialize message field [exterior_lights]
    bufferOffset = ExteriorLights.serialize(obj.exterior_lights, buffer, bufferOffset);
    // Serialize message field [path_history]
    bufferOffset = Path.serialize(obj.path_history, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type BasicVehicleContainerLowFrequency
    let len;
    let data = new BasicVehicleContainerLowFrequency(null);
    // Deserialize message field [vehicle_role]
    data.vehicle_role = VehicleRole.deserialize(buffer, bufferOffset);
    // Deserialize message field [exterior_lights]
    data.exterior_lights = ExteriorLights.deserialize(buffer, bufferOffset);
    // Deserialize message field [path_history]
    data.path_history = Path.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += ExteriorLights.getMessageSize(object.exterior_lights);
    length += Path.getMessageSize(object.path_history);
    return length + 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/BasicVehicleContainerLowFrequency';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'c34d4deea8d3ef6fcd0ed5bff418cd7f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # BasicVehicleContainerLowFrequency  ::= SEQUENCE {
    # 	vehicleRole VehicleRole,
    # 	exteriorLights ExteriorLights,
    # 	pathHistory Path
    # }
    # ------------------------------------------------------------------------------
    # *
    #* This type contains detaild information of the Basic Vehicle Container Low Frequency.
    #*
    #* It shall include the following components:
    #*
    #* @field vehicleRole: represent the role of the vehicle ITS-S that originates the CAM. Only values 0 to 7 shall be used.
    #*
    #* @field exteriorLights: represent the status of the most important exterior lights switches of the vehicle ITS-S that originates the CAM.
    #*
    #* @field pathHistory: which represents the vehicle's recent movement over some past time and/or distance. It consists of a list of path points,
    #* each represented as DF PathPoint. The list of path points may consist of up to 23 elements. 
    #
    
    VehicleRole vehicle_role
    
    ExteriorLights exterior_lights
    
    Path path_history
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/VehicleRole
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # VehicleRole ::= ENUMERATED {
    #     default         (0), 
    #     publicTransport (1), 
    #     specialTransport(2), 
    #     dangerousGoods  (3), 
    #     roadWork        (4), 
    #     rescue          (5), 
    #     emergency       (6), 
    #     safetyCar       (7), 
    #     agriculture     (8), 
    #     commercial      (9), 
    #     military        (10), 
    #     roadOperator    (11), 
    #     taxi            (12), 
    #     uvar            (13), 
    #     rfu1            (14), 
    #     rfu2            (15)
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates the role played by a vehicle at a point in time.
    # *
    # * The value shall be set to:
    # * - 0 `default`          - to indicate the default vehicle role as indicated by the vehicle type,
    # * - 1 `publicTransport`  - to indicate that the vehicle is used to operate public transport service,
    # * - 2 `specialTransport` - to indicate that the vehicle is used for special transport purpose, e.g. oversized trucks,
    # * - 3 `dangerousGoods`   - to indicate that the vehicle is used for dangerous goods transportation,
    # * - 4 `roadWork`         - to indicate that the vehicle is used to realize roadwork or road maintenance mission,
    # * - 5 `rescue`           - to indicate that the vehicle is used for rescue purpose in case of an accident, e.g. as a towing service,
    # * - 6 `emergency`        - to indicate that the vehicle is used for emergency mission, e.g. ambulance, fire brigade,
    # * - 7 `safetyCar`        - to indicate that the vehicle is used for public safety, e.g. patrol,
    # * - 8 `agriculture`      - to indicate that the vehicle is used for agriculture, e.g. farm tractor, 
    # * - 9 `commercial`       - to indicate that the vehicle is used for transportation of commercial goods,
    # * - 10 `military`        - to indicate that the vehicle is used for military purpose, 
    # * - 11 `roadOperator`    - to indicate that the vehicle is used in road operator missions,
    # * - 12 `taxi`            - to indicate that the vehicle is used to provide an authorized taxi service,
    # * - 13 `uvar`            - to indicate that the vehicle is authorized to enter a zone according to the applicable Urban Vehicle Access Restrictions.
    # * - 14 `rfu1`            - is reserved for future usage.
    # * - 15 `rfu2`            - is reserved for future usage.
    # * 
    # * @category: Vehicle Information
    # * @revision: Description updated in V2.1.1 (removed reference to CEN/TS 16157-3), value 13 assigned in V2.2.1
    # 
    
    uint8 value
    uint8 DEFAULT = 0
    uint8 PUBLIC_TRANSPORT = 1
    uint8 SPECIAL_TRANSPORT = 2
    uint8 DANGEROUS_GOODS = 3
    uint8 ROAD_WORK = 4
    uint8 RESCUE = 5
    uint8 EMERGENCY = 6
    uint8 SAFETY_CAR = 7
    uint8 AGRICULTURE = 8
    uint8 COMMERCIAL = 9
    uint8 MILITARY = 10
    uint8 ROAD_OPERATOR = 11
    uint8 TAXI = 12
    uint8 UVAR = 13
    uint8 RFU1 = 14
    uint8 RFU2 = 15
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/ExteriorLights
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ExteriorLights ::= BIT STRING {
    #     lowBeamHeadlightsOn      (0),
    #     highBeamHeadlightsOn     (1),
    #     leftTurnSignalOn         (2),
    #     rightTurnSignalOn        (3),
    #     daytimeRunningLightsOn   (4),
    #     reverseLightOn           (5),
    #     fogLightOn               (6),
    #     parkingLightsOn          (7)
    # } (SIZE(8))
    # ------------------------------------------------------------------------------
    # *
    # * This DE describes the status of the exterior light switches of a vehicle incl. VRU vehicles.
    # *
    # * The corresponding bit shall be set to 1 under the following conditions:
    # * - 0 - `lowBeamHeadlightsOn`    - when the low beam head light switch is on,
    # * - 1 - `highBeamHeadlightsOn`   - when the high beam head light switch is on,
    # * - 2 - `leftTurnSignalOn`       - when the left turnSignal switch is on,
    # * - 3 - `rightTurnSignalOn`      - when the right turn signal switch is on,
    # * - 4 - `daytimeRunningLightsOn` - when the daytime running light switch is on,
    # * - 5 - `reverseLightOn`         - when the reverse light switch is on,
    # * - 6 - `fogLightOn`             - when the tail fog light switch is on,
    # * - 7 - `parkingLightsOn`        - when the parking light switch is on.
    # * 
    # * @note: The value of each bit indicates the state of the switch, which commands the corresponding light.
    # * The bit corresponding to a specific light is set to `1`, when the corresponding switch is turned on,
    # * either manually by the driver or automatically by a vehicle system. The bit value does not indicate
    # * if the corresponding lamps are alight or not.
    # * 
    # * If a vehicle is not equipped with a certain light or if the light switch status information is not available,
    # * the corresponding bit shall be set to `0`.
    # * 
    # * As the bit value indicates only the state of the switch, the turn signal and hazard signal bit values shall not
    # * alternate with the blinking interval.
    # * 
    # * For hazard indicator, the `leftTurnSignalOn (2)` and `rightTurnSignalOn (3)` shall be both set to `1`.
    # * 
    # * @category Vehicle information
    # * @revision: Description revised in V2.1.1
    # 
    
    uint8[] value
    uint8 bits_unused
    uint8 SIZE_BITS = 8
    uint8 BIT_INDEX_LOW_BEAM_HEADLIGHTS_ON = 0
    uint8 BIT_INDEX_HIGH_BEAM_HEADLIGHTS_ON = 1
    uint8 BIT_INDEX_LEFT_TURN_SIGNAL_ON = 2
    uint8 BIT_INDEX_RIGHT_TURN_SIGNAL_ON = 3
    uint8 BIT_INDEX_DAYTIME_RUNNING_LIGHTS_ON = 4
    uint8 BIT_INDEX_REVERSE_LIGHT_ON = 5
    uint8 BIT_INDEX_FOG_LIGHT_ON = 6
    uint8 BIT_INDEX_PARKING_LIGHTS_ON = 7
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Path
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Path::= SEQUENCE (SIZE(0..40)) OF PathPoint
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a path with a set of path points.
    # * It shall contain up to `40` @ref PathPoint. 
    # * 
    # * The first PathPoint presents an offset delta position with regards to an external reference position.
    # * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint. 
    # *
    # * @category: GeoReference information, Vehicle information
    # * @revision: created in V2.1.1 based on PathHistory
    # 
    
    PathPoint[] array
    uint8 MIN_SIZE = 0
    uint8 MAX_SIZE = 40
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/PathPoint
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PathPoint ::= SEQUENCE {
    #     pathPosition     DeltaReferencePosition,
    #     pathDeltaTime    PathDeltaTime OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF defines an offset waypoint position within a path.
    # *
    # * It shall include the following components: 
    # *
    # * @field pathPosition: The waypoint position defined as an offset position with regards to a pre-defined reference position. 
    # *
    # * @field pathDeltaTime: The optional travel time separated from a waypoint to the predefined reference position.
    # *
    # * @category GeoReference information
    # * @revision: semantics updated in V2.1.1
    # 
    
    DeltaReferencePosition path_position
    
    PathDeltaTime path_delta_time
    bool path_delta_time_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/DeltaReferencePosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaReferencePosition ::= SEQUENCE {
    #     deltaLatitude     DeltaLatitude,
    #     deltaLongitude    DeltaLongitude,
    #     deltaAltitude     DeltaAltitude
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF defines a geographical point position as a 3 dimensional offset position to a geographical reference point.
    # *
    # * It shall include the following components: 
    # *
    # * @field deltaLatitude: A delta latitude offset with regards to the latitude value of the reference position.
    # *
    # * @field deltaLongitude: A delta longitude offset with regards to the longitude value of the reference position.
    # *
    # * @field deltaAltitude: A delta altitude offset with regards to the altitude value of the reference position.
    # *
    # * @category: GeoReference information
    # * @revision:  V1.3.1
    # 
    
    DeltaLatitude delta_latitude
    
    DeltaLongitude delta_longitude
    
    DeltaAltitude delta_altitude
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/DeltaLatitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaLatitude ::= INTEGER {
    #     unavailable (131072)
    # } (-131071..131072)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents an offset latitude with regards to a defined latitude value.
    # * It may be used to describe a geographical point with regards to a specific reference geographical position.
    # *
    # * The value shall be set to:
    # * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
    # * - `0` for no latitudinal offset,
    # * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
    # * - `131 072` when the information is unavailable.
    # *
    # * @unit: 10^-7 degree
    # * @category: GeoReference information
    # * @revision: editorial update in V2.1.1
    # 
    
    int32 value
    int32 MIN = -131071
    int32 MAX = 131072
    int32 UNAVAILABLE = 131072
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/DeltaLongitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaLongitude ::= INTEGER {
    #     unavailable (131072)
    # } (-131071..131072)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents an offset longitude with regards to a defined longitude value.
    # * It may be used to describe a geographical point with regards to a specific reference geographical position.
    # *
    # * The value shall be set to:
    # * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the west from the reference position,
    # * - `0` for no longitudinal offset,
    # * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the east from the reference position, 
    # * - `131 072` when the information is unavailable.
    # *
    # * @unit: 10^-7 degree
    # * @category: GeoReference information
    # * @revision: editorial update in V2.1.1
    # 
    
    int32 value
    int32 MIN = -131071
    int32 MAX = 131072
    int32 UNAVAILABLE = 131072
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/DeltaAltitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaAltitude ::= INTEGER {
    #     negativeOutOfRange (-12700),
    #     positiveOutOfRange (12799),
    #     unavailable        (12800)
    # } (-12700..12800)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents an offset altitude with regards to a defined altitude value.
    # * It may be used to describe a geographical point with regards to a specific reference geographical position.
    # *
    # * The value shall be set to:
    # * - `-12 700` for values equal to or lower than -127 metres,
    # * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,
    # * - `0` for no altitudinal offset,
    # * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,
    # * - `12 799` for values equal to or greater than 127,99 metres,
    # * - `12 800` when the information is unavailable.
    # *
    # * @unit: 0,01 metre
    # * @category: GeoReference information
    # * @revision: editorial update in V2.1.1
    # 
    
    int16 value
    int16 MIN = -12700
    int16 MAX = 12800
    int16 NEGATIVE_OUT_OF_RANGE = -12700
    int16 POSITIVE_OUT_OF_RANGE = 12799
    int16 UNAVAILABLE = 12800
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/PathDeltaTime
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PathDeltaTime ::= INTEGER (1..65535, ...) 
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the recorded or estimated travel time between a position and a predefined reference position. 
    # *
    # * @unit 0,01 second
    # * @category: Basic information
    # * @revision: V1.3.1
    # 
    
    int64 value
    int64 MIN = 1
    int64 MAX = 65535
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new BasicVehicleContainerLowFrequency(null);
    if (msg.vehicle_role !== undefined) {
      resolved.vehicle_role = VehicleRole.Resolve(msg.vehicle_role)
    }
    else {
      resolved.vehicle_role = new VehicleRole()
    }

    if (msg.exterior_lights !== undefined) {
      resolved.exterior_lights = ExteriorLights.Resolve(msg.exterior_lights)
    }
    else {
      resolved.exterior_lights = new ExteriorLights()
    }

    if (msg.path_history !== undefined) {
      resolved.path_history = Path.Resolve(msg.path_history)
    }
    else {
      resolved.path_history = new Path()
    }

    return resolved;
    }
};

module.exports = BasicVehicleContainerLowFrequency;
