// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let GeneralizedLanePosition = require('./GeneralizedLanePosition.js');

//-----------------------------------------------------------

class GeneralizedLanePositions {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.array = null;
    }
    else {
      if (initObj.hasOwnProperty('array')) {
        this.array = initObj.array
      }
      else {
        this.array = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GeneralizedLanePositions
    // Serialize message field [array]
    // Serialize the length for message field [array]
    bufferOffset = _serializer.uint32(obj.array.length, buffer, bufferOffset);
    obj.array.forEach((val) => {
      bufferOffset = GeneralizedLanePosition.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GeneralizedLanePositions
    let len;
    let data = new GeneralizedLanePositions(null);
    // Deserialize message field [array]
    // Deserialize array length for message field [array]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.array = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.array[i] = GeneralizedLanePosition.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.array.forEach((val) => {
      length += GeneralizedLanePosition.getMessageSize(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/GeneralizedLanePositions';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '6cdb68db485cb9c95cb5381bd496120d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # GeneralizedLanePositions ::= SEQUENCE (SIZE(1..4)) OF GeneralizedLanePosition
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents transversal position information with respect to the road, at an externally defined reference position. It shall contain a set of up to `4` @ref GeneralizedLanePosition.
    # * Multiple entries can be used to describe several lane positions with the associated confidence, in cases where the reference position cannot be mapped to a single lane.
    # *
    # * @category: Road Topology information
    # * @revision: Created in V2.2.1
    # 
    
    GeneralizedLanePosition[] array
    uint8 MIN_SIZE = 1
    uint8 MAX_SIZE = 4
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/GeneralizedLanePosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # GeneralizedLanePosition ::= SEQUENCE {
    #     lanePositionBased     LanePositionOptions,
    #     mapBased              MapPosition OPTIONAL,
    #     confidence            MetaInformation,
    #     ... 
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents the top-level DF to represent a lane position. A lane position is a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway.
    # *
    # * @note: This DF is the most general way to represent a lane position: it provides a complete set of information regarding a transversal (dimensionless) position on the carriageway at a specific 
    # * reference position, i.e. it provides different options and synonyms to represent the lane at which the reference position (the point) is located. A confidence is used to describe the probability 
    # * that the object is located in the provided lane. The dimension of the object or extension of an area are not considered: See @ref OccupiedLanesWithConfidence for describing the occupation of lanes, 
    # * where the dimensions of an object or the extension of an area is considered.
    # *
    # * It shall include the following components: 
    # *
    # * @field lanePositionBased: lane position information for a defined reference position.
    # * 
    # * @field mapBased: optional lane position information described in the context of a MAPEM as specified in ETSI TS 103 301 [15]. 
    # * If present, it shall describe the same reference position using the lane identification in the MAPEM. This component can be used only if a MAPEM is available for the reference position 
    # * (e.g. on an intersection): In this case it is used as a synonym to the mandatory component lanePositionBased. 
    # * 
    # * @field confidence: confidence information for expressing the probability that the object is located at the indicated lane.  
    # * If the value of the component lanePositionBased is generated directly from the absolute reference position and reference topology information, 
    # * no sensor shall be indicated in the component usedDetectionInformation of the @ref MetaInformation.
    # *
    # * @category: Road Topology information
    # * @revision: newly created in V2.2.1. The previous DF GeneralizedLanePosition is now renamed to @ref LanePositionOptions. 
    # 
    
    LanePositionOptions lane_position_based
    
    MapPosition map_based
    bool map_based_is_present
    
    MetaInformation confidence
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LanePositionOptions
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LanePositionOptions ::= CHOICE {
    #     simplelanePosition                   LanePosition,
    #     simpleLaneType                       LaneType,
    #     detailedlanePosition                 LanePositionAndType,
    #     lanePositionWithLateralDetails       LanePositionWithLateralDetails,
    #     trafficIslandPosition                TrafficIslandPosition,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a set of options to describe a lane position and is the second level DF to represent a lane position. The top-level DFs are @ref GeneralizedLanePosition or @ref OccupiedLanesWithConfidence. 
    # * A lane position is a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway.
    # *
    # * The following options are available:
    # *
    # * @field simplelanePosition: a single lane position without any additional context information.
    # *
    # * @field simpleLaneType: a lane type, to be used when the lane position is unknown but the type of lane is known. This can be used in scenarios where a certain confidence about the used lane type is given 
    # * but no or limited knowledge about the absolute lane number is available. For example, a cyclist on a cycle-lane or vehicles on a specific lane that is unique for the part of the road (e.g. a bus lane).
    # * 
    # * @field detailedlanePosition: a single lane position with additional lane details.
    # * 
    # * @field lanePositionWithLateralDetails: a single lane position with additional details and the lateral position within the lane.
    # *
    # * @field trafficIslandPosition: a position on a traffic island, i.e. between two lanes. 
    # *
    # * @category: Road Topology information
    # * @revision: Created in V2.2.1 from the DF GeneralizedLanePosition of V2.1.1. 
    # 
    
    uint8 choice
    
    LanePosition simplelane_position
    uint8 CHOICE_SIMPLELANE_POSITION = 0
    
    LaneType simple_lane_type
    uint8 CHOICE_SIMPLE_LANE_TYPE = 1
    
    LanePositionAndType detailedlane_position
    uint8 CHOICE_DETAILEDLANE_POSITION = 2
    
    LanePositionWithLateralDetails lane_position_with_lateral_details
    uint8 CHOICE_LANE_POSITION_WITH_LATERAL_DETAILS = 3
    
    TrafficIslandPosition traffic_island_position
    uint8 CHOICE_TRAFFIC_ISLAND_POSITION = 4
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LanePosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LanePosition ::= INTEGER {
    #     offTheRoad           (-1), 
    #     innerHardShoulder    (0), 
    #     outerHardShoulder    (14) 
    # } (-1..14)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
    # *
    # * For right-hand traffic roads, the value shall be set to:
    # * - `-1` if the position is off, i.e. besides the road,
    # * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
    # * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
    # * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
    # *
    # * For left-hand traffic roads, the value shall be set to:
    # * - `-1` if the position is off, i.e. besides the road,
    # * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
    # * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
    # * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
    # *
    # *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
    # *
    # * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
    # * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
    # * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
    # *
    # * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:
    # * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the 
    # *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.
    # * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. 
    # *   The remaining middle lane is assigned to both traffic directions as innermost lane.
    # *
    # * @category: Road topology information
    # * @revision: Description of the legal separation of carriageways added in V2.2.1
    #
    
    int8 value
    int8 MIN = -1
    int8 MAX = 14
    int8 OFF_THE_ROAD = -1
    int8 INNER_HARD_SHOULDER = 0
    int8 OUTER_HARD_SHOULDER = 14
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LaneType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LaneType::= INTEGER{
    # 	traffic              (0),
    # 	through	             (1),
    # 	reversible           (2),
    # 	acceleration         (3),
    # 	deceleration         (4),
    # 	leftHandTurning      (5),
    # 	rightHandTurning     (6),
    # 	dedicatedVehicle     (7),
    # 	bus                  (8),
    # 	taxi                 (9),
    # 	hov                  (10),
    # 	hot                  (11),
    # 	pedestrian           (12),
    # 	cycleLane            (13),
    # 	median               (14),   
    # 	striping             (15),
    # 	trackedVehicle       (16),
    # 	parking	             (17),
    # 	emergency            (18),
    # 	verge                (19),
    # 	minimumRiskManoeuvre (20),
    #     exclusiveCycleLane   (21),
    # 	unknown              (31)
    # }(0..31)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the type of a lane. 
    # * 
    # * The value shall be set to:
    # * - 0	- `traffic`            - Lane dedicated to the movement of vehicles,
    # * - 1	- `through`            - Lane dedicated to the movement of vehicles travelling ahead and not turning,
    # * - 2	- `reversible`         - Lane where the direction of traffic can be changed to match the peak flow,
    # * - 3	- `acceleration`	   - Lane that allows vehicles entering a road to accelerate to the speed of through traffic before merging with it,
    # * - 4	- `deceleration`       - Lane that allows vehicles exiting a road to decelerate before leaving it,
    # * - 5	- `leftHandTurning`    - Lane reserved for slowing down and making a left turn, so as not to disrupt traffic,
    # * - 6	- `rightHandTurning`   - Lane reserved for slowing down and making a right turn so as not to disrupt traffic,
    # * - 7	- `dedicatedVehicle`   - Lane dedicated to movement of motor vehicles with specific characteristics, such as heavy goods vehicles, etc., 
    # * - 8	- `bus`                - Lane dedicated to movement of buses providing public transport,
    # * - 9	- `taxi`               - Lane dedicated to movement of taxis,
    # * - 10	- `hov`                - Carpooling lane or high occupancy vehicle lane,
    # * - 11	- `hot`                - High occupancy vehicle lanes that is allowed to be used without meeting the occupancy criteria by paying a toll,
    # * - 12	- `pedestrian`         - Lanes dedicated to pedestrians such as pedestrian sidewalk paths,
    # * - 13	- `cycleLane`	       - Lane dedicated to exclusive or preferred use by bicycles,
    # * - 14	- `median`             - Lane not dedicated to movement of vehicles but representing a median / central reservation  such as the central median, 
    #                                 separating the two directional carriageways of the highway,
    # * - 15	- `striping`	       - Lane not dedicated to movement of vehicles but covered with roadway markings,
    # * - 16	- `trackedVehicle`     - Lane dedicated to movement of trains, trams and trolleys,
    # * - 17	- `parking`            - Lanes dedicated to vehicles parking, stopping and loading lanes,
    # * - 18	- `emergency`          - Lane dedicated to vehicles in breakdown or to emergency vehicles also called hard shoulder,
    # * - 19	- `verge`              - Lane representing the verge, i.e. a narrow strip of grass or plants and sometimes also trees located between 
    #                                 the road surface edge and the boundary of a road,
    # * - 20	`minimumRiskManoeuvre` - Lane dedicated to automated vehicles making a minimum risk manoeuvre,
    # * - 21	`separatedCycleLane`   - Lane dedicated to exclusive or preferred use by bicycles that is phyisically separated from the vehicle-traffic lanes, e.g. by a verge.
    # * - values 22 to 30             reserved for future use. 
    # *
    # * @category: Road topology information
    # * @revision: Created in V2.1.1, named value 21 added in V2.2.1
    #
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 31
    uint8 TRAFFIC = 0
    uint8 THROUGH = 1
    uint8 REVERSIBLE = 2
    uint8 ACCELERATION = 3
    uint8 DECELERATION = 4
    uint8 LEFT_HAND_TURNING = 5
    uint8 RIGHT_HAND_TURNING = 6
    uint8 DEDICATED_VEHICLE = 7
    uint8 BUS = 8
    uint8 TAXI = 9
    uint8 HOV = 10
    uint8 HOT = 11
    uint8 PEDESTRIAN = 12
    uint8 CYCLE_LANE = 13
    uint8 MEDIAN = 14
    uint8 STRIPING = 15
    uint8 TRACKED_VEHICLE = 16
    uint8 PARKING = 17
    uint8 EMERGENCY = 18
    uint8 VERGE = 19
    uint8 MINIMUM_RISK_MANOEUVRE = 20
    uint8 EXCLUSIVE_CYCLE_LANE = 21
    uint8 UNKNOWN = 31
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LanePositionAndType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LanePositionAndType::= SEQUENCE {
    #     transversalPosition    LanePosition,
    #     laneType               LaneType DEFAULT traffic,
    #     direction              Direction DEFAULT sameDirection,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF indicates a transversal position in resolution of lanes and other associated details.
    # *
    # * It shall include the following components: 
    # * 
    # * @field transversalPosition: the transversal position.
    # * 
    # * @field laneType: the type of the lane identified in the component transversalPosition. By default set to `traffic`.
    # *
    # * @field direction: the traffic direction for the lane position relative to a defined reference direction. By default set to `sameDirection`, i.e. following the reference direction.
    # *
    # * @category Road topology information
    # * @revision: direction added in V2.2.1
    # 
    
    LanePosition transversal_position
    
    LaneType lane_type
    
    Direction direction
    
    
    uint8 LANE_TYPE_DEFAULT = 0
    uint8 DIRECTION_DEFAULT = 0
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Direction
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Direction::= INTEGER{
    #     sameDirection     (0),
    #     oppositeDirection (1),
    #     bothDirections    (2),
    #     unavailable       (3)
    #  } (0..3)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates a direction with respect to a defined reference direction.
    # * Example: a reference direction may be implicitly defined by the definition of a geographical zone.
    # *
    # * The value shall be set to:
    # * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,
    # * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,
    # * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,
    # * - 3 - `unavailable`       - to indicate that the information is unavailable.
    # *
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 3
    uint8 SAME_DIRECTION = 0
    uint8 OPPOSITE_DIRECTION = 1
    uint8 BOTH_DIRECTIONS = 2
    uint8 UNAVAILABLE = 3
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LanePositionWithLateralDetails
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LanePositionWithLateralDetails ::= SEQUENCE {
    #     COMPONENTS OF               LanePositionAndType,
    #     distanceToLeftBorder        StandardLength9b,
    #     distanceToRightBorder       StandardLength9b,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF is a third-level DF that represents a lane position and is an extended version of @ref LanePositionAndType that adds the distances to the left and right lane border.
    # *
    # * It shall additionally include the following components: 
    # *
    # * @field distanceToLeftBorder: the distance of the transversal position to the left lane border. The real value shall be rounded to the next lower encoding-value.
    # *
    # * @field distanceToRightBorder: the distance of the transversal position to the right lane border. The real value shall be rounded to the next lower encoding-value.
    # * 
    # * @category: Road Topology information
    # * @revision: Created in V2.2.1
    # 
    
    StandardLength9b distance_to_left_border
    
    StandardLength9b distance_to_right_border
    
    LanePosition transversal_position
    
    LaneType lane_type
    
    Direction direction
    
    
    uint8 LANE_TYPE_DEFAULT = 0
    uint8 DIRECTION_DEFAULT = 0
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/StandardLength9b
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # StandardLength9b::= INTEGER (0..511)
    # ------------------------------------------------------------------------------
    # *
    # * The DE represents length as a measure of distance between points or as a dimension of an object. 
    # *
    # * @unit: 0,1 metre
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    # 
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 511
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/TrafficIslandPosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # TrafficIslandPosition ::= SEQUENCE {
    #     oneSide      LanePositionAndType,
    #     otherSide    LanePositionAndType,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * Ths DF represents the a position on a traffic island between two lanes. 
    # *
    # * It shall include the following components: 
    # *
    # * @field oneSide: represents one lane.
    # * 
    # * @field otherSide: represents the other lane.
    # * 
    # * @category: Road Topology information
    # * @revision: Created in V2.1.1
    # 
    
    LanePositionAndType one_side
    
    LanePositionAndType other_side
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/MapPosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MapPosition ::= SEQUENCE {
    #     mapReference                MapReference OPTIONAL,
    #     laneId                      Identifier1B OPTIONAL,
    #     connectionId                Identifier1B OPTIONAL, 
    #     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301 [15].
    # *
    # * It shall include the following components: 
    # * 
    # * @field mapReference: optionally identifies the MAPEM containing the topology information.
    # * It is absent if the MAPEM topology is known from the context.
    # * 
    # * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
    # *
    # * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
    # * conflict area of an intersection which connects e.g an ingress with an egress lane.
    # *
    # * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection measured from the start of the lane/connection, along the lane.
    # * 
    # * @category: Road topology information
    # * @revision: Created in V2.1.1, definition of longitudinalLanePosition amended in V2.2.1
    # 
    
    MapReference map_reference
    bool map_reference_is_present
    
    Identifier1B lane_id
    bool lane_id_is_present
    
    Identifier1B connection_id
    bool connection_id_is_present
    
    LongitudinalLanePosition longitudinal_lane_position
    bool longitudinal_lane_position_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/MapReference
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MapReference::= CHOICE {
    # 	roadsegment     RoadSegmentReferenceId,
    # 	intersection    IntersectionReferenceId
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
    # *
    # * The following options are provided:
    # * 
    # * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
    # * 
    # * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
    # *
    # * @category: Road topology information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 choice
    
    RoadSegmentReferenceId roadsegment
    uint8 CHOICE_ROADSEGMENT = 0
    
    IntersectionReferenceId intersection
    uint8 CHOICE_INTERSECTION = 1
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/RoadSegmentReferenceId
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RoadSegmentReferenceId ::= SEQUENCE {
    #     region    Identifier2B OPTIONAL,
    #     id        Identifier2B
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a unique id for a road segment
    # *
    # * It shall include the following components: 
    # *
    # * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
    # * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
    # *
    # * @field id: the identifier of the road segment.
    # *
    # * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
    # * @category: GeoReference information
    # * @revision: created in V2.1.1
    # 
    
    Identifier2B region
    bool region_is_present
    
    Identifier2B id
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Identifier2B
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Identifier2B ::= INTEGER (0..65535)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE is a general identifier.
    # * 
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 65535
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/IntersectionReferenceId
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # IntersectionReferenceId ::= SEQUENCE {
    #     region    Identifier2B OPTIONAL,
    #     id        Identifier2B
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
    # *
    # * It shall include the following components: 
    # *
    # * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
    # * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
    # *
    # * @field id: the identifier of the intersection
    # *
    # * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
    # * @category: Road topology information
    # * @revision: created in V2.1.1
    # 
    
    Identifier2B region
    bool region_is_present
    
    Identifier2B id
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Identifier1B
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Identifier1B ::= INTEGER (0..255)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE is a general identifier.
    # * 
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 255
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LongitudinalLanePosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LongitudinalLanePosition ::= SEQUENCE {
    #     longitudinalLanePositionValue         LongitudinalLanePositionValue,
    #     longitudinalLanePositionConfidence    LongitudinalLanePositionConfidence
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents the estimated position along the longitudinal extension of a carriageway or lane. 
    # *
    # * It shall include the following components: 
    # *
    # * @field  longitudinalLanePositionValue: the mean value of the longitudinal position along the carriageway or lane w.r.t. an externally defined start position.
    # *
    # * @field  longitudinalLanePositionConfidence: The confidence value associated to the value.
    # *
    # * @category: Road topology information
    # * @revision: created in V2.1.1, description revised in V2.2.1
    # 
    
    LongitudinalLanePositionValue longitudinal_lane_position_value
    
    LongitudinalLanePositionConfidence longitudinal_lane_position_confidence
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LongitudinalLanePositionValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LongitudinalLanePositionValue ::= INTEGER {
    #     outOfRange(32766),
    #     unavailable(32767)
    # }(0..32767)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents the longitudinal offset of a map-matched position along a matched lane, beginning from the lane's starting point.
    # * 
    # * The value shall be set to:
    # * - `n` (`n >= 0` and `n < 32766`) if the longitudinal offset information is equal to or less than n x 0,1 metre and more than (n-1) x 0,1 metre,
    # * - `32 766` if the longitudinal offset is out of range, i.e. greater than 3276,5 m,
    # * - `32 767` if the longitudinal offset information is not available. 
    # *
    # * @unit 0,1 metre
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 32767
    uint16 OUT_OF_RANGE = 32766
    uint16 UNAVAILABLE = 32767
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LongitudinalLanePositionConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LongitudinalLanePositionConfidence ::= INTEGER {
    #     outOfRange  (1022),
    #     unavailable (1023)  
    # } (0..1023)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the longitudinal lane position confidence value which represents the estimated accuracy of longitudinal lane position measurement with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # *
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 1 022`) if the  confidence value is equal to or less than n x 0,1 m, and more than (n-1) x 0,1 m,
    # * - `1 022` if the confidence value is out of range i.e. greater than 102,1 m,
    # * - `1 023` if the confidence value is unavailable.
    # *
    # * @unit 0,1 metre
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 1023
    uint16 OUT_OF_RANGE = 1022
    uint16 UNAVAILABLE = 1023
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/MetaInformation
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MetaInformation::=SEQUENCE{		
    #   usedDetectionInformation   SensorTypes, 
    #   usedStoredInformation      StoredInformationType,
    #   confidenceValue            ConfidenceLevel OPTIONAL,
    #   ...
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF provides information about the source of and confidence in information.
    # *
    # * It shall include the following components: 
    # * 
    # * @field usedDetectionInformation: the type of sensor(s) that is used to provide the detection information.
    # * 
    # * @field usedStoredInformation: the type of source of the stored information. 
    # *
    # * @field confidenceValue: an optional confidence value associated to the information. 
    # * 
    # * @category: Basic information
    # * @revision: Created in V2.2.1
    #
    
    SensorTypes used_detection_information
    
    StoredInformationType used_stored_information
    
    ConfidenceLevel confidence_value
    bool confidence_value_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/SensorTypes
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SensorTypes ::= BIT STRING {
    #     undefined         (0),
    #     radar             (1),
    #     lidar             (2),
    #     monovideo         (3),
    #     stereovision      (4),
    #     nightvision       (5),
    #     ultrasonic        (6),
    #     pmd               (7),
    #     inductionLoop     (8),
    #     sphericalCamera   (9),
    #     uwb               (10),
    #     acoustic          (11),
    #     localAggregation  (12),
    #     itsAggregation    (13)
    # } (SIZE (16,... ))
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the type of sensor(s).
    # * The corresponding bit shall be set to 1 under the following conditions:
    # * 
    # * - 0  `undefined`         - in case the sensor type is undefined. 
    # * - 1  `radar`             - in case the sensor is a radar,
    # * - 2  `lidar`             - in case the sensor is a lidar,
    # * - 3  `monovideo`         - in case the sensor is mono video,
    # * - 4  `stereovision`      - in case the sensor is stereo vision,
    # * - 5  `nightvision`       - in case the sensor is night vision,
    # * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
    # * - 7  `pmd`               - in case the sensor is photonic mixing device,
    # * - 8  `inductionLoop`     - in case the sensor is an induction loop,
    # * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
    # * - 10 `uwb`               - in case the sensor is ultra wide band,
    # * - 11 `acoustic`          - in case the sensor is acoustic,
    # * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
    # * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
    # * - 14-15                  - are reserved for future usage.
    # * 
    # * @note: If all bits are set to 0, then no sensor type is used
    # *
    # * @category: Sensing Information
    # * @revision: created in V2.2.1
    #
    
    uint8[] value
    uint8 bits_unused
    int64 MIN_SIZE_BITS = 16
    int64 MAX_SIZE_BITS = 16
    uint8 BIT_INDEX_UNDEFINED = 0
    uint8 BIT_INDEX_RADAR = 1
    uint8 BIT_INDEX_LIDAR = 2
    uint8 BIT_INDEX_MONOVIDEO = 3
    uint8 BIT_INDEX_STEREOVISION = 4
    uint8 BIT_INDEX_NIGHTVISION = 5
    uint8 BIT_INDEX_ULTRASONIC = 6
    uint8 BIT_INDEX_PMD = 7
    uint8 BIT_INDEX_INDUCTION_LOOP = 8
    uint8 BIT_INDEX_SPHERICAL_CAMERA = 9
    uint8 BIT_INDEX_UWB = 10
    uint8 BIT_INDEX_ACOUSTIC = 11
    uint8 BIT_INDEX_LOCAL_AGGREGATION = 12
    uint8 BIT_INDEX_ITS_AGGREGATION = 13
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/StoredInformationType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # StoredInformationType::= BIT STRING {
    #     undefined       (0),
    #     staticDb	    (1),    
    #     dynamicDb   	(2),
    #     realTimeDb  	(3),
    #     map		    	(4)	
    # } (SIZE (8,... )) 
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the type of stored information.
    # *
    # * The corresponding bit shall be set to 1 under the following conditions:
    # * 
    # * - `0` undefined        - in case the stored information type is undefined. 
    # * - `1` staticDb         - in case the stored information type is a static database.
    # * - `2` dynamicDb        - in case the stored information type is a dynamic database
    # * - `3` realTimeDb       - in case the stored information type is a real time updated database.
    # * - `4` map              - in case the stored information type is a road topology map.
    # * - Bits 5 to 7          - are reserved for future use.
    # *
    # * @note: If all bits are set to 0, then no stored information type is used
    # *
    # * @category: Basic Information
    # * @revision: created in V2.2.1
    #
    
    uint8[] value
    uint8 bits_unused
    int64 MIN_SIZE_BITS = 8
    int64 MAX_SIZE_BITS = 8
    uint8 BIT_INDEX_UNDEFINED = 0
    uint8 BIT_INDEX_STATIC_DB = 1
    uint8 BIT_INDEX_DYNAMIC_DB = 2
    uint8 BIT_INDEX_REAL_TIME_DB = 3
    uint8 BIT_INDEX_MAP = 4
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/ConfidenceLevel
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ConfidenceLevel ::= INTEGER {
    #     unavailable (101)  
    # } (1..101)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents a confidence level in percentage.
    # * 
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
    # * - `101`                   : in case the confidence level is not available.
    # *
    # * @unit Percent 
    # * @category: Basic information 
    # * @revision: Created in V2.1.1 
    #
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 101
    uint8 UNAVAILABLE = 101
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GeneralizedLanePositions(null);
    if (msg.array !== undefined) {
      resolved.array = new Array(msg.array.length);
      for (let i = 0; i < resolved.array.length; ++i) {
        resolved.array[i] = GeneralizedLanePosition.Resolve(msg.array[i]);
      }
    }
    else {
      resolved.array = []
    }

    return resolved;
    }
};

// Constants for message
GeneralizedLanePositions.Constants = {
  MIN_SIZE: 1,
  MAX_SIZE: 4,
}

module.exports = GeneralizedLanePositions;
