// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Latitude = require('./Latitude.js');
let Longitude = require('./Longitude.js');
let AltitudeValue = require('./AltitudeValue.js');

//-----------------------------------------------------------

class GeoPosition {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.latitude = null;
      this.longitude = null;
      this.altitude = null;
    }
    else {
      if (initObj.hasOwnProperty('latitude')) {
        this.latitude = initObj.latitude
      }
      else {
        this.latitude = new Latitude();
      }
      if (initObj.hasOwnProperty('longitude')) {
        this.longitude = initObj.longitude
      }
      else {
        this.longitude = new Longitude();
      }
      if (initObj.hasOwnProperty('altitude')) {
        this.altitude = initObj.altitude
      }
      else {
        this.altitude = new AltitudeValue();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GeoPosition
    // Serialize message field [latitude]
    bufferOffset = Latitude.serialize(obj.latitude, buffer, bufferOffset);
    // Serialize message field [longitude]
    bufferOffset = Longitude.serialize(obj.longitude, buffer, bufferOffset);
    // Serialize message field [altitude]
    bufferOffset = AltitudeValue.serialize(obj.altitude, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GeoPosition
    let len;
    let data = new GeoPosition(null);
    // Deserialize message field [latitude]
    data.latitude = Latitude.deserialize(buffer, bufferOffset);
    // Deserialize message field [longitude]
    data.longitude = Longitude.deserialize(buffer, bufferOffset);
    // Deserialize message field [altitude]
    data.altitude = AltitudeValue.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 12;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/GeoPosition';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '21582c9df7e23683b4f8a80362f391aa';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # GeoPosition::= SEQUENCE{
    # 	latitude   Latitude,
    # 	longitude  Longitude,
    #     altitude   AltitudeValue DEFAULT unavailable
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF indicates a geographical position.
    # *
    # * It shall include the following components: 
    # *
    # * @field latitude: the latitude of the geographical position.
    # *
    # * @field longitude: the longitude of the geographical position.
    # *
    # * @field altitude: the altitude of the geographical position with default value unavailable.
    # *
    #
    
    Latitude latitude
    
    Longitude longitude
    
    AltitudeValue altitude
    
    
    int32 ALTITUDE_DEFAULT = 800001
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Latitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Latitude ::= INTEGER {
    #     unavailable(900000001)
    # } (-900000000..900000001)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the absolute geographical latitude in a WGS84 coordinate system, providing a range of 90 degrees in north or
    # * in south hemisphere.
    # * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    # *
    # * The value shall be set to:
    # * - `n` (`n >= -900 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for latitudes south of the Equator,
    # * - `0` is used for the latitude of the equator,
    # * - `n` (`n > 0` and `n < 900 000 001`) x 10^-7 degree, i.e. positive values for latitudes north of the Equator,
    # * - `900 000 001` when the information is unavailable.
    # *
    # * @unit: 10^-7 degree
    # * @category: GeoReference information
    # * @revision: Editorial update in V2.1.1
    # 
    
    int32 value
    int32 MIN = -900000000
    int32 MAX = 900000001
    int32 UNAVAILABLE = 900000001
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Longitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Longitude ::= INTEGER {
    #     valueNotUsed (-1800000000),
    #     unavailable  (1800000001)
    # } (-1800000000..1800000001)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
    # * to the east or to the west of the prime meridian.
    # * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    # *
    # * The value shall be set to:
    # * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
    # * - `0` to indicate the prime meridian,
    # * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
    # * - `1 800 000 001` when the information is unavailable.
    # *
    # * The value -1 800 000 000 shall not be used. 
    # * 
    # * @unit: 10^-7 degree
    # * @category: GeoReference information
    # * @revision: Description revised in V2.1.1
    # 
    
    int32 value
    int32 MIN = -1800000000
    int32 MAX = 1800000001
    int32 VALUE_NOT_USED = -1800000000
    int32 UNAVAILABLE = 1800000001
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/AltitudeValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AltitudeValue ::= INTEGER {
    #     negativeOutOfRange (-100000),
    #     postiveOutOfRange  (800000),
    #     unavailable        (800001)
    # } (-100000..800001)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the altitude value in a WGS84 coordinate system.
    # * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    # *
    # * The value shall be set to: 
    # * - `-100 000` if the altitude is equal to or less than -1 000 m,
    # * - `n` (`n > -100 000` and `n < 800 000`) if the altitude is equal to or less than n  x 0,01 metre and greater than (n-1) x 0,01 metre,
    # * - `800 000` if the altitude  greater than 7 999,99 m,
    # * - `800 001` if the information is not available.
    # *
    # * @note: the range of this DE does not use the full binary encoding range, but all reasonable values are covered. In order to cover all possible altitude ranges a larger encoding would be necessary.
    # * @unit: 0,01 metre
    # * @category: GeoReference information
    # * @revision: Description revised in V2.1.1 (definition of 800 000 has slightly changed) 
    # 
    
    int32 value
    int32 MIN = -100000
    int32 MAX = 800001
    int32 NEGATIVE_OUT_OF_RANGE = -100000
    int32 POSTIVE_OUT_OF_RANGE = 800000
    int32 UNAVAILABLE = 800001
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GeoPosition(null);
    if (msg.latitude !== undefined) {
      resolved.latitude = Latitude.Resolve(msg.latitude)
    }
    else {
      resolved.latitude = new Latitude()
    }

    if (msg.longitude !== undefined) {
      resolved.longitude = Longitude.Resolve(msg.longitude)
    }
    else {
      resolved.longitude = new Longitude()
    }

    if (msg.altitude !== undefined) {
      resolved.altitude = AltitudeValue.Resolve(msg.altitude)
    }
    else {
      resolved.altitude = new AltitudeValue()
    }

    return resolved;
    }
};

// Constants for message
GeoPosition.Constants = {
  ALTITUDE_DEFAULT: 800001,
}

module.exports = GeoPosition;
