// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Provider = require('./Provider.js');
let IviIdentificationNumber = require('./IviIdentificationNumber.js');

//-----------------------------------------------------------

class IvimReference {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.service_provider_id = null;
      this.ivi_identification_number = null;
    }
    else {
      if (initObj.hasOwnProperty('service_provider_id')) {
        this.service_provider_id = initObj.service_provider_id
      }
      else {
        this.service_provider_id = new Provider();
      }
      if (initObj.hasOwnProperty('ivi_identification_number')) {
        this.ivi_identification_number = initObj.ivi_identification_number
      }
      else {
        this.ivi_identification_number = new IviIdentificationNumber();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type IvimReference
    // Serialize message field [service_provider_id]
    bufferOffset = Provider.serialize(obj.service_provider_id, buffer, bufferOffset);
    // Serialize message field [ivi_identification_number]
    bufferOffset = IviIdentificationNumber.serialize(obj.ivi_identification_number, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type IvimReference
    let len;
    let data = new IvimReference(null);
    // Deserialize message field [service_provider_id]
    data.service_provider_id = Provider.deserialize(buffer, bufferOffset);
    // Deserialize message field [ivi_identification_number]
    data.ivi_identification_number = IviIdentificationNumber.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += Provider.getMessageSize(object.service_provider_id);
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/IvimReference';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '711106f8fc533db4c4f0ce3f20eac088';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # IvimReference::= SEQUENCE {
    #     serviceProviderId         Provider, 
    #     iviIdentificationNumber   IviIdentificationNumber
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF provides the reference to the information contained in a IVIM according to ETSI TS 103 301 [15]. 
    # *
    # * It shall include the following components: 
    # * 
    # * @field serviceProviderId: identifier of the organization that provided the IVIM.
    # *
    # * @field iviIdentificationNumber: identifier of the IVIM, as assigned by the organization identified in serviceProviderId.
    # *
    # * @category: Communication information
    # * @revision: Created in V2.2.1
    # 
    
    Provider service_provider_id
    
    IviIdentificationNumber ivi_identification_number
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Provider
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Provider ::= SEQUENCE {
    # 	countryCode		CountryCode,
    # 	providerIdentifier	IssuerIdentifier
    # } 
    # ------------------------------------------------------------------------------
    # *
    # * This DF identifies an organization.
    # *
    # * It shall include the following components: 
    # * 
    # * @field countryCode: represents the country code that identifies the country of the national registration administrator for issuers according to ISO 14816.
    # *
    # * @field providerIdentifier: identifies the organization according to the national ISO 14816 register for issuers.
    # *
    # * @note: See https://www.itsstandards.eu/registries/register-of-nra-i-cs1/ for a list of national registration administrators and their respective registers
    # * 
    # * @category: Communication information
    # * @revision: Created in V2.2.1 based on ISO 17573-3 [24]
    # 
    
    CountryCode country_code
    
    IssuerIdentifier provider_identifier
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/CountryCode
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CountryCode ::= BIT STRING(SIZE(10))
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents an ISO 3166-1 [25] country code encoded using ITA-2 encoding.
    # *
    # * @category: Basic information
    # * @revision: Created in V2.2.1 based on ISO 14816 [23]
    #
    
    uint8[] value
    uint8 bits_unused
    uint8 SIZE_BITS = 10
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/IssuerIdentifier
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # IssuerIdentifier ::= INTEGER(0 .. 16383)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represent the identifier of an organization according to the applicable registry.
    # *
    # * @category: Basic information
    # * @revision: Created in V2.2.1 based on ISO 14816 [23]
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 16383
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/IviIdentificationNumber
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # IviIdentificationNumber::= INTEGER(1..32767,..., 8388607) 
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents the identifier of the IVIM.
    # *
    # * @category: Basic information
    # * @revision: Created in V2.2.1 based on ETSI TS 103 301 [15]
    #
    
    int64 value
    int64 MIN = 1
    int64 MAX = 32767
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new IvimReference(null);
    if (msg.service_provider_id !== undefined) {
      resolved.service_provider_id = Provider.Resolve(msg.service_provider_id)
    }
    else {
      resolved.service_provider_id = new Provider()
    }

    if (msg.ivi_identification_number !== undefined) {
      resolved.ivi_identification_number = IviIdentificationNumber.Resolve(msg.ivi_identification_number)
    }
    else {
      resolved.ivi_identification_number = new IviIdentificationNumber()
    }

    return resolved;
    }
};

module.exports = IvimReference;
