// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let LanePosition = require('./LanePosition.js');
let LaneType = require('./LaneType.js');
let Direction = require('./Direction.js');

//-----------------------------------------------------------

class LanePositionAndType {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.transversal_position = null;
      this.lane_type = null;
      this.direction = null;
    }
    else {
      if (initObj.hasOwnProperty('transversal_position')) {
        this.transversal_position = initObj.transversal_position
      }
      else {
        this.transversal_position = new LanePosition();
      }
      if (initObj.hasOwnProperty('lane_type')) {
        this.lane_type = initObj.lane_type
      }
      else {
        this.lane_type = new LaneType();
      }
      if (initObj.hasOwnProperty('direction')) {
        this.direction = initObj.direction
      }
      else {
        this.direction = new Direction();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type LanePositionAndType
    // Serialize message field [transversal_position]
    bufferOffset = LanePosition.serialize(obj.transversal_position, buffer, bufferOffset);
    // Serialize message field [lane_type]
    bufferOffset = LaneType.serialize(obj.lane_type, buffer, bufferOffset);
    // Serialize message field [direction]
    bufferOffset = Direction.serialize(obj.direction, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type LanePositionAndType
    let len;
    let data = new LanePositionAndType(null);
    // Deserialize message field [transversal_position]
    data.transversal_position = LanePosition.deserialize(buffer, bufferOffset);
    // Deserialize message field [lane_type]
    data.lane_type = LaneType.deserialize(buffer, bufferOffset);
    // Deserialize message field [direction]
    data.direction = Direction.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 3;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/LanePositionAndType';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e89fa1c156114f78ca3d37ce77bb51d8';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LanePositionAndType::= SEQUENCE {
    #     transversalPosition    LanePosition,
    #     laneType               LaneType DEFAULT traffic,
    #     direction              Direction DEFAULT sameDirection,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF indicates a transversal position in resolution of lanes and other associated details.
    # *
    # * It shall include the following components: 
    # * 
    # * @field transversalPosition: the transversal position.
    # * 
    # * @field laneType: the type of the lane identified in the component transversalPosition. By default set to `traffic`.
    # *
    # * @field direction: the traffic direction for the lane position relative to a defined reference direction. By default set to `sameDirection`, i.e. following the reference direction.
    # *
    # * @category Road topology information
    # * @revision: direction added in V2.2.1
    # 
    
    LanePosition transversal_position
    
    LaneType lane_type
    
    Direction direction
    
    
    uint8 LANE_TYPE_DEFAULT = 0
    uint8 DIRECTION_DEFAULT = 0
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LanePosition
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LanePosition ::= INTEGER {
    #     offTheRoad           (-1), 
    #     innerHardShoulder    (0), 
    #     outerHardShoulder    (14) 
    # } (-1..14)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. 
    # *
    # * For right-hand traffic roads, the value shall be set to:
    # * - `-1` if the position is off, i.e. besides the road,
    # * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,
    # * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,
    # * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).
    # *
    # * For left-hand traffic roads, the value shall be set to:
    # * - `-1` if the position is off, i.e. besides the road,
    # * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,
    # * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,
    # * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).
    # *
    # *  @note: in practice this means that the position is counted from "inside" to "outside" no matter which traffic practice is used.
    # *
    # * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. 
    # * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), 
    # * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). 
    # *
    # * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:
    # * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the 
    # *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.
    # * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. 
    # *   The remaining middle lane is assigned to both traffic directions as innermost lane.
    # *
    # * @category: Road topology information
    # * @revision: Description of the legal separation of carriageways added in V2.2.1
    #
    
    int8 value
    int8 MIN = -1
    int8 MAX = 14
    int8 OFF_THE_ROAD = -1
    int8 INNER_HARD_SHOULDER = 0
    int8 OUTER_HARD_SHOULDER = 14
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/LaneType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # LaneType::= INTEGER{
    # 	traffic              (0),
    # 	through	             (1),
    # 	reversible           (2),
    # 	acceleration         (3),
    # 	deceleration         (4),
    # 	leftHandTurning      (5),
    # 	rightHandTurning     (6),
    # 	dedicatedVehicle     (7),
    # 	bus                  (8),
    # 	taxi                 (9),
    # 	hov                  (10),
    # 	hot                  (11),
    # 	pedestrian           (12),
    # 	cycleLane            (13),
    # 	median               (14),   
    # 	striping             (15),
    # 	trackedVehicle       (16),
    # 	parking	             (17),
    # 	emergency            (18),
    # 	verge                (19),
    # 	minimumRiskManoeuvre (20),
    #     exclusiveCycleLane   (21),
    # 	unknown              (31)
    # }(0..31)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the type of a lane. 
    # * 
    # * The value shall be set to:
    # * - 0	- `traffic`            - Lane dedicated to the movement of vehicles,
    # * - 1	- `through`            - Lane dedicated to the movement of vehicles travelling ahead and not turning,
    # * - 2	- `reversible`         - Lane where the direction of traffic can be changed to match the peak flow,
    # * - 3	- `acceleration`	   - Lane that allows vehicles entering a road to accelerate to the speed of through traffic before merging with it,
    # * - 4	- `deceleration`       - Lane that allows vehicles exiting a road to decelerate before leaving it,
    # * - 5	- `leftHandTurning`    - Lane reserved for slowing down and making a left turn, so as not to disrupt traffic,
    # * - 6	- `rightHandTurning`   - Lane reserved for slowing down and making a right turn so as not to disrupt traffic,
    # * - 7	- `dedicatedVehicle`   - Lane dedicated to movement of motor vehicles with specific characteristics, such as heavy goods vehicles, etc., 
    # * - 8	- `bus`                - Lane dedicated to movement of buses providing public transport,
    # * - 9	- `taxi`               - Lane dedicated to movement of taxis,
    # * - 10	- `hov`                - Carpooling lane or high occupancy vehicle lane,
    # * - 11	- `hot`                - High occupancy vehicle lanes that is allowed to be used without meeting the occupancy criteria by paying a toll,
    # * - 12	- `pedestrian`         - Lanes dedicated to pedestrians such as pedestrian sidewalk paths,
    # * - 13	- `cycleLane`	       - Lane dedicated to exclusive or preferred use by bicycles,
    # * - 14	- `median`             - Lane not dedicated to movement of vehicles but representing a median / central reservation  such as the central median, 
    #                                 separating the two directional carriageways of the highway,
    # * - 15	- `striping`	       - Lane not dedicated to movement of vehicles but covered with roadway markings,
    # * - 16	- `trackedVehicle`     - Lane dedicated to movement of trains, trams and trolleys,
    # * - 17	- `parking`            - Lanes dedicated to vehicles parking, stopping and loading lanes,
    # * - 18	- `emergency`          - Lane dedicated to vehicles in breakdown or to emergency vehicles also called hard shoulder,
    # * - 19	- `verge`              - Lane representing the verge, i.e. a narrow strip of grass or plants and sometimes also trees located between 
    #                                 the road surface edge and the boundary of a road,
    # * - 20	`minimumRiskManoeuvre` - Lane dedicated to automated vehicles making a minimum risk manoeuvre,
    # * - 21	`separatedCycleLane`   - Lane dedicated to exclusive or preferred use by bicycles that is phyisically separated from the vehicle-traffic lanes, e.g. by a verge.
    # * - values 22 to 30             reserved for future use. 
    # *
    # * @category: Road topology information
    # * @revision: Created in V2.1.1, named value 21 added in V2.2.1
    #
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 31
    uint8 TRAFFIC = 0
    uint8 THROUGH = 1
    uint8 REVERSIBLE = 2
    uint8 ACCELERATION = 3
    uint8 DECELERATION = 4
    uint8 LEFT_HAND_TURNING = 5
    uint8 RIGHT_HAND_TURNING = 6
    uint8 DEDICATED_VEHICLE = 7
    uint8 BUS = 8
    uint8 TAXI = 9
    uint8 HOV = 10
    uint8 HOT = 11
    uint8 PEDESTRIAN = 12
    uint8 CYCLE_LANE = 13
    uint8 MEDIAN = 14
    uint8 STRIPING = 15
    uint8 TRACKED_VEHICLE = 16
    uint8 PARKING = 17
    uint8 EMERGENCY = 18
    uint8 VERGE = 19
    uint8 MINIMUM_RISK_MANOEUVRE = 20
    uint8 EXCLUSIVE_CYCLE_LANE = 21
    uint8 UNKNOWN = 31
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Direction
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Direction::= INTEGER{
    #     sameDirection     (0),
    #     oppositeDirection (1),
    #     bothDirections    (2),
    #     unavailable       (3)
    #  } (0..3)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates a direction with respect to a defined reference direction.
    # * Example: a reference direction may be implicitly defined by the definition of a geographical zone.
    # *
    # * The value shall be set to:
    # * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,
    # * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,
    # * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,
    # * - 3 - `unavailable`       - to indicate that the information is unavailable.
    # *
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 3
    uint8 SAME_DIRECTION = 0
    uint8 OPPOSITE_DIRECTION = 1
    uint8 BOTH_DIRECTIONS = 2
    uint8 UNAVAILABLE = 3
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new LanePositionAndType(null);
    if (msg.transversal_position !== undefined) {
      resolved.transversal_position = LanePosition.Resolve(msg.transversal_position)
    }
    else {
      resolved.transversal_position = new LanePosition()
    }

    if (msg.lane_type !== undefined) {
      resolved.lane_type = LaneType.Resolve(msg.lane_type)
    }
    else {
      resolved.lane_type = new LaneType()
    }

    if (msg.direction !== undefined) {
      resolved.direction = Direction.Resolve(msg.direction)
    }
    else {
      resolved.direction = new Direction()
    }

    return resolved;
    }
};

// Constants for message
LanePositionAndType.Constants = {
  LANE_TYPE_DEFAULT: 0,
  DIRECTION_DEFAULT: 0,
}

module.exports = LanePositionAndType;
