// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MapReference = require('./MapReference.js');
let MapemLaneList = require('./MapemLaneList.js');
let MapemConnectionList = require('./MapemConnectionList.js');

//-----------------------------------------------------------

class MapemElementReference {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.map_reference = null;
      this.map_reference_is_present = null;
      this.lane_ids = null;
      this.lane_ids_is_present = null;
      this.connection_ids = null;
      this.connection_ids_is_present = null;
    }
    else {
      if (initObj.hasOwnProperty('map_reference')) {
        this.map_reference = initObj.map_reference
      }
      else {
        this.map_reference = new MapReference();
      }
      if (initObj.hasOwnProperty('map_reference_is_present')) {
        this.map_reference_is_present = initObj.map_reference_is_present
      }
      else {
        this.map_reference_is_present = false;
      }
      if (initObj.hasOwnProperty('lane_ids')) {
        this.lane_ids = initObj.lane_ids
      }
      else {
        this.lane_ids = new MapemLaneList();
      }
      if (initObj.hasOwnProperty('lane_ids_is_present')) {
        this.lane_ids_is_present = initObj.lane_ids_is_present
      }
      else {
        this.lane_ids_is_present = false;
      }
      if (initObj.hasOwnProperty('connection_ids')) {
        this.connection_ids = initObj.connection_ids
      }
      else {
        this.connection_ids = new MapemConnectionList();
      }
      if (initObj.hasOwnProperty('connection_ids_is_present')) {
        this.connection_ids_is_present = initObj.connection_ids_is_present
      }
      else {
        this.connection_ids_is_present = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MapemElementReference
    // Serialize message field [map_reference]
    bufferOffset = MapReference.serialize(obj.map_reference, buffer, bufferOffset);
    // Serialize message field [map_reference_is_present]
    bufferOffset = _serializer.bool(obj.map_reference_is_present, buffer, bufferOffset);
    // Serialize message field [lane_ids]
    bufferOffset = MapemLaneList.serialize(obj.lane_ids, buffer, bufferOffset);
    // Serialize message field [lane_ids_is_present]
    bufferOffset = _serializer.bool(obj.lane_ids_is_present, buffer, bufferOffset);
    // Serialize message field [connection_ids]
    bufferOffset = MapemConnectionList.serialize(obj.connection_ids, buffer, bufferOffset);
    // Serialize message field [connection_ids_is_present]
    bufferOffset = _serializer.bool(obj.connection_ids_is_present, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MapemElementReference
    let len;
    let data = new MapemElementReference(null);
    // Deserialize message field [map_reference]
    data.map_reference = MapReference.deserialize(buffer, bufferOffset);
    // Deserialize message field [map_reference_is_present]
    data.map_reference_is_present = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [lane_ids]
    data.lane_ids = MapemLaneList.deserialize(buffer, bufferOffset);
    // Deserialize message field [lane_ids_is_present]
    data.lane_ids_is_present = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [connection_ids]
    data.connection_ids = MapemConnectionList.deserialize(buffer, bufferOffset);
    // Deserialize message field [connection_ids_is_present]
    data.connection_ids_is_present = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += MapemLaneList.getMessageSize(object.lane_ids);
    length += MapemConnectionList.getMessageSize(object.connection_ids);
    return length + 14;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/MapemElementReference';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b0c60c03e0f131b572cc7ee98e082a5d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MapemElementReference::= SEQUENCE {
    #   mapReference      MapReference OPTIONAL,
    #   laneIds           MapemLaneList  OPTIONAL,
    #   connectionIds	    MapemConnectionList  OPTIONAL,		
    #   ...
    # } 
    # ------------------------------------------------------------------------------
    # * 
    # * This DF provides references to an element described in a MAPEM according to ETSI TS 103 301 [i.15], such as a lane or connection at a specific intersection or road segment. 
    # * 
    # * It shall include the following components: 
    # * 
    # * @field mapReference: the optional reference to a MAPEM that describes the intersection or road segment. It is absent if the MAPEM topology is known from the context.
    # * 
    # * @field laneIds: the optional list of the identifiers of the lanes to be referenced. 
    # * 
    # * @field connectionIds: the optional list of the identifiers of the connections to be referenced. 
    # *
    # * @category: Road topology information
    # * @revision: Created in V2.2.1
    #
    
    MapReference map_reference
    bool map_reference_is_present
    
    MapemLaneList lane_ids
    bool lane_ids_is_present
    
    MapemConnectionList connection_ids
    bool connection_ids_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/MapReference
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MapReference::= CHOICE {
    # 	roadsegment     RoadSegmentReferenceId,
    # 	intersection    IntersectionReferenceId
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF provides the reference to the information contained in a MAPEM according to ETSI TS 103 301 [15]. 
    # *
    # * The following options are provided:
    # * 
    # * @field roadsegment: option that identifies the description of a road segment contained in a MAPEM.
    # * 
    # * @field intersection: option that identifies the description of an intersection contained in a MAPEM.
    # *
    # * @category: Road topology information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 choice
    
    RoadSegmentReferenceId roadsegment
    uint8 CHOICE_ROADSEGMENT = 0
    
    IntersectionReferenceId intersection
    uint8 CHOICE_INTERSECTION = 1
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/RoadSegmentReferenceId
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RoadSegmentReferenceId ::= SEQUENCE {
    #     region    Identifier2B OPTIONAL,
    #     id        Identifier2B
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a unique id for a road segment
    # *
    # * It shall include the following components: 
    # *
    # * @field region: the optional identifier of the entity that is responsible for the region in which the road segment is placed.
    # * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
    # *
    # * @field id: the identifier of the road segment.
    # *
    # * @note: when the component region is present, the RoadSegmentReferenceId is guaranteed to be globally unique.
    # * @category: GeoReference information
    # * @revision: created in V2.1.1
    # 
    
    Identifier2B region
    bool region_is_present
    
    Identifier2B id
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Identifier2B
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Identifier2B ::= INTEGER (0..65535)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE is a general identifier.
    # * 
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 65535
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/IntersectionReferenceId
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # IntersectionReferenceId ::= SEQUENCE {
    #     region    Identifier2B OPTIONAL,
    #     id        Identifier2B
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a unique id for an intersection, in accordance with ETSI TS 103 301 [15].
    # *
    # * It shall include the following components: 
    # *
    # * @field region: the optional identifier of the entity that is responsible for the region in which the intersection is placed.
    # * It is the duty of that entity to guarantee that the @ref Id is unique within the region.
    # *
    # * @field id: the identifier of the intersection
    # *
    # * @note: when the component region is present, the IntersectionReferenceId is guaranteed to be globally unique.
    # * @category: Road topology information
    # * @revision: created in V2.1.1
    # 
    
    Identifier2B region
    bool region_is_present
    
    Identifier2B id
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/MapemLaneList
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MapemLaneList ::=  SEQUENCE (SIZE(1..8,...)) OF Identifier1B
    # ------------------------------------------------------------------------------
    # * 
    # * This DF provides references to MAPEM lanes using a list of @ref Identifier1B.
    # *
    # * @category: Road topology information
    # * @revision: Created in 2.2.1
    #
    
    Identifier1B[] array
    int64 MIN_SIZE = 1
    int64 MAX_SIZE = 8
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Identifier1B
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Identifier1B ::= INTEGER (0..255)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE is a general identifier.
    # * 
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 255
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/MapemConnectionList
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MapemConnectionList ::=  SEQUENCE (SIZE(1..8,...)) OF Identifier1B
    # ------------------------------------------------------------------------------
    # * 
    # * This DF provides references to MAPEM connections using a list of @ref Identifier1B.
    # * Note: connections are  allowed �maneuvers� (e.g. an ingress / egress relation) on an intersection.
    # *
    # * @category: Road topology information
    # * @revision: Created in V2.2.1
    #
    
    Identifier1B[] array
    int64 MIN_SIZE = 1
    int64 MAX_SIZE = 8
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MapemElementReference(null);
    if (msg.map_reference !== undefined) {
      resolved.map_reference = MapReference.Resolve(msg.map_reference)
    }
    else {
      resolved.map_reference = new MapReference()
    }

    if (msg.map_reference_is_present !== undefined) {
      resolved.map_reference_is_present = msg.map_reference_is_present;
    }
    else {
      resolved.map_reference_is_present = false
    }

    if (msg.lane_ids !== undefined) {
      resolved.lane_ids = MapemLaneList.Resolve(msg.lane_ids)
    }
    else {
      resolved.lane_ids = new MapemLaneList()
    }

    if (msg.lane_ids_is_present !== undefined) {
      resolved.lane_ids_is_present = msg.lane_ids_is_present;
    }
    else {
      resolved.lane_ids_is_present = false
    }

    if (msg.connection_ids !== undefined) {
      resolved.connection_ids = MapemConnectionList.Resolve(msg.connection_ids)
    }
    else {
      resolved.connection_ids = new MapemConnectionList()
    }

    if (msg.connection_ids_is_present !== undefined) {
      resolved.connection_ids_is_present = msg.connection_ids_is_present;
    }
    else {
      resolved.connection_ids_is_present = false
    }

    return resolved;
    }
};

module.exports = MapemElementReference;
