// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let SensorTypes = require('./SensorTypes.js');
let StoredInformationType = require('./StoredInformationType.js');
let ConfidenceLevel = require('./ConfidenceLevel.js');

//-----------------------------------------------------------

class MetaInformation {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.used_detection_information = null;
      this.used_stored_information = null;
      this.confidence_value = null;
      this.confidence_value_is_present = null;
    }
    else {
      if (initObj.hasOwnProperty('used_detection_information')) {
        this.used_detection_information = initObj.used_detection_information
      }
      else {
        this.used_detection_information = new SensorTypes();
      }
      if (initObj.hasOwnProperty('used_stored_information')) {
        this.used_stored_information = initObj.used_stored_information
      }
      else {
        this.used_stored_information = new StoredInformationType();
      }
      if (initObj.hasOwnProperty('confidence_value')) {
        this.confidence_value = initObj.confidence_value
      }
      else {
        this.confidence_value = new ConfidenceLevel();
      }
      if (initObj.hasOwnProperty('confidence_value_is_present')) {
        this.confidence_value_is_present = initObj.confidence_value_is_present
      }
      else {
        this.confidence_value_is_present = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MetaInformation
    // Serialize message field [used_detection_information]
    bufferOffset = SensorTypes.serialize(obj.used_detection_information, buffer, bufferOffset);
    // Serialize message field [used_stored_information]
    bufferOffset = StoredInformationType.serialize(obj.used_stored_information, buffer, bufferOffset);
    // Serialize message field [confidence_value]
    bufferOffset = ConfidenceLevel.serialize(obj.confidence_value, buffer, bufferOffset);
    // Serialize message field [confidence_value_is_present]
    bufferOffset = _serializer.bool(obj.confidence_value_is_present, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MetaInformation
    let len;
    let data = new MetaInformation(null);
    // Deserialize message field [used_detection_information]
    data.used_detection_information = SensorTypes.deserialize(buffer, bufferOffset);
    // Deserialize message field [used_stored_information]
    data.used_stored_information = StoredInformationType.deserialize(buffer, bufferOffset);
    // Deserialize message field [confidence_value]
    data.confidence_value = ConfidenceLevel.deserialize(buffer, bufferOffset);
    // Deserialize message field [confidence_value_is_present]
    data.confidence_value_is_present = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += SensorTypes.getMessageSize(object.used_detection_information);
    length += StoredInformationType.getMessageSize(object.used_stored_information);
    return length + 2;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/MetaInformation';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '76660bcc3b59dc12ea5d954fca2bb80f';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # MetaInformation::=SEQUENCE{		
    #   usedDetectionInformation   SensorTypes, 
    #   usedStoredInformation      StoredInformationType,
    #   confidenceValue            ConfidenceLevel OPTIONAL,
    #   ...
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF provides information about the source of and confidence in information.
    # *
    # * It shall include the following components: 
    # * 
    # * @field usedDetectionInformation: the type of sensor(s) that is used to provide the detection information.
    # * 
    # * @field usedStoredInformation: the type of source of the stored information. 
    # *
    # * @field confidenceValue: an optional confidence value associated to the information. 
    # * 
    # * @category: Basic information
    # * @revision: Created in V2.2.1
    #
    
    SensorTypes used_detection_information
    
    StoredInformationType used_stored_information
    
    ConfidenceLevel confidence_value
    bool confidence_value_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/SensorTypes
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SensorTypes ::= BIT STRING {
    #     undefined         (0),
    #     radar             (1),
    #     lidar             (2),
    #     monovideo         (3),
    #     stereovision      (4),
    #     nightvision       (5),
    #     ultrasonic        (6),
    #     pmd               (7),
    #     inductionLoop     (8),
    #     sphericalCamera   (9),
    #     uwb               (10),
    #     acoustic          (11),
    #     localAggregation  (12),
    #     itsAggregation    (13)
    # } (SIZE (16,... ))
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the type of sensor(s).
    # * The corresponding bit shall be set to 1 under the following conditions:
    # * 
    # * - 0  `undefined`         - in case the sensor type is undefined. 
    # * - 1  `radar`             - in case the sensor is a radar,
    # * - 2  `lidar`             - in case the sensor is a lidar,
    # * - 3  `monovideo`         - in case the sensor is mono video,
    # * - 4  `stereovision`      - in case the sensor is stereo vision,
    # * - 5  `nightvision`       - in case the sensor is night vision,
    # * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
    # * - 7  `pmd`               - in case the sensor is photonic mixing device,
    # * - 8  `inductionLoop`     - in case the sensor is an induction loop,
    # * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
    # * - 10 `uwb`               - in case the sensor is ultra wide band,
    # * - 11 `acoustic`          - in case the sensor is acoustic,
    # * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
    # * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
    # * - 14-15                  - are reserved for future usage.
    # * 
    # * @note: If all bits are set to 0, then no sensor type is used
    # *
    # * @category: Sensing Information
    # * @revision: created in V2.2.1
    #
    
    uint8[] value
    uint8 bits_unused
    int64 MIN_SIZE_BITS = 16
    int64 MAX_SIZE_BITS = 16
    uint8 BIT_INDEX_UNDEFINED = 0
    uint8 BIT_INDEX_RADAR = 1
    uint8 BIT_INDEX_LIDAR = 2
    uint8 BIT_INDEX_MONOVIDEO = 3
    uint8 BIT_INDEX_STEREOVISION = 4
    uint8 BIT_INDEX_NIGHTVISION = 5
    uint8 BIT_INDEX_ULTRASONIC = 6
    uint8 BIT_INDEX_PMD = 7
    uint8 BIT_INDEX_INDUCTION_LOOP = 8
    uint8 BIT_INDEX_SPHERICAL_CAMERA = 9
    uint8 BIT_INDEX_UWB = 10
    uint8 BIT_INDEX_ACOUSTIC = 11
    uint8 BIT_INDEX_LOCAL_AGGREGATION = 12
    uint8 BIT_INDEX_ITS_AGGREGATION = 13
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/StoredInformationType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # StoredInformationType::= BIT STRING {
    #     undefined       (0),
    #     staticDb	    (1),    
    #     dynamicDb   	(2),
    #     realTimeDb  	(3),
    #     map		    	(4)	
    # } (SIZE (8,... )) 
    # ------------------------------------------------------------------------------
    # * 
    # * This DE indicates the type of stored information.
    # *
    # * The corresponding bit shall be set to 1 under the following conditions:
    # * 
    # * - `0` undefined        - in case the stored information type is undefined. 
    # * - `1` staticDb         - in case the stored information type is a static database.
    # * - `2` dynamicDb        - in case the stored information type is a dynamic database
    # * - `3` realTimeDb       - in case the stored information type is a real time updated database.
    # * - `4` map              - in case the stored information type is a road topology map.
    # * - Bits 5 to 7          - are reserved for future use.
    # *
    # * @note: If all bits are set to 0, then no stored information type is used
    # *
    # * @category: Basic Information
    # * @revision: created in V2.2.1
    #
    
    uint8[] value
    uint8 bits_unused
    int64 MIN_SIZE_BITS = 8
    int64 MAX_SIZE_BITS = 8
    uint8 BIT_INDEX_UNDEFINED = 0
    uint8 BIT_INDEX_STATIC_DB = 1
    uint8 BIT_INDEX_DYNAMIC_DB = 2
    uint8 BIT_INDEX_REAL_TIME_DB = 3
    uint8 BIT_INDEX_MAP = 4
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/ConfidenceLevel
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ConfidenceLevel ::= INTEGER {
    #     unavailable (101)  
    # } (1..101)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents a confidence level in percentage.
    # * 
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
    # * - `101`                   : in case the confidence level is not available.
    # *
    # * @unit Percent 
    # * @category: Basic information 
    # * @revision: Created in V2.1.1 
    #
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 101
    uint8 UNAVAILABLE = 101
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MetaInformation(null);
    if (msg.used_detection_information !== undefined) {
      resolved.used_detection_information = SensorTypes.Resolve(msg.used_detection_information)
    }
    else {
      resolved.used_detection_information = new SensorTypes()
    }

    if (msg.used_stored_information !== undefined) {
      resolved.used_stored_information = StoredInformationType.Resolve(msg.used_stored_information)
    }
    else {
      resolved.used_stored_information = new StoredInformationType()
    }

    if (msg.confidence_value !== undefined) {
      resolved.confidence_value = ConfidenceLevel.Resolve(msg.confidence_value)
    }
    else {
      resolved.confidence_value = new ConfidenceLevel()
    }

    if (msg.confidence_value_is_present !== undefined) {
      resolved.confidence_value_is_present = msg.confidence_value_is_present;
    }
    else {
      resolved.confidence_value_is_present = false
    }

    return resolved;
    }
};

module.exports = MetaInformation;
