// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let PathPredicted = require('./PathPredicted.js');
let UsageIndication = require('./UsageIndication.js');
let ConfidenceLevel = require('./ConfidenceLevel.js');

//-----------------------------------------------------------

class PathPredicted2 {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.path_predicted = null;
      this.usage_indication = null;
      this.confidence_level = null;
    }
    else {
      if (initObj.hasOwnProperty('path_predicted')) {
        this.path_predicted = initObj.path_predicted
      }
      else {
        this.path_predicted = new PathPredicted();
      }
      if (initObj.hasOwnProperty('usage_indication')) {
        this.usage_indication = initObj.usage_indication
      }
      else {
        this.usage_indication = new UsageIndication();
      }
      if (initObj.hasOwnProperty('confidence_level')) {
        this.confidence_level = initObj.confidence_level
      }
      else {
        this.confidence_level = new ConfidenceLevel();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PathPredicted2
    // Serialize message field [path_predicted]
    bufferOffset = PathPredicted.serialize(obj.path_predicted, buffer, bufferOffset);
    // Serialize message field [usage_indication]
    bufferOffset = UsageIndication.serialize(obj.usage_indication, buffer, bufferOffset);
    // Serialize message field [confidence_level]
    bufferOffset = ConfidenceLevel.serialize(obj.confidence_level, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PathPredicted2
    let len;
    let data = new PathPredicted2(null);
    // Deserialize message field [path_predicted]
    data.path_predicted = PathPredicted.deserialize(buffer, bufferOffset);
    // Deserialize message field [usage_indication]
    data.usage_indication = UsageIndication.deserialize(buffer, bufferOffset);
    // Deserialize message field [confidence_level]
    data.confidence_level = ConfidenceLevel.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += PathPredicted.getMessageSize(object.path_predicted);
    return length + 2;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/PathPredicted2';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f02a6c0ea73bdc23240d1bfdcbe77b96';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PathPredicted2::= SEQUENCE{
    #     pathPredicted     PathPredicted
    #    ((WITH COMPONENT (WITH COMPONENTS {..., pathDeltaTime ABSENT, symmetricAreaOffset ABSENT})) |
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents a predicted path, predicted trajectory or predicted path zone together with usage information and a prediction confidence.
    # *
    # * It shall include the following components: 
    # *
    # * @field pathPredicted: the predicted path (pathDeltaTime ABSENT) or trajectory (pathDeltaTime PRESENT) and/or the path zone (symmetricAreaOffset PRESENT).
    # *
    # * @field usageIndication: an indication of how the predicted path will be used. 
    # *
    # * @field confidenceLevel: the confidence that the path/trajectory in pathPredicted will occur as predicted.
    # *
    # * @category: GeoReference information
    # * @revision: created in V2.2.1
    # 
    
    PathPredicted path_predicted
    int64 PATH_PREDICTED_MIN = 0
    
    UsageIndication usage_indication
    
    ConfidenceLevel confidence_level
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/PathPredicted
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PathPredicted::= SEQUENCE (SIZE(1..16,...)) OF PathPointPredicted
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents a predicted path or trajectory with a set of predicted points and optional information to generate a shape which is estimated to contain the real path. 
    # * It shall contain up to `16` @ref PathPointPredicted. 
    # * 
    # * The first PathPoint presents an offset delta position with regards to an external reference position.
    # * Each other PathPoint presents an offset delta position and optionally an offset travel time with regards to the previous PathPoint. 
    # *
    # * @category: GeoReference information
    # * @revision: created in V2.1.1 , size constraint changed to SIZE(1..16, ...) in V2.2.1
    # 
    
    PathPointPredicted[] array
    int64 MIN_SIZE = 1
    int64 MAX_SIZE = 16
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/PathPointPredicted
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PathPointPredicted::= SEQUENCE {
    #   deltaLatitude                 DeltaLatitude,      
    #   deltaLongitude                DeltaLongitude, 
    #   horizontalPositionConfidence  PosConfidenceEllipse OPTIONAL,   
    #   deltaAltitude                 DeltaAltitude DEFAULT unavailable, 
    #   altitudeConfidence            AltitudeConfidence DEFAULT unavailable,
    #   pathDeltaTime                 PathDeltaTimeChoice OPTIONAL,
    #   symmetricAreaOffset           StandardLength9b OPTIONAL, 
    #   asymmetricAreaOffset          StandardLength9b OPTIONAL, 
    #   ... 
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF defines a predicted offset position that can be used within a predicted path or trajectory, together with optional data to describe a path zone shape.
    # *
    # * It shall include the following components: 
    # *
    # * @field deltaLatitude: the offset latitude with regards to a pre-defined reference position. 
    # *
    # * @field deltaLongitude: the offset longitude with regards to a pre-defined reference position. 
    # * 
    # * @field horizontalPositionConfidence: the optional confidence value associated to the horizontal geographical position.
    # *
    # * @field deltaAltitude: the optional offset altitude with regards to a pre-defined reference position, with default value unavailable. 
    # *
    # * @field altitudeConfidence: the optional confidence value associated to the altitude value of the geographical position, with default value unavailable.
    # * 
    # * @field pathDeltaTime: the optional travel time to the waypoint from the predefined reference position.
    #
    # * @field symmetricAreaOffset: the optional symmetric offset to generate a shape, see Annex D for details.
    # *  
    # * @field asymmetricAreaOffset: the optional asymmetric offset to generate a shape, see Annex D for details. 
    # *
    # * @category GeoReference information
    # * @revision: Created in V2.1.1, type of pathDeltaTime changed and optionality added, fields symmetricAreaOffset and asymmetricAreaOffset added in V2.2.1
    # 
    
    DeltaLatitude delta_latitude
    
    DeltaLongitude delta_longitude
    
    PosConfidenceEllipse horizontal_position_confidence
    bool horizontal_position_confidence_is_present
    
    DeltaAltitude delta_altitude
    
    AltitudeConfidence altitude_confidence
    
    PathDeltaTimeChoice path_delta_time
    bool path_delta_time_is_present
    
    StandardLength9b symmetric_area_offset
    bool symmetric_area_offset_is_present
    
    StandardLength9b asymmetric_area_offset
    bool asymmetric_area_offset_is_present
    
    
    int16 DELTA_ALTITUDE_DEFAULT = 12800
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/DeltaLatitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaLatitude ::= INTEGER {
    #     unavailable (131072)
    # } (-131071..131072)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents an offset latitude with regards to a defined latitude value.
    # * It may be used to describe a geographical point with regards to a specific reference geographical position.
    # *
    # * The value shall be set to:
    # * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the south from the reference position,
    # * - `0` for no latitudinal offset,
    # * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the north from the reference position,
    # * - `131 072` when the information is unavailable.
    # *
    # * @unit: 10^-7 degree
    # * @category: GeoReference information
    # * @revision: editorial update in V2.1.1
    # 
    
    int32 value
    int32 MIN = -131071
    int32 MAX = 131072
    int32 UNAVAILABLE = 131072
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/DeltaLongitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaLongitude ::= INTEGER {
    #     unavailable (131072)
    # } (-131071..131072)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents an offset longitude with regards to a defined longitude value.
    # * It may be used to describe a geographical point with regards to a specific reference geographical position.
    # *
    # * The value shall be set to:
    # * - `n` (`n >= -131 071` and `n < 0`) for offset n x 10^-7 degree towards the west from the reference position,
    # * - `0` for no longitudinal offset,
    # * - `n` (`n > 0` and `n < 131 072`) for offset n x 10^-7 degree towards the east from the reference position, 
    # * - `131 072` when the information is unavailable.
    # *
    # * @unit: 10^-7 degree
    # * @category: GeoReference information
    # * @revision: editorial update in V2.1.1
    # 
    
    int32 value
    int32 MIN = -131071
    int32 MAX = 131072
    int32 UNAVAILABLE = 131072
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/PosConfidenceEllipse
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PosConfidenceEllipse ::= SEQUENCE {
    #     semiMajorConfidence     SemiAxisLength,
    #     semiMinorConfidence     SemiAxisLength,
    #     semiMajorOrientation    HeadingValue
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF indicates the horizontal position confidence ellipse which represents the estimated accuracy with a 
    # * confidence level of 95  %. The centre of the ellipse shape corresponds to the reference
    # * position point for which the position accuracy is evaluated.
    # *
    # * It shall include the following components: 
    # *
    # * @field semiMajorConfidence: half of length of the major axis, i.e. distance between the centre point
    # * and major axis point of the position accuracy ellipse. 
    # *
    # * @field semiMinorConfidence: half of length of the minor axis, i.e. distance between the centre point
    # * and minor axis point of the position accuracy ellipse. 
    # *
    # * @field semiMajorOrientation: orientation direction of the ellipse major axis of the position accuracy
    # * ellipse with regards to the WGS84 north. 
    # * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
    # *
    # *
    # * @category GeoReference information
    # * @revision: V1.3.1
    # 
    
    SemiAxisLength semi_major_confidence
    
    SemiAxisLength semi_minor_confidence
    
    HeadingValue semi_major_orientation
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/SemiAxisLength
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SemiAxisLength ::= INTEGER{
    #     doNotUse    (0),
    #     outOfRange  (4094), 
    #     unavailable (4095)
    # } (0..4095)
    # ------------------------------------------------------------------------------
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 4095
    uint16 DO_NOT_USE = 0
    uint16 OUT_OF_RANGE = 4094
    uint16 UNAVAILABLE = 4095
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/HeadingValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # HeadingValue ::= INTEGER { 
    #     wgs84North  (0),
    #     wgs84East   (900),
    #     wgs84South  (1800),
    #     wgs84West   (2700),
    #     doNotUse    (3600),
    #     unavailable (3601)
    # } (0..3601)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents the orientation of the horizontal velocity vector with regards to the WGS84 north.
    # * When the information is not available, the DE shall be set to 3 601. The value 3600 shall not be used.
    # *
    # * @note: this DE is kept for backwards compatibility reasons only. It is recommended to use the @ref Wgs84AngleValue instead. 
    # *
    # * Unit: 0,1 degree
    # * Categories: GeoReference information
    # * @revision: Description revised in V2.1.1 (usage of value 3600 specified) 
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 3601
    uint16 WGS84_NORTH = 0
    uint16 WGS84_EAST = 900
    uint16 WGS84_SOUTH = 1800
    uint16 WGS84_WEST = 2700
    uint16 DO_NOT_USE = 3600
    uint16 UNAVAILABLE = 3601
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/DeltaAltitude
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaAltitude ::= INTEGER {
    #     negativeOutOfRange (-12700),
    #     positiveOutOfRange (12799),
    #     unavailable        (12800)
    # } (-12700..12800)
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents an offset altitude with regards to a defined altitude value.
    # * It may be used to describe a geographical point with regards to a specific reference geographical position.
    # *
    # * The value shall be set to:
    # * - `-12 700` for values equal to or lower than -127 metres,
    # * - `n` (`n > -12 700` and `n <= 0`) for altitude offset n x 0,01 metre below the reference position,
    # * - `0` for no altitudinal offset,
    # * - `n` (`n > 0` and `n < 12799`) for altitude offset n x 0,01 metre above the reference position,
    # * - `12 799` for values equal to or greater than 127,99 metres,
    # * - `12 800` when the information is unavailable.
    # *
    # * @unit: 0,01 metre
    # * @category: GeoReference information
    # * @revision: editorial update in V2.1.1
    # 
    
    int16 value
    int16 MIN = -12700
    int16 MAX = 12800
    int16 NEGATIVE_OUT_OF_RANGE = -12700
    int16 POSITIVE_OUT_OF_RANGE = 12799
    int16 UNAVAILABLE = 12800
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/AltitudeConfidence
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # AltitudeConfidence ::= ENUMERATED {
    #     alt-000-01  (0),
    #     alt-000-02  (1),
    #     alt-000-05  (2),
    #     alt-000-10  (3),
    #     alt-000-20  (4),
    #     alt-000-50  (5),
    #     alt-001-00  (6),
    #     alt-002-00  (7),
    #     alt-005-00  (8),
    #     alt-010-00  (9),
    #     alt-020-00  (10),
    #     alt-050-00  (11),
    #     alt-100-00  (12),
    #     alt-200-00  (13),
    #     outOfRange  (14),
    #     unavailable (15)
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates the altitude confidence value which represents the estimated absolute accuracy of an altitude value of a geographical point with a default confidence level of 95 %.
    # * If required, the confidence level can be defined by the corresponding standards applying this DE.
    # *
    # * The value shall be set to: 
    # *   - 0  - `alt-000-01`   - if the confidence value is equal to or less than 0,01 metre,
    # *   - 1  - `alt-000-02`   - if the confidence value is equal to or less than 0,02 metre and greater than 0,01 metre,
    # *   - 2  - `alt-000-05`   - if the confidence value is equal to or less than 0,05 metre and greater than 0,02 metre,            
    # *   - 3  - `alt-000-10`   - if the confidence value is equal to or less than 0,1 metre and greater than 0,05 metre,            
    # *   - 4  - `alt-000-20`   - if the confidence value is equal to or less than 0,2 metre and greater than 0,1 metre,            
    # *   - 5  - `alt-000-50`   - if the confidence value is equal to or less than 0,5 metre and greater than 0,2 metre,             
    # *   - 6  - `alt-001-00`   - if the confidence value is equal to or less than 1 metre and greater than 0,5 metre,             
    # *   - 7  - `alt-002-00`   - if the confidence value is equal to or less than 2 metres and greater than 1 metre,             
    # *   - 8  - `alt-005-00`   - if the confidence value is equal to or less than 5 metres and greater than 2 metres,              
    # *   - 9  - `alt-010-00`   - if the confidence value is equal to or less than 10 metres and greater than 5 metres,             
    # *   - 10 - `alt-020-00`   - if the confidence value is equal to or less than 20 metres and greater than 10 metres,            
    # *   - 11 - `alt-050-00`   - if the confidence value is equal to or less than 50 metres and greater than 20 metres,            
    # *   - 12 - `alt-100-00`   - if the confidence value is equal to or less than 100 metres and greater than 50 metres,           
    # *   - 13 - `alt-200-00`   - if the confidence value is equal to or less than 200 metres and greater than 100 metres,           
    # *   - 14 - `outOfRange`   - if the confidence value is out of range, i.e. greater than 200 metres,
    # *   - 15 - `unavailable`  - if the confidence value is unavailable.       
    # *
    # * @note: The fact that an altitude value is received with confidence value set to `unavailable(15)` can be caused
    # * by several reasons, such as:
    # * - the sensor cannot deliver the accuracy at the defined confidence level because it is a low-end sensor,
    # * - the sensor cannot calculate the accuracy due to lack of variables, or
    # * - there has been a vehicle bus (e.g. CAN bus) error.
    # * In all 3 cases above, the altitude value may be valid and used by the application.
    # * 
    # * @note: If an altitude value is received and its confidence value is set to `outOfRange(14)`, it means that the  
    # * altitude value is not valid and therefore cannot be trusted. Such value is not useful for the application.             
    # *
    # * @category: GeoReference information
    # * @revision: Description revised in V2.1.1
    # 
    
    uint8 value
    uint8 ALT_000_01 = 0
    uint8 ALT_000_02 = 1
    uint8 ALT_000_05 = 2
    uint8 ALT_000_10 = 3
    uint8 ALT_000_20 = 4
    uint8 ALT_000_50 = 5
    uint8 ALT_001_00 = 6
    uint8 ALT_002_00 = 7
    uint8 ALT_005_00 = 8
    uint8 ALT_010_00 = 9
    uint8 ALT_020_00 = 10
    uint8 ALT_050_00 = 11
    uint8 ALT_100_00 = 12
    uint8 ALT_200_00 = 13
    uint8 OUT_OF_RANGE = 14
    uint8 UNAVAILABLE = 15
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/PathDeltaTimeChoice
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PathDeltaTimeChoice::= CHOICE {
    #     deltaTimeHighPrecision	DeltaTimeTenthOfSecond,
    #     deltaTimeBigRange	    DeltaTimeTenSeconds,
    #     ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents estimated/predicted travel time between a position and a predefined reference position. 
    # *
    # * the following options are available:
    # * 
    # * @field deltaTimeHighPrecision: delta time with precision of 0,1 s.
    # *
    # * @field deltaTimeBigRange: delta time with precision of 10 s.
    # *
    # * @category: Basic information
    # * @revision: Created in V2.2.1
    # 
    
    uint8 choice
    
    DeltaTimeTenthOfSecond delta_time_high_precision
    uint8 CHOICE_DELTA_TIME_HIGH_PRECISION = 0
    
    DeltaTimeTenSeconds delta_time_big_range
    uint8 CHOICE_DELTA_TIME_BIG_RANGE = 1
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/DeltaTimeTenthOfSecond
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaTimeTenthOfSecond::= INTEGER {
    #     unavailable (127)  
    # } (0..127) 
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents a difference in time with respect to a reference time.
    # *
    # * The value shall be set to:
    # * - `0` for a difference in time of 0 seconds. 
    # * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 0,1 s, and greater than (n-1) x 0,1 s,
    # *
    # * @unit: 0,1 s
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 127
    uint8 UNAVAILABLE = 127
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/DeltaTimeTenSeconds
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # DeltaTimeTenSeconds ::= INTEGER  (0..127)  
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents a difference in time with respect to a reference time.
    # *
    # * The value shall be set to:
    # * - `-0` for a difference in time of 0 seconds. 
    # * - `n` (`n > 0` and `n < 128`) to indicate a time value equal to or less than n x 10 s, and greater than (n-1) x 10 s,
    # *
    # * @unit: 10 s
    # * @category: Basic information
    # * @revision: Created in V2.2.1
    #
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 127
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/StandardLength9b
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # StandardLength9b::= INTEGER (0..511)
    # ------------------------------------------------------------------------------
    # *
    # * The DE represents length as a measure of distance between points or as a dimension of an object. 
    # *
    # * @unit: 0,1 metre
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    # 
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 511
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/UsageIndication
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # UsageIndication ::= ENUMERATED { 
    #     noIndication(0),
    #     specialUse (1),
    #     rescueOperation (2),
    #     ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DE represents indication of how a certain path or area will be used. 
    # * 
    # * The value shall be set to:
    # * - 0  - ` noIndication `     - in case it will remain free to be used,
    # * - 1  - ` specialUse `       - in case it will be physically blocked by special use,
    # * - 2  - ` rescueOperation`   - in case it is intended to be used for rescue operations,
    # *
    # * @category: Basic information
    # * @revision: Created in V2.2.1
    # 
    
    uint8 value
    uint8 NO_INDICATION = 0
    uint8 SPECIAL_USE = 1
    uint8 RESCUE_OPERATION = 2
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/ConfidenceLevel
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # ConfidenceLevel ::= INTEGER {
    #     unavailable (101)  
    # } (1..101)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents a confidence level in percentage.
    # * 
    # * The value shall be set to:
    # * - `n` (`n > 0` and `n < 101`) : for the confidence level in %,
    # * - `101`                   : in case the confidence level is not available.
    # *
    # * @unit Percent 
    # * @category: Basic information 
    # * @revision: Created in V2.1.1 
    #
    
    uint8 value
    uint8 MIN = 1
    uint8 MAX = 101
    uint8 UNAVAILABLE = 101
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PathPredicted2(null);
    if (msg.path_predicted !== undefined) {
      resolved.path_predicted = PathPredicted.Resolve(msg.path_predicted)
    }
    else {
      resolved.path_predicted = new PathPredicted()
    }

    if (msg.usage_indication !== undefined) {
      resolved.usage_indication = UsageIndication.Resolve(msg.usage_indication)
    }
    else {
      resolved.usage_indication = new UsageIndication()
    }

    if (msg.confidence_level !== undefined) {
      resolved.confidence_level = ConfidenceLevel.Resolve(msg.confidence_level)
    }
    else {
      resolved.confidence_level = new ConfidenceLevel()
    }

    return resolved;
    }
};

// Constants for message
PathPredicted2.Constants = {
  PATH_PREDICTED_MIN: 0,
}

module.exports = PathPredicted2;
