// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let EmbarkationStatus = require('./EmbarkationStatus.js');
let PtActivation = require('./PtActivation.js');

//-----------------------------------------------------------

class PublicTransportContainer {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.embarkation_status = null;
      this.pt_activation = null;
      this.pt_activation_is_present = null;
    }
    else {
      if (initObj.hasOwnProperty('embarkation_status')) {
        this.embarkation_status = initObj.embarkation_status
      }
      else {
        this.embarkation_status = new EmbarkationStatus();
      }
      if (initObj.hasOwnProperty('pt_activation')) {
        this.pt_activation = initObj.pt_activation
      }
      else {
        this.pt_activation = new PtActivation();
      }
      if (initObj.hasOwnProperty('pt_activation_is_present')) {
        this.pt_activation_is_present = initObj.pt_activation_is_present
      }
      else {
        this.pt_activation_is_present = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PublicTransportContainer
    // Serialize message field [embarkation_status]
    bufferOffset = EmbarkationStatus.serialize(obj.embarkation_status, buffer, bufferOffset);
    // Serialize message field [pt_activation]
    bufferOffset = PtActivation.serialize(obj.pt_activation, buffer, bufferOffset);
    // Serialize message field [pt_activation_is_present]
    bufferOffset = _serializer.bool(obj.pt_activation_is_present, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PublicTransportContainer
    let len;
    let data = new PublicTransportContainer(null);
    // Deserialize message field [embarkation_status]
    data.embarkation_status = EmbarkationStatus.deserialize(buffer, bufferOffset);
    // Deserialize message field [pt_activation]
    data.pt_activation = PtActivation.deserialize(buffer, bufferOffset);
    // Deserialize message field [pt_activation_is_present]
    data.pt_activation_is_present = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += PtActivation.getMessageSize(object.pt_activation);
    return length + 2;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/PublicTransportContainer';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '6e0db2bcdf856f30d6400e662ae61b19';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PublicTransportContainer ::= SEQUENCE {
    # 	embarkationStatus EmbarkationStatus,
    # 	ptActivation PtActivation OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # *
    #* This type contains detaild information of the Public Transport Container.
    #*
    #* It shall include the following components:
    #*
    #* @field embarkationStatus: It indicates whether the passenger embarkation is currently ongoing. 
    #*
    #* @field ptActivation: an optional component used for controlling traffic lights, barriers, bollards, etc.
    #
    
    EmbarkationStatus embarkation_status
    
    PtActivation pt_activation
    bool pt_activation_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/EmbarkationStatus
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # EmbarkationStatus ::= BOOLEAN
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates whether a vehicle (e.g. public transport vehicle, truck) is under the embarkation process.
    # * If that is the case, the value is *TRUE*, otherwise *FALSE*.
    # *
    # * @category: Vehicle information
    # * @revision: editorial update in V2.1.1
    # 
    
    bool value
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/PtActivation
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PtActivation ::= SEQUENCE {
    #     ptActivationType    PtActivationType,
    #     ptActivationData    PtActivationData
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents activation data for real-time systems designed for operations control, traffic light priorities, track switches, barriers, etc.
    # * using a range of activation devices equipped in public transport vehicles.
    # *
    # * The activation of the corresponding equipment is triggered by the approach or passage of a public transport
    # * vehicle at a certain point (e.g. a beacon).
    # *
    # * @field ptActivationType: type of activation. 
    # *
    # * @field ptActicationData: data of activation. 
    # *
    # * Today there are different payload variants defined for public transport activation-data. The R09.x is one of
    # * the industry standard used by public transport vehicles (e.g. buses, trams) in Europe (e.g. Germany Austria)
    # * for controlling traffic lights, barriers, bollards, etc. This DF shall include information like route, course,
    # * destination, priority, etc.
    # * 
    # * The R09.x content is defined in VDV recommendation 420 [7]. It includes following information:
    # * - Priority Request Information (pre-request, request, ready to start)
    # * - End of Prioritization procedure
    # * - Priority request direction
    # * - Public Transport line number
    # * - Priority of public transport
    # * - Route line identifier of the public transport
    # * - Route number identification
    # * - Destination of public transport vehicle
    # *
    # * Other countries may use different message sets defined by the local administration.
    # * @category: Vehicle information
    # * @revision: V1.3.1
    # 
    
    PtActivationType pt_activation_type
    
    PtActivationData pt_activation_data
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/PtActivationType
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PtActivationType ::= INTEGER {
    #     undefinedCodingType (0), 
    #     r09-16CodingType    (1), 
    #     vdv-50149CodingType (2)
    # } (0..255)
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates a certain coding type of the PtActivationData data.
    # *
    # * The folowing value are specified:
    # * - 0 `undefinedCodingType`  : undefined coding type,
    # * - 1 `r09-16CodingType`     : coding of PtActivationData conform to VDV recommendation 420 [7],
    # * - 2 `vdv-50149CodingType`  : coding of PtActivationData based on VDV recommendation 420 [7].
    # * - 3 - 255                  : reserved for alternative and future use.
    # * 
    # * @category: Vehicle information 
    # * @revision: V1.3.1
    # 
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 255
    uint8 UNDEFINED_CODING_TYPE = 0
    uint8 R09_16_CODING_TYPE = 1
    uint8 VDV_50149_CODING_TYPE = 2
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/PtActivationData
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PtActivationData ::= OCTET STRING (SIZE(1..20))
    # ------------------------------------------------------------------------------
    # *
    # * This DE is used for various tasks in the public transportation environment, especially for controlling traffic
    # * signal systems to prioritize and speed up public transportation in urban area (e.g. intersection "_bottlenecks_").
    # * The traffic lights may be controlled by an approaching bus or tram automatically. This permits "_In Time_" activation
    # * of the green phase, will enable the individual traffic to clear a potential traffic jam in advance. Thereby the
    # * approaching bus or tram may pass an intersection with activated green light without slowing down the speed due to
    # * traffic congestion. Other usage of the DE is the provision of information like the public transport line number
    # * or the schedule delay of a public transport vehicle.
    # * 
    # * @category: Vehicle information
    # * @revision: V1.3.1
    # 
    
    uint8[] value
    uint8 MIN_SIZE = 1
    uint8 MAX_SIZE = 20
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PublicTransportContainer(null);
    if (msg.embarkation_status !== undefined) {
      resolved.embarkation_status = EmbarkationStatus.Resolve(msg.embarkation_status)
    }
    else {
      resolved.embarkation_status = new EmbarkationStatus()
    }

    if (msg.pt_activation !== undefined) {
      resolved.pt_activation = PtActivation.Resolve(msg.pt_activation)
    }
    else {
      resolved.pt_activation = new PtActivation()
    }

    if (msg.pt_activation_is_present !== undefined) {
      resolved.pt_activation_is_present = msg.pt_activation_is_present;
    }
    else {
      resolved.pt_activation_is_present = false
    }

    return resolved;
    }
};

module.exports = PublicTransportContainer;
