// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let RectangularShape = require('./RectangularShape.js');
let CircularShape = require('./CircularShape.js');
let PolygonalShape = require('./PolygonalShape.js');
let EllipticalShape = require('./EllipticalShape.js');
let RadialShape = require('./RadialShape.js');
let RadialShapes = require('./RadialShapes.js');

//-----------------------------------------------------------

class Shape {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.choice = null;
      this.rectangular = null;
      this.circular = null;
      this.polygonal = null;
      this.elliptical = null;
      this.radial = null;
      this.radial_shapes = null;
    }
    else {
      if (initObj.hasOwnProperty('choice')) {
        this.choice = initObj.choice
      }
      else {
        this.choice = 0;
      }
      if (initObj.hasOwnProperty('rectangular')) {
        this.rectangular = initObj.rectangular
      }
      else {
        this.rectangular = new RectangularShape();
      }
      if (initObj.hasOwnProperty('circular')) {
        this.circular = initObj.circular
      }
      else {
        this.circular = new CircularShape();
      }
      if (initObj.hasOwnProperty('polygonal')) {
        this.polygonal = initObj.polygonal
      }
      else {
        this.polygonal = new PolygonalShape();
      }
      if (initObj.hasOwnProperty('elliptical')) {
        this.elliptical = initObj.elliptical
      }
      else {
        this.elliptical = new EllipticalShape();
      }
      if (initObj.hasOwnProperty('radial')) {
        this.radial = initObj.radial
      }
      else {
        this.radial = new RadialShape();
      }
      if (initObj.hasOwnProperty('radial_shapes')) {
        this.radial_shapes = initObj.radial_shapes
      }
      else {
        this.radial_shapes = new RadialShapes();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Shape
    // Serialize message field [choice]
    bufferOffset = _serializer.uint8(obj.choice, buffer, bufferOffset);
    // Serialize message field [rectangular]
    bufferOffset = RectangularShape.serialize(obj.rectangular, buffer, bufferOffset);
    // Serialize message field [circular]
    bufferOffset = CircularShape.serialize(obj.circular, buffer, bufferOffset);
    // Serialize message field [polygonal]
    bufferOffset = PolygonalShape.serialize(obj.polygonal, buffer, bufferOffset);
    // Serialize message field [elliptical]
    bufferOffset = EllipticalShape.serialize(obj.elliptical, buffer, bufferOffset);
    // Serialize message field [radial]
    bufferOffset = RadialShape.serialize(obj.radial, buffer, bufferOffset);
    // Serialize message field [radial_shapes]
    bufferOffset = RadialShapes.serialize(obj.radial_shapes, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Shape
    let len;
    let data = new Shape(null);
    // Deserialize message field [choice]
    data.choice = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [rectangular]
    data.rectangular = RectangularShape.deserialize(buffer, bufferOffset);
    // Deserialize message field [circular]
    data.circular = CircularShape.deserialize(buffer, bufferOffset);
    // Deserialize message field [polygonal]
    data.polygonal = PolygonalShape.deserialize(buffer, bufferOffset);
    // Deserialize message field [elliptical]
    data.elliptical = EllipticalShape.deserialize(buffer, bufferOffset);
    // Deserialize message field [radial]
    data.radial = RadialShape.deserialize(buffer, bufferOffset);
    // Deserialize message field [radial_shapes]
    data.radial_shapes = RadialShapes.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += PolygonalShape.getMessageSize(object.polygonal);
    length += RadialShapes.getMessageSize(object.radial_shapes);
    return length + 70;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/Shape';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'be25e61584196dd87f223aa7f3704ecc';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Shape::= CHOICE {
    #    rectangular       RectangularShape,
    #    circular          CircularShape, 
    #    polygonal         PolygonalShape,
    #    elliptical        EllipticalShape,
    #    radial            RadialShape,
    #    radialShapes      RadialShapes,
    #    ...
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF provides the definition of a geographical area or volume, based on different options.
    # *
    # * It is a choice of the following components: 
    # *
    # * @field rectangular: definition of an rectangular area or a right rectangular prism (with a rectangular base) also called a cuboid, or informally a rectangular box.
    # *
    # * @field circular: definition of an area of circular shape or a right circular cylinder.
    # *
    # * @field polygonal: definition of an area of polygonal shape or a right prism.
    # *
    # * @field elliptical: definition of an area of elliptical shape or a right elliptical cylinder.
    # *
    # * @field radial: definition of a radial shape.
    # *
    # * @field radialList: definition of list of radial shapes.
    # *
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1
    # 
    
    uint8 choice
    
    RectangularShape rectangular
    uint8 CHOICE_RECTANGULAR = 0
    
    CircularShape circular
    uint8 CHOICE_CIRCULAR = 1
    
    PolygonalShape polygonal
    uint8 CHOICE_POLYGONAL = 2
    
    EllipticalShape elliptical
    uint8 CHOICE_ELLIPTICAL = 3
    
    RadialShape radial
    uint8 CHOICE_RADIAL = 4
    
    RadialShapes radial_shapes
    uint8 CHOICE_RADIAL_SHAPES = 5
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/RectangularShape
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RectangularShape ::= SEQUENCE { 
    #     shapeReferencePoint   CartesianPosition3d OPTIONAL,
    #     semiLength            StandardLength12b,
    #     semiBreadth           StandardLength12b,
    #     orientation           CartesianAngleValue OPTIONAL,
    #     height                StandardLength12b OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents the shape of a rectangular area or a right rectangular prism that is centred 
    # * on a reference position defined outside of the context of this DF and oriented w.r.t. a cartesian    
    # * coordinate system defined outside of the context of this DF. 
    # *
    # * It shall include the following components: 
    # * 
    # * @field shapeReferencePoint: represents an optional offset point which the rectangle is centred on with 
    # * respect to the reference position. If this component is absent, the externally specified  
    # * reference position represents the shape's reference point. 
    # *
    # * @field semiLength: represents half the length of the rectangle located in the X-Y Plane.
    # * 
    # * @field semiBreadth: represents half the breadth of the rectangle located in the X-Y Plane.
    # *
    # * @field orientation: represents the optional orientation of the length of the rectangle, 
    # * measured with positive values turning around the Z-axis using the right-hand rule, starting from
    # * the X-axis. 
    # *
    # * @field height: represents the optional height, present if the shape is a right rectangular prism 
    # * with height extending in the positive Z-axis.
    # *
    # * @category GeoReference information
    # * @revision: created in V2.1.1, centerPoint renamed to shapeReferencePoint, the type of the field orientation changed and description revised in V2.2.1
    # 
    
    CartesianPosition3d shape_reference_point
    bool shape_reference_point_is_present
    
    StandardLength12b semi_length
    
    StandardLength12b semi_breadth
    
    CartesianAngleValue orientation
    bool orientation_is_present
    
    StandardLength12b height
    bool height_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/CartesianPosition3d
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianPosition3d::=SEQUENCE{
    #     xCoordinate    CartesianCoordinate,
    #     yCoordinate    CartesianCoordinate,
    #     zCoordinate    CartesianCoordinate OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents a  position in a two- or three-dimensional cartesian coordinate system.
    # *
    # * It shall include the following components: 
    # *
    # * @field xCoordinate: the X coordinate value.
    # *
    # * @field yCoordinate: the Y coordinate value.
    # *
    # * @field zCoordinate: the optional Z coordinate value.
    # * 
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1
    #
    
    CartesianCoordinate x_coordinate
    
    CartesianCoordinate y_coordinate
    
    CartesianCoordinate z_coordinate
    bool z_coordinate_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/CartesianCoordinate
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianCoordinate::= INTEGER{
    #     negativeOutOfRange (-32768),
    #     positiveOutOfRange (32767)
    # } (-32768..32767)
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents the value of a cartesian coordinate with a range of -327,68 metres to +327,66 metres.
    # *
    # * The value shall be set to:
    # * - `-32 768` if the longitudinal offset is out of range, i.e. less than or equal to -327,68 metres,
    # * - `n` (`n > -32 768` and `n < 32 767`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
    # * - `32 767` if the longitudinal offset is out of range, i.e. greater than + 327,66 metres.
    # *
    # * @unit 0,01 m
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    int16 value
    int16 MIN = -32768
    int16 MAX = 32767
    int16 NEGATIVE_OUT_OF_RANGE = -32768
    int16 POSITIVE_OUT_OF_RANGE = 32767
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/StandardLength12b
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # StandardLength12b::= INTEGER (0..4095)
    # ------------------------------------------------------------------------------
    # *
    # * The DE represents length as a measure of distance between points or as a dimension of an object or shape. 
    # *
    # * @unit: 0,1 metre
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    # 
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 4095
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/CartesianAngleValue
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianAngleValue ::= INTEGER {
    #     valueNotUsed (3600),
    #     unavailable  (3601)
    # } (0..3601)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE represents an angle value described in a local Cartesian coordinate system, per default counted positive in
    # * a right-hand local coordinate system from the abscissa.
    # *
    # * The value shall be set to: 
    # * - `n` (`n >= 0` and `n < 3600`) if the angle is equal to or less than n x 0,1 degrees, and greater than (n-1) x 0,1 degrees,
    # * - `3601` if the information is not available.
    # *
    # * The value 3600 shall not be used. 
    # * 
    # * @unit 0,1 degrees
    # * @category: Basic information
    # * @revision: Created in V2.1.1, description and value for 3601 corrected in V2.2.1
    #
    
    uint16 value
    uint16 MIN = 0
    uint16 MAX = 3601
    uint16 VALUE_NOT_USED = 3600
    uint16 UNAVAILABLE = 3601
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/CircularShape
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CircularShape ::= SEQUENCE {
    #     shapeReferencePoint    CartesianPosition3d OPTIONAL,
    #     radius                 StandardLength12b,
    #     height                 StandardLength12b OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * 
    # * This DF represents the shape of a circular area or a right cylinder that is centred on the shape's reference point. 
    # *
    # * It shall include the following components: 
    # * 
    # * @field shapeReferencePoint: optional reference point that represents the centre of the circle, relative to an externally specified reference position. 
    # * If this component is absent, the externally specified reference position represents the shape's reference point. 
    # *
    # * @field radius: the radius of the circular area.
    # *
    # * @field height: the optional height, present if the shape is a right cylinder extending in the positive z-axis. 
    # *
    # * 
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1
    # 
    
    CartesianPosition3d shape_reference_point
    bool shape_reference_point_is_present
    
    StandardLength12b radius
    
    StandardLength12b height
    bool height_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/PolygonalShape
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # PolygonalShape ::= SEQUENCE {
    #    shapeReferencePoint    CartesianPosition3d OPTIONAL,
    #    polygon                SequenceOfCartesianPosition3d (SIZE(3..16,...)),
    #    height                 StandardLength12b OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * This DF represents the shape of a polygonal area or of a right prism.
    # *
    # * It shall include the following components: 
    # *
    # * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position. 
    # * If this component is absent, the externally specified reference position represents the shape's reference point. 
    # *
    # * @field polygon: the polygonal area represented by a list of minimum `3` to maximum `16` @ref CartesianPosition3d.
    # * All nodes of the polygon shall be considered relative to the shape's reference point.
    # *
    # * @field height: the optional height, present if the shape is a right prism extending in the positive z-axis.
    # * 
    # * @category GeoReference information
    # * @revision: created in V2.1.1
    # *
    # 
    
    CartesianPosition3d shape_reference_point
    bool shape_reference_point_is_present
    
    SequenceOfCartesianPosition3d polygon
    int64 POLYGON_MIN_SIZE = 3
    int64 POLYGON_MAX_SIZE = 16
    
    StandardLength12b height
    bool height_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/SequenceOfCartesianPosition3d
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # SequenceOfCartesianPosition3d ::= SEQUENCE (SIZE(1..16, ...)) OF CartesianPosition3d
    # ------------------------------------------------------------------------------
    # * 
    # * This DF shall contain a list of DF @ref CartesianPosition3d.
    # * 
    # * @category: GeoReference information
    # * @revision: created in V2.1.1
    # 
    
    CartesianPosition3d[] array
    int64 MIN_SIZE = 1
    int64 MAX_SIZE = 16
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/EllipticalShape
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # EllipticalShape  ::= SEQUENCE {
    #     shapeReferencePoint    CartesianPosition3d OPTIONAL,
    #     semiMajorAxisLength    StandardLength12b,
    #     semiMinorAxisLength    StandardLength12b,
    #     orientation            CartesianAngleValue OPTIONAL,
    #     height                 StandardLength12b OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # * 
    # * 
    # * This DF represents the shape of an elliptical area or right elliptical cylinder that is centred 
    # * on the shape's reference point defined outside of the context of this DF and oriented w.r.t. a  
    # * cartesian coordinate system defined outside of the context of this DF. 
    # *
    # * It shall include the following components: 
    # * 
    # * @field shapeReferencePoint: optional reference point which represents the centre of the ellipse, 
    # * relative to an externally specified reference position. If this component is absent, the 
    # * externally specified reference position represents the shape's reference point. 
    # *
    # * @field semiMajorAxisLength: half length of the major axis of the ellipse located in the X-Y Plane.
    # * 
    # * @field semiMinorAxisLength: half length of the minor axis of the ellipse located in the X-Y Plane.
    # *
    # * @field orientation: the optional orientation of the major axis of the ellipse, measured with 
    # * positive values turning around the z-axis using the right-hand rule, starting from the X-axis. 
    # * 
    # * @field height: the optional height, present if the shape is a right elliptical cylinder extending 
    # * in the positive Z-axis.
    # *
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1, the type of the field orientation changed and the description revised in V2.2.1
    #
    
    CartesianPosition3d shape_reference_point
    bool shape_reference_point_is_present
    
    StandardLength12b semi_major_axis_length
    
    StandardLength12b semi_minor_axis_length
    
    CartesianAngleValue orientation
    bool orientation_is_present
    
    StandardLength12b height
    bool height_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/RadialShape
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RadialShape ::= SEQUENCE { 
    #     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
    #     range                                    StandardLength12b,
    #     horizontalOpeningAngleStart              CartesianAngleValue, 
    #     horizontalOpeningAngleEnd                CartesianAngleValue, 
    #     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
    #     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF describes a radial shape. The circular or spherical sector is constructed by sweeping      
    # * the provided range about the reference position specified outside of the context of this DF or 
    # * about the optional shapeReferencePoint. The range is swept between a horizontal start and a 
    # * horizontal end angle in the X-Y plane of a cartesian coordinate system specified outside of the 
    # * context of this DF, in a right-hand positive angular direction w.r.t. the x-axis. 
    # * A vertical opening angle in the X-Z plane may optionally be provided in a right-hand positive 
    # * angular direction w.r.t. the x-axis. 
    # *
    # * It shall include the following components:
    # * 
    # * @field shapeReferencePoint: the optional reference point used for the definition of the shape, 
    # * relative to an externally specified reference position. If this component is absent, the  
    # * externally specified reference position represents the shape's reference point. 
    # *
    # * @field range: the radial range of the shape from the shape's reference point. 
    # *
    # * @field horizontalOpeningAngleStart: the start of the shape's horizontal opening angle. 
    # *
    # * @field horizontalOpeningAngleEnd: the end of the shape's horizontal opening angle. 
    # *
    # * @field verticalOpeningAngleStart: optional start of the shape's vertical opening angle. 
    # *
    # * @field verticalOpeningAngleEnd: optional end of the shape's vertical opening angle. 
    # *
    # * @category GeoReference information
    # * @revision: created in V2.1.1, names and types of the horizontal opening angles changed, constraint added and description revised in V2.2.1
    #
    
    CartesianPosition3d shape_reference_point
    bool shape_reference_point_is_present
    
    StandardLength12b range
    
    CartesianAngleValue horizontal_opening_angle_start
    
    CartesianAngleValue horizontal_opening_angle_end
    
    CartesianAngleValue vertical_opening_angle_start
    bool vertical_opening_angle_start_is_present
    
    CartesianAngleValue vertical_opening_angle_end
    bool vertical_opening_angle_end_is_present
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/RadialShapes
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RadialShapes ::= SEQUENCE {
    #     refPointId          Identifier1B,
    #     xCoordinate         CartesianCoordinateSmall, 
    #     yCoordinate         CartesianCoordinateSmall,
    #     zCoordinate         CartesianCoordinateSmall OPTIONAL,
    #     radialShapesList    RadialShapesList
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF describes a list of radial shapes positioned w.r.t. to an offset position defined  
    # * relative to a reference position specified outside of the context of this DF and oriented w.r.t.  
    # * a cartesian coordinate system specified outside of the context of this DF. 
    # *
    # * It shall include the following components:
    # *
    # * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
    # * 
    # * @field xCoordinate: the x-coordinate of the offset position.
    # *
    # * @field yCoordinate: the y-coordinate of the offset position.
    # *
    # * @field zCoordinate: the optional z-coordinate of the offset position.
    # *
    # * @field radialShapesList: the list of radial shape details.
    # *
    # * @category: Georeference information
    # * @revision: created in V2.1.1, description revised in V2.2.1
    # 
    
    Identifier1B ref_point_id
    
    CartesianCoordinateSmall x_coordinate
    
    CartesianCoordinateSmall y_coordinate
    
    CartesianCoordinateSmall z_coordinate
    bool z_coordinate_is_present
    
    RadialShapesList radial_shapes_list
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/Identifier1B
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # Identifier1B ::= INTEGER (0..255)
    # ------------------------------------------------------------------------------
    # * 
    # * This DE is a general identifier.
    # * 
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    uint8 value
    uint8 MIN = 0
    uint8 MAX = 255
    
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/CartesianCoordinateSmall
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # CartesianCoordinateSmall::= INTEGER {
    #     negativeOutOfRange (-3094),
    #     positiveOutOfRange (1001)
    # } (-3094..1001) 
    # ------------------------------------------------------------------------------
    # *
    # * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.
    # *
    # * The value shall be set to:
    # * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,
    # * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,
    # * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.
    # *
    # * @unit 0,01 m
    # * @category: Basic information
    # * @revision: Created in V2.1.1
    #
    
    int16 value
    int16 MIN = -3094
    int16 MAX = 1001
    int16 NEGATIVE_OUT_OF_RANGE = -3094
    int16 POSITIVE_OUT_OF_RANGE = 1001
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/RadialShapesList
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RadialShapesList ::= SEQUENCE SIZE(1..16,...) OF RadialShapeDetails
    # ------------------------------------------------------------------------------
    # * 
    # * The DF contains a list of @ref RadialShapeDetails.
    # *
    # * @category: Georeference information
    # * @revision: created in V2.1.1
    # 
    
    RadialShapeDetails[] array
    int64 MIN_SIZE = 1
    int64 MAX_SIZE = 16
    
    ================================================================================
    MSG: etsi_its_cam_ts_msgs/RadialShapeDetails
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    # RadialShapeDetails ::= SEQUENCE {
    #     range                          StandardLength12b,
    #     horizontalOpeningAngleStart    CartesianAngleValue,
    #     horizontalOpeningAngleEnd      CartesianAngleValue,
    #     verticalOpeningAngleStart      CartesianAngleValue OPTIONAL,
    #     verticalOpeningAngleEnd        CartesianAngleValue OPTIONAL
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DF describes radial shape details. The circular sector or cone is
    # * constructed by sweeping the provided range about the position specified outside of the  
    # * context of this DF. The range is swept between a horizontal start and a horizontal end angle in 
    # * the X-Y plane of a right-hand cartesian coordinate system specified outside of the context of 
    # * this DF, in positive angular direction w.r.t. the x-axis. A vertical opening angle in the X-Z 
    # * plane may optionally be provided in positive angular direction w.r.t. the x-axis.
    # * 
    # * It shall include the following components:
    # * 
    # * @field range: the radial range of the sensor from the reference point or sensor point offset. 
    # *
    # * @field horizontalOpeningAngleStart:  the start of the shape's horizontal opening angle.
    # *
    # * @field horizontalOpeningAngleEnd: the end of the shape's horizontal opening angle. 
    # *
    # * @field verticalOpeningAngleStart: optional start of the shape's vertical opening angle. 
    # *
    # * @field verticalOpeningAngleEnd: optional end of the shape's vertical opening angle. 
    # *
    # * @category: Georeference information
    # * @revision: created in V2.1.1, description revised and constraint added in V2.2.1
    # 
    
    StandardLength12b range
    
    CartesianAngleValue horizontal_opening_angle_start
    
    CartesianAngleValue horizontal_opening_angle_end
    
    CartesianAngleValue vertical_opening_angle_start
    bool vertical_opening_angle_start_is_present
    
    CartesianAngleValue vertical_opening_angle_end
    bool vertical_opening_angle_end_is_present
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Shape(null);
    if (msg.choice !== undefined) {
      resolved.choice = msg.choice;
    }
    else {
      resolved.choice = 0
    }

    if (msg.rectangular !== undefined) {
      resolved.rectangular = RectangularShape.Resolve(msg.rectangular)
    }
    else {
      resolved.rectangular = new RectangularShape()
    }

    if (msg.circular !== undefined) {
      resolved.circular = CircularShape.Resolve(msg.circular)
    }
    else {
      resolved.circular = new CircularShape()
    }

    if (msg.polygonal !== undefined) {
      resolved.polygonal = PolygonalShape.Resolve(msg.polygonal)
    }
    else {
      resolved.polygonal = new PolygonalShape()
    }

    if (msg.elliptical !== undefined) {
      resolved.elliptical = EllipticalShape.Resolve(msg.elliptical)
    }
    else {
      resolved.elliptical = new EllipticalShape()
    }

    if (msg.radial !== undefined) {
      resolved.radial = RadialShape.Resolve(msg.radial)
    }
    else {
      resolved.radial = new RadialShape()
    }

    if (msg.radial_shapes !== undefined) {
      resolved.radial_shapes = RadialShapes.Resolve(msg.radial_shapes)
    }
    else {
      resolved.radial_shapes = new RadialShapes()
    }

    return resolved;
    }
};

// Constants for message
Shape.Constants = {
  CHOICE_RECTANGULAR: 0,
  CHOICE_CIRCULAR: 1,
  CHOICE_POLYGONAL: 2,
  CHOICE_ELLIPTICAL: 3,
  CHOICE_RADIAL: 4,
  CHOICE_RADIAL_SHAPES: 5,
}

module.exports = Shape;
