// Auto-generated. Do not edit!

// (in-package etsi_its_cam_ts_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class TrafficDirection {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.value = null;
    }
    else {
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type TrafficDirection
    // Serialize message field [value]
    bufferOffset = _serializer.uint8(obj.value, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type TrafficDirection
    let len;
    let data = new TrafficDirection(null);
    // Deserialize message field [value]
    data.value = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'etsi_its_cam_ts_msgs/TrafficDirection';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'e042dfa1bda8a9b2647d1faf40c3b1e9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ==============================================================================
    # MIT License
    #
    # Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
    # Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
    #
    # Permission is hereby granted, free of charge, to any person obtaining a copy
    # of this software and associated documentation files (the "Software"), to deal
    # in the Software without restriction, including without limitation the rights
    # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    # copies of the Software, and to permit persons to whom the Software is
    # furnished to do so, subject to the following conditions:
    #
    # The above copyright notice and this permission notice shall be included in all
    # copies or substantial portions of the Software.
    #
    # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    # SOFTWARE.
    # ==============================================================================
    
    # --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
    
    # --- ASN.1 Definition ---------------------------------------------------------
    #  TrafficDirection ::= ENUMERATED {
    #     allTrafficDirections(0), 
    #     sameAsReferenceDirection-upstreamOfReferencePosition(1), 
    #     sameAsReferenceDirection-downstreamOfReferencePosition(2), 
    #     oppositeToReferenceDirection(3)
    # }
    # ------------------------------------------------------------------------------
    # *
    # * This DE indicates a direction of traffic with respect to a reference direction, and a portion of that traffic with respect to a reference position.
    # * 
    # * The value shall be set to:
    # * - 0 `allTrafficDirections`                                    - for all directions of traffic, 
    # * - 1 `sameAsReferenceDirection-upstreamOfReferencePosition`    - for the direction of traffic according to the reference direction, and the portion of traffic upstream of the reference position, 
    # * - 2 `sameAsReferenceDirection-downstreamOfReferencePosition`  - for the direction of traffic according to the reference direction, and the portion of traffic downstream of the reference position, 
    # * - 3 `oppositeToReferenceDirection`                            - for the direction of traffic opposite to the reference direction. 
    # *
    # * @note: Upstream traffic corresponds to the incoming traffic towards the event position, and downstream traffic to the departing traffic away from the event position.
    # * @category: GeoReference information
    # * @revision: Created in V2.1.1 from RelevanceTrafficDirection, description and naming of values changed in V2.2.1
    # *
    # 
    
    uint8 value
    uint8 ALL_TRAFFIC_DIRECTIONS = 0
    uint8 SAME_AS_REFERENCE_DIRECTION_UPSTREAM_OF_REFERENCE_POSITION = 1
    uint8 SAME_AS_REFERENCE_DIRECTION_DOWNSTREAM_OF_REFERENCE_POSITION = 2
    uint8 OPPOSITE_TO_REFERENCE_DIRECTION = 3
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new TrafficDirection(null);
    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0
    }

    return resolved;
    }
};

// Constants for message
TrafficDirection.Constants = {
  ALL_TRAFFIC_DIRECTIONS: 0,
  SAME_AS_REFERENCE_DIRECTION_UPSTREAM_OF_REFERENCE_POSITION: 1,
  SAME_AS_REFERENCE_DIRECTION_DOWNSTREAM_OF_REFERENCE_POSITION: 2,
  OPPOSITE_TO_REFERENCE_DIRECTION: 3,
}

module.exports = TrafficDirection;
